/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: org/waveprotocol/wave/federation/federation.protodevel

package org.waveprotocol.wave.federation;

public final class Proto {
  private Proto() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public interface ProtocolWaveletDeltaOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // required .federation.ProtocolHashedVersion hashed_version = 1;
    /**
     * <code>required .federation.ProtocolHashedVersion hashed_version = 1;</code>
     *
     * <pre>
     * Wavelet version that the delta is intended to be applied to.
     * </pre>
     */
    boolean hasHashedVersion();
    /**
     * <code>required .federation.ProtocolHashedVersion hashed_version = 1;</code>
     *
     * <pre>
     * Wavelet version that the delta is intended to be applied to.
     * </pre>
     */
    org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion getHashedVersion();
    /**
     * <code>required .federation.ProtocolHashedVersion hashed_version = 1;</code>
     *
     * <pre>
     * Wavelet version that the delta is intended to be applied to.
     * </pre>
     */
    org.waveprotocol.wave.federation.Proto.ProtocolHashedVersionOrBuilder getHashedVersionOrBuilder();

    // required string author = 2;
    /**
     * <code>required string author = 2;</code>
     *
     * <pre>
     * Wave address of the contributor. Must be an explicit wavelet participant,
     * and may be different from the originator of this delta.
     * </pre>
     */
    boolean hasAuthor();
    /**
     * <code>required string author = 2;</code>
     *
     * <pre>
     * Wave address of the contributor. Must be an explicit wavelet participant,
     * and may be different from the originator of this delta.
     * </pre>
     */
    java.lang.String getAuthor();
    /**
     * <code>required string author = 2;</code>
     *
     * <pre>
     * Wave address of the contributor. Must be an explicit wavelet participant,
     * and may be different from the originator of this delta.
     * </pre>
     */
    com.google.protobuf.ByteString
        getAuthorBytes();

    // repeated .federation.ProtocolWaveletOperation operation = 3;
    /**
     * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
     *
     * <pre>
     * Operations included in this delta.
     * </pre>
     */
    java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation> 
        getOperationList();
    /**
     * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
     *
     * <pre>
     * Operations included in this delta.
     * </pre>
     */
    org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation getOperation(int index);
    /**
     * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
     *
     * <pre>
     * Operations included in this delta.
     * </pre>
     */
    int getOperationCount();
    /**
     * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
     *
     * <pre>
     * Operations included in this delta.
     * </pre>
     */
    java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperationOrBuilder> 
        getOperationOrBuilderList();
    /**
     * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
     *
     * <pre>
     * Operations included in this delta.
     * </pre>
     */
    org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperationOrBuilder getOperationOrBuilder(
        int index);

    // repeated string address_path = 4;
    /**
     * <code>repeated string address_path = 4;</code>
     *
     * <pre>
     *
     * The nodes on the "overt" path from the originator through the address
     * access graph leading up to (but excluding) the author. The path excludes
     * any initial segments of the complete path which come before a WRITE edge
     * in the graph. This field is empty if the author is either the originator's
     * entry point into the address graph or is accessed by a WRITE edge.
     *
     * For example, "wave-discuss@acmewave.com" may be the explicit participant of
     * a wavelet, and is set as the author of a delta. However, this group is
     * being asked to act on behalf of "peter@initech-corp.com", who is a member
     * of "wave-authors", which is in turn a member of "wave-discuss". In this
     * example, the delta would be configured as such:
     *  delta.author = "wave-discuss@acmewave.com"
     *  delta.addressPath = ["peter@initech-corp.com", "wave-authors@acmewave.com"]
     * </pre>
     */
    java.util.List<java.lang.String>
    getAddressPathList();
    /**
     * <code>repeated string address_path = 4;</code>
     *
     * <pre>
     *
     * The nodes on the "overt" path from the originator through the address
     * access graph leading up to (but excluding) the author. The path excludes
     * any initial segments of the complete path which come before a WRITE edge
     * in the graph. This field is empty if the author is either the originator's
     * entry point into the address graph or is accessed by a WRITE edge.
     *
     * For example, "wave-discuss@acmewave.com" may be the explicit participant of
     * a wavelet, and is set as the author of a delta. However, this group is
     * being asked to act on behalf of "peter@initech-corp.com", who is a member
     * of "wave-authors", which is in turn a member of "wave-discuss". In this
     * example, the delta would be configured as such:
     *  delta.author = "wave-discuss@acmewave.com"
     *  delta.addressPath = ["peter@initech-corp.com", "wave-authors@acmewave.com"]
     * </pre>
     */
    int getAddressPathCount();
    /**
     * <code>repeated string address_path = 4;</code>
     *
     * <pre>
     *
     * The nodes on the "overt" path from the originator through the address
     * access graph leading up to (but excluding) the author. The path excludes
     * any initial segments of the complete path which come before a WRITE edge
     * in the graph. This field is empty if the author is either the originator's
     * entry point into the address graph or is accessed by a WRITE edge.
     *
     * For example, "wave-discuss@acmewave.com" may be the explicit participant of
     * a wavelet, and is set as the author of a delta. However, this group is
     * being asked to act on behalf of "peter@initech-corp.com", who is a member
     * of "wave-authors", which is in turn a member of "wave-discuss". In this
     * example, the delta would be configured as such:
     *  delta.author = "wave-discuss@acmewave.com"
     *  delta.addressPath = ["peter@initech-corp.com", "wave-authors@acmewave.com"]
     * </pre>
     */
    java.lang.String getAddressPath(int index);
    /**
     * <code>repeated string address_path = 4;</code>
     *
     * <pre>
     *
     * The nodes on the "overt" path from the originator through the address
     * access graph leading up to (but excluding) the author. The path excludes
     * any initial segments of the complete path which come before a WRITE edge
     * in the graph. This field is empty if the author is either the originator's
     * entry point into the address graph or is accessed by a WRITE edge.
     *
     * For example, "wave-discuss@acmewave.com" may be the explicit participant of
     * a wavelet, and is set as the author of a delta. However, this group is
     * being asked to act on behalf of "peter@initech-corp.com", who is a member
     * of "wave-authors", which is in turn a member of "wave-discuss". In this
     * example, the delta would be configured as such:
     *  delta.author = "wave-discuss@acmewave.com"
     *  delta.addressPath = ["peter@initech-corp.com", "wave-authors@acmewave.com"]
     * </pre>
     */
    com.google.protobuf.ByteString
        getAddressPathBytes(int index);
  }
  /**
   * Protobuf type {@code federation.ProtocolWaveletDelta}
   *
   * <pre>
   **
   * An immutable list of operations for contribution to a wavelet.
   * Specifies the contributor and the wavelet version that the
   * operations are intended to be applied to.  The host wave server
   * may apply the operations to the wavelet at the specified wavelet version
   * or it may accept them at a later version after operational transformation
   * against the operations at the intermediate wavelet versions.
   * </pre>
   */
  public static final class ProtocolWaveletDelta extends
      com.google.protobuf.GeneratedMessage
      implements ProtocolWaveletDeltaOrBuilder {
    // Use ProtocolWaveletDelta.newBuilder() to construct.
    private ProtocolWaveletDelta(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private ProtocolWaveletDelta(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final ProtocolWaveletDelta defaultInstance;
    public static ProtocolWaveletDelta getDefaultInstance() {
      return defaultInstance;
    }

    public ProtocolWaveletDelta getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private ProtocolWaveletDelta(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.Builder subBuilder = null;
              if (((bitField0_ & 0x00000001) == 0x00000001)) {
                subBuilder = hashedVersion_.toBuilder();
              }
              hashedVersion_ = input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(hashedVersion_);
                hashedVersion_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000001;
              break;
            }
            case 18: {
              bitField0_ |= 0x00000002;
              author_ = input.readBytes();
              break;
            }
            case 26: {
              if (!((mutable_bitField0_ & 0x00000004) == 0x00000004)) {
                operation_ = new java.util.ArrayList<org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation>();
                mutable_bitField0_ |= 0x00000004;
              }
              operation_.add(input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.PARSER, extensionRegistry));
              break;
            }
            case 34: {
              if (!((mutable_bitField0_ & 0x00000008) == 0x00000008)) {
                addressPath_ = new com.google.protobuf.LazyStringArrayList();
                mutable_bitField0_ |= 0x00000008;
              }
              addressPath_.add(input.readBytes());
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000004) == 0x00000004)) {
          operation_ = java.util.Collections.unmodifiableList(operation_);
        }
        if (((mutable_bitField0_ & 0x00000008) == 0x00000008)) {
          addressPath_ = new com.google.protobuf.UnmodifiableLazyStringList(addressPath_);
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolWaveletDelta_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolWaveletDelta_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta.class, org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta.Builder.class);
    }

    public static com.google.protobuf.Parser<ProtocolWaveletDelta> PARSER =
        new com.google.protobuf.AbstractParser<ProtocolWaveletDelta>() {
      public ProtocolWaveletDelta parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new ProtocolWaveletDelta(input, extensionRegistry);
      }
    };

    @java.lang.Override
    public com.google.protobuf.Parser<ProtocolWaveletDelta> getParserForType() {
      return PARSER;
    }

    private int bitField0_;
    // required .federation.ProtocolHashedVersion hashed_version = 1;
    public static final int HASHED_VERSION_FIELD_NUMBER = 1;
    private org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion hashedVersion_;
    /**
     * <code>required .federation.ProtocolHashedVersion hashed_version = 1;</code>
     *
     * <pre>
     * Wavelet version that the delta is intended to be applied to.
     * </pre>
     */
    public boolean hasHashedVersion() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>required .federation.ProtocolHashedVersion hashed_version = 1;</code>
     *
     * <pre>
     * Wavelet version that the delta is intended to be applied to.
     * </pre>
     */
    public org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion getHashedVersion() {
      return hashedVersion_;
    }
    /**
     * <code>required .federation.ProtocolHashedVersion hashed_version = 1;</code>
     *
     * <pre>
     * Wavelet version that the delta is intended to be applied to.
     * </pre>
     */
    public org.waveprotocol.wave.federation.Proto.ProtocolHashedVersionOrBuilder getHashedVersionOrBuilder() {
      return hashedVersion_;
    }

    // required string author = 2;
    public static final int AUTHOR_FIELD_NUMBER = 2;
    private java.lang.Object author_;
    /**
     * <code>required string author = 2;</code>
     *
     * <pre>
     * Wave address of the contributor. Must be an explicit wavelet participant,
     * and may be different from the originator of this delta.
     * </pre>
     */
    public boolean hasAuthor() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    /**
     * <code>required string author = 2;</code>
     *
     * <pre>
     * Wave address of the contributor. Must be an explicit wavelet participant,
     * and may be different from the originator of this delta.
     * </pre>
     */
    public java.lang.String getAuthor() {
      java.lang.Object ref = author_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          author_ = s;
        }
        return s;
      }
    }
    /**
     * <code>required string author = 2;</code>
     *
     * <pre>
     * Wave address of the contributor. Must be an explicit wavelet participant,
     * and may be different from the originator of this delta.
     * </pre>
     */
    public com.google.protobuf.ByteString
        getAuthorBytes() {
      java.lang.Object ref = author_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        author_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // repeated .federation.ProtocolWaveletOperation operation = 3;
    public static final int OPERATION_FIELD_NUMBER = 3;
    private java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation> operation_;
    /**
     * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
     *
     * <pre>
     * Operations included in this delta.
     * </pre>
     */
    public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation> getOperationList() {
      return operation_;
    }
    /**
     * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
     *
     * <pre>
     * Operations included in this delta.
     * </pre>
     */
    public java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperationOrBuilder> 
        getOperationOrBuilderList() {
      return operation_;
    }
    /**
     * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
     *
     * <pre>
     * Operations included in this delta.
     * </pre>
     */
    public int getOperationCount() {
      return operation_.size();
    }
    /**
     * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
     *
     * <pre>
     * Operations included in this delta.
     * </pre>
     */
    public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation getOperation(int index) {
      return operation_.get(index);
    }
    /**
     * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
     *
     * <pre>
     * Operations included in this delta.
     * </pre>
     */
    public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperationOrBuilder getOperationOrBuilder(
        int index) {
      return operation_.get(index);
    }

    // repeated string address_path = 4;
    public static final int ADDRESS_PATH_FIELD_NUMBER = 4;
    private com.google.protobuf.LazyStringList addressPath_;
    /**
     * <code>repeated string address_path = 4;</code>
     *
     * <pre>
     *
     * The nodes on the "overt" path from the originator through the address
     * access graph leading up to (but excluding) the author. The path excludes
     * any initial segments of the complete path which come before a WRITE edge
     * in the graph. This field is empty if the author is either the originator's
     * entry point into the address graph or is accessed by a WRITE edge.
     *
     * For example, "wave-discuss@acmewave.com" may be the explicit participant of
     * a wavelet, and is set as the author of a delta. However, this group is
     * being asked to act on behalf of "peter@initech-corp.com", who is a member
     * of "wave-authors", which is in turn a member of "wave-discuss". In this
     * example, the delta would be configured as such:
     *  delta.author = "wave-discuss@acmewave.com"
     *  delta.addressPath = ["peter@initech-corp.com", "wave-authors@acmewave.com"]
     * </pre>
     */
    public java.util.List<java.lang.String>
        getAddressPathList() {
      return addressPath_;
    }
    /**
     * <code>repeated string address_path = 4;</code>
     *
     * <pre>
     *
     * The nodes on the "overt" path from the originator through the address
     * access graph leading up to (but excluding) the author. The path excludes
     * any initial segments of the complete path which come before a WRITE edge
     * in the graph. This field is empty if the author is either the originator's
     * entry point into the address graph or is accessed by a WRITE edge.
     *
     * For example, "wave-discuss@acmewave.com" may be the explicit participant of
     * a wavelet, and is set as the author of a delta. However, this group is
     * being asked to act on behalf of "peter@initech-corp.com", who is a member
     * of "wave-authors", which is in turn a member of "wave-discuss". In this
     * example, the delta would be configured as such:
     *  delta.author = "wave-discuss@acmewave.com"
     *  delta.addressPath = ["peter@initech-corp.com", "wave-authors@acmewave.com"]
     * </pre>
     */
    public int getAddressPathCount() {
      return addressPath_.size();
    }
    /**
     * <code>repeated string address_path = 4;</code>
     *
     * <pre>
     *
     * The nodes on the "overt" path from the originator through the address
     * access graph leading up to (but excluding) the author. The path excludes
     * any initial segments of the complete path which come before a WRITE edge
     * in the graph. This field is empty if the author is either the originator's
     * entry point into the address graph or is accessed by a WRITE edge.
     *
     * For example, "wave-discuss@acmewave.com" may be the explicit participant of
     * a wavelet, and is set as the author of a delta. However, this group is
     * being asked to act on behalf of "peter@initech-corp.com", who is a member
     * of "wave-authors", which is in turn a member of "wave-discuss". In this
     * example, the delta would be configured as such:
     *  delta.author = "wave-discuss@acmewave.com"
     *  delta.addressPath = ["peter@initech-corp.com", "wave-authors@acmewave.com"]
     * </pre>
     */
    public java.lang.String getAddressPath(int index) {
      return addressPath_.get(index);
    }
    /**
     * <code>repeated string address_path = 4;</code>
     *
     * <pre>
     *
     * The nodes on the "overt" path from the originator through the address
     * access graph leading up to (but excluding) the author. The path excludes
     * any initial segments of the complete path which come before a WRITE edge
     * in the graph. This field is empty if the author is either the originator's
     * entry point into the address graph or is accessed by a WRITE edge.
     *
     * For example, "wave-discuss@acmewave.com" may be the explicit participant of
     * a wavelet, and is set as the author of a delta. However, this group is
     * being asked to act on behalf of "peter@initech-corp.com", who is a member
     * of "wave-authors", which is in turn a member of "wave-discuss". In this
     * example, the delta would be configured as such:
     *  delta.author = "wave-discuss@acmewave.com"
     *  delta.addressPath = ["peter@initech-corp.com", "wave-authors@acmewave.com"]
     * </pre>
     */
    public com.google.protobuf.ByteString
        getAddressPathBytes(int index) {
      return addressPath_.getByteString(index);
    }

    private void initFields() {
      hashedVersion_ = org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.getDefaultInstance();
      author_ = "";
      operation_ = java.util.Collections.emptyList();
      addressPath_ = com.google.protobuf.LazyStringArrayList.EMPTY;
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      if (!hasHashedVersion()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasAuthor()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!getHashedVersion().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      for (int i = 0; i < getOperationCount(); i++) {
        if (!getOperation(i).isInitialized()) {
          memoizedIsInitialized = 0;
          return false;
        }
      }
      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeMessage(1, hashedVersion_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeBytes(2, getAuthorBytes());
      }
      for (int i = 0; i < operation_.size(); i++) {
        output.writeMessage(3, operation_.get(i));
      }
      for (int i = 0; i < addressPath_.size(); i++) {
        output.writeBytes(4, addressPath_.getByteString(i));
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(1, hashedVersion_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(2, getAuthorBytes());
      }
      for (int i = 0; i < operation_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(3, operation_.get(i));
      }
      {
        int dataSize = 0;
        for (int i = 0; i < addressPath_.size(); i++) {
          dataSize += com.google.protobuf.CodedOutputStream
            .computeBytesSizeNoTag(addressPath_.getByteString(i));
        }
        size += dataSize;
        size += 1 * getAddressPathList().size();
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code federation.ProtocolWaveletDelta}
     *
     * <pre>
     **
     * An immutable list of operations for contribution to a wavelet.
     * Specifies the contributor and the wavelet version that the
     * operations are intended to be applied to.  The host wave server
     * may apply the operations to the wavelet at the specified wavelet version
     * or it may accept them at a later version after operational transformation
     * against the operations at the intermediate wavelet versions.
     * </pre>
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements org.waveprotocol.wave.federation.Proto.ProtocolWaveletDeltaOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolWaveletDelta_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolWaveletDelta_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta.class, org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta.Builder.class);
      }

      // Construct using org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
          getHashedVersionFieldBuilder();
          getOperationFieldBuilder();
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        if (hashedVersionBuilder_ == null) {
          hashedVersion_ = org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.getDefaultInstance();
        } else {
          hashedVersionBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        author_ = "";
        bitField0_ = (bitField0_ & ~0x00000002);
        if (operationBuilder_ == null) {
          operation_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000004);
        } else {
          operationBuilder_.clear();
        }
        addressPath_ = com.google.protobuf.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000008);
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolWaveletDelta_descriptor;
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta getDefaultInstanceForType() {
        return org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta.getDefaultInstance();
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta build() {
        org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta buildPartial() {
        org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta result = new org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        if (hashedVersionBuilder_ == null) {
          result.hashedVersion_ = hashedVersion_;
        } else {
          result.hashedVersion_ = hashedVersionBuilder_.build();
        }
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.author_ = author_;
        if (operationBuilder_ == null) {
          if (((bitField0_ & 0x00000004) == 0x00000004)) {
            operation_ = java.util.Collections.unmodifiableList(operation_);
            bitField0_ = (bitField0_ & ~0x00000004);
          }
          result.operation_ = operation_;
        } else {
          result.operation_ = operationBuilder_.build();
        }
        if (((bitField0_ & 0x00000008) == 0x00000008)) {
          addressPath_ = new com.google.protobuf.UnmodifiableLazyStringList(
              addressPath_);
          bitField0_ = (bitField0_ & ~0x00000008);
        }
        result.addressPath_ = addressPath_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta) {
          return mergeFrom((org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta other) {
        if (other == org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta.getDefaultInstance()) return this;
        if (other.hasHashedVersion()) {
          mergeHashedVersion(other.getHashedVersion());
        }
        if (other.hasAuthor()) {
          bitField0_ |= 0x00000002;
          author_ = other.author_;
          onChanged();
        }
        if (operationBuilder_ == null) {
          if (!other.operation_.isEmpty()) {
            if (operation_.isEmpty()) {
              operation_ = other.operation_;
              bitField0_ = (bitField0_ & ~0x00000004);
            } else {
              ensureOperationIsMutable();
              operation_.addAll(other.operation_);
            }
            onChanged();
          }
        } else {
          if (!other.operation_.isEmpty()) {
            if (operationBuilder_.isEmpty()) {
              operationBuilder_.dispose();
              operationBuilder_ = null;
              operation_ = other.operation_;
              bitField0_ = (bitField0_ & ~0x00000004);
              operationBuilder_ = 
                com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                   getOperationFieldBuilder() : null;
            } else {
              operationBuilder_.addAllMessages(other.operation_);
            }
          }
        }
        if (!other.addressPath_.isEmpty()) {
          if (addressPath_.isEmpty()) {
            addressPath_ = other.addressPath_;
            bitField0_ = (bitField0_ & ~0x00000008);
          } else {
            ensureAddressPathIsMutable();
            addressPath_.addAll(other.addressPath_);
          }
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        if (!hasHashedVersion()) {
          
          return false;
        }
        if (!hasAuthor()) {
          
          return false;
        }
        if (!getHashedVersion().isInitialized()) {
          
          return false;
        }
        for (int i = 0; i < getOperationCount(); i++) {
          if (!getOperation(i).isInitialized()) {
            
            return false;
          }
        }
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.waveprotocol.wave.federation.Proto.ProtocolWaveletDelta) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // required .federation.ProtocolHashedVersion hashed_version = 1;
      private org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion hashedVersion_ = org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.getDefaultInstance();
      private com.google.protobuf.SingleFieldBuilder<
          org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion, org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.Builder, org.waveprotocol.wave.federation.Proto.ProtocolHashedVersionOrBuilder> hashedVersionBuilder_;
      /**
       * <code>required .federation.ProtocolHashedVersion hashed_version = 1;</code>
       *
       * <pre>
       * Wavelet version that the delta is intended to be applied to.
       * </pre>
       */
      public boolean hasHashedVersion() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>required .federation.ProtocolHashedVersion hashed_version = 1;</code>
       *
       * <pre>
       * Wavelet version that the delta is intended to be applied to.
       * </pre>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion getHashedVersion() {
        if (hashedVersionBuilder_ == null) {
          return hashedVersion_;
        } else {
          return hashedVersionBuilder_.getMessage();
        }
      }
      /**
       * <code>required .federation.ProtocolHashedVersion hashed_version = 1;</code>
       *
       * <pre>
       * Wavelet version that the delta is intended to be applied to.
       * </pre>
       */
      public Builder setHashedVersion(org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion value) {
        if (hashedVersionBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          hashedVersion_ = value;
          onChanged();
        } else {
          hashedVersionBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .federation.ProtocolHashedVersion hashed_version = 1;</code>
       *
       * <pre>
       * Wavelet version that the delta is intended to be applied to.
       * </pre>
       */
      public Builder setHashedVersion(
          org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.Builder builderForValue) {
        if (hashedVersionBuilder_ == null) {
          hashedVersion_ = builderForValue.build();
          onChanged();
        } else {
          hashedVersionBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .federation.ProtocolHashedVersion hashed_version = 1;</code>
       *
       * <pre>
       * Wavelet version that the delta is intended to be applied to.
       * </pre>
       */
      public Builder mergeHashedVersion(org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion value) {
        if (hashedVersionBuilder_ == null) {
          if (((bitField0_ & 0x00000001) == 0x00000001) &&
              hashedVersion_ != org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.getDefaultInstance()) {
            hashedVersion_ =
              org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.newBuilder(hashedVersion_).mergeFrom(value).buildPartial();
          } else {
            hashedVersion_ = value;
          }
          onChanged();
        } else {
          hashedVersionBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .federation.ProtocolHashedVersion hashed_version = 1;</code>
       *
       * <pre>
       * Wavelet version that the delta is intended to be applied to.
       * </pre>
       */
      public Builder clearHashedVersion() {
        if (hashedVersionBuilder_ == null) {
          hashedVersion_ = org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.getDefaultInstance();
          onChanged();
        } else {
          hashedVersionBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        return this;
      }
      /**
       * <code>required .federation.ProtocolHashedVersion hashed_version = 1;</code>
       *
       * <pre>
       * Wavelet version that the delta is intended to be applied to.
       * </pre>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.Builder getHashedVersionBuilder() {
        bitField0_ |= 0x00000001;
        onChanged();
        return getHashedVersionFieldBuilder().getBuilder();
      }
      /**
       * <code>required .federation.ProtocolHashedVersion hashed_version = 1;</code>
       *
       * <pre>
       * Wavelet version that the delta is intended to be applied to.
       * </pre>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolHashedVersionOrBuilder getHashedVersionOrBuilder() {
        if (hashedVersionBuilder_ != null) {
          return hashedVersionBuilder_.getMessageOrBuilder();
        } else {
          return hashedVersion_;
        }
      }
      /**
       * <code>required .federation.ProtocolHashedVersion hashed_version = 1;</code>
       *
       * <pre>
       * Wavelet version that the delta is intended to be applied to.
       * </pre>
       */
      private com.google.protobuf.SingleFieldBuilder<
          org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion, org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.Builder, org.waveprotocol.wave.federation.Proto.ProtocolHashedVersionOrBuilder> 
          getHashedVersionFieldBuilder() {
        if (hashedVersionBuilder_ == null) {
          hashedVersionBuilder_ = new com.google.protobuf.SingleFieldBuilder<
              org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion, org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.Builder, org.waveprotocol.wave.federation.Proto.ProtocolHashedVersionOrBuilder>(
                  hashedVersion_,
                  getParentForChildren(),
                  isClean());
          hashedVersion_ = null;
        }
        return hashedVersionBuilder_;
      }

      // required string author = 2;
      private java.lang.Object author_ = "";
      /**
       * <code>required string author = 2;</code>
       *
       * <pre>
       * Wave address of the contributor. Must be an explicit wavelet participant,
       * and may be different from the originator of this delta.
       * </pre>
       */
      public boolean hasAuthor() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      /**
       * <code>required string author = 2;</code>
       *
       * <pre>
       * Wave address of the contributor. Must be an explicit wavelet participant,
       * and may be different from the originator of this delta.
       * </pre>
       */
      public java.lang.String getAuthor() {
        java.lang.Object ref = author_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          author_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>required string author = 2;</code>
       *
       * <pre>
       * Wave address of the contributor. Must be an explicit wavelet participant,
       * and may be different from the originator of this delta.
       * </pre>
       */
      public com.google.protobuf.ByteString
          getAuthorBytes() {
        java.lang.Object ref = author_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          author_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>required string author = 2;</code>
       *
       * <pre>
       * Wave address of the contributor. Must be an explicit wavelet participant,
       * and may be different from the originator of this delta.
       * </pre>
       */
      public Builder setAuthor(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        author_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required string author = 2;</code>
       *
       * <pre>
       * Wave address of the contributor. Must be an explicit wavelet participant,
       * and may be different from the originator of this delta.
       * </pre>
       */
      public Builder clearAuthor() {
        bitField0_ = (bitField0_ & ~0x00000002);
        author_ = getDefaultInstance().getAuthor();
        onChanged();
        return this;
      }
      /**
       * <code>required string author = 2;</code>
       *
       * <pre>
       * Wave address of the contributor. Must be an explicit wavelet participant,
       * and may be different from the originator of this delta.
       * </pre>
       */
      public Builder setAuthorBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        author_ = value;
        onChanged();
        return this;
      }

      // repeated .federation.ProtocolWaveletOperation operation = 3;
      private java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation> operation_ =
        java.util.Collections.emptyList();
      private void ensureOperationIsMutable() {
        if (!((bitField0_ & 0x00000004) == 0x00000004)) {
          operation_ = new java.util.ArrayList<org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation>(operation_);
          bitField0_ |= 0x00000004;
         }
      }

      private com.google.protobuf.RepeatedFieldBuilder<
          org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.Builder, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperationOrBuilder> operationBuilder_;

      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation> getOperationList() {
        if (operationBuilder_ == null) {
          return java.util.Collections.unmodifiableList(operation_);
        } else {
          return operationBuilder_.getMessageList();
        }
      }
      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public int getOperationCount() {
        if (operationBuilder_ == null) {
          return operation_.size();
        } else {
          return operationBuilder_.getCount();
        }
      }
      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation getOperation(int index) {
        if (operationBuilder_ == null) {
          return operation_.get(index);
        } else {
          return operationBuilder_.getMessage(index);
        }
      }
      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public Builder setOperation(
          int index, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation value) {
        if (operationBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureOperationIsMutable();
          operation_.set(index, value);
          onChanged();
        } else {
          operationBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public Builder setOperation(
          int index, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.Builder builderForValue) {
        if (operationBuilder_ == null) {
          ensureOperationIsMutable();
          operation_.set(index, builderForValue.build());
          onChanged();
        } else {
          operationBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public Builder addOperation(org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation value) {
        if (operationBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureOperationIsMutable();
          operation_.add(value);
          onChanged();
        } else {
          operationBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public Builder addOperation(
          int index, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation value) {
        if (operationBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureOperationIsMutable();
          operation_.add(index, value);
          onChanged();
        } else {
          operationBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public Builder addOperation(
          org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.Builder builderForValue) {
        if (operationBuilder_ == null) {
          ensureOperationIsMutable();
          operation_.add(builderForValue.build());
          onChanged();
        } else {
          operationBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public Builder addOperation(
          int index, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.Builder builderForValue) {
        if (operationBuilder_ == null) {
          ensureOperationIsMutable();
          operation_.add(index, builderForValue.build());
          onChanged();
        } else {
          operationBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public Builder addAllOperation(
          java.lang.Iterable<? extends org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation> values) {
        if (operationBuilder_ == null) {
          ensureOperationIsMutable();
          super.addAll(values, operation_);
          onChanged();
        } else {
          operationBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public Builder clearOperation() {
        if (operationBuilder_ == null) {
          operation_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000004);
          onChanged();
        } else {
          operationBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public Builder removeOperation(int index) {
        if (operationBuilder_ == null) {
          ensureOperationIsMutable();
          operation_.remove(index);
          onChanged();
        } else {
          operationBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.Builder getOperationBuilder(
          int index) {
        return getOperationFieldBuilder().getBuilder(index);
      }
      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperationOrBuilder getOperationOrBuilder(
          int index) {
        if (operationBuilder_ == null) {
          return operation_.get(index);  } else {
          return operationBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperationOrBuilder> 
           getOperationOrBuilderList() {
        if (operationBuilder_ != null) {
          return operationBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(operation_);
        }
      }
      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.Builder addOperationBuilder() {
        return getOperationFieldBuilder().addBuilder(
            org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.getDefaultInstance());
      }
      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.Builder addOperationBuilder(
          int index) {
        return getOperationFieldBuilder().addBuilder(
            index, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.getDefaultInstance());
      }
      /**
       * <code>repeated .federation.ProtocolWaveletOperation operation = 3;</code>
       *
       * <pre>
       * Operations included in this delta.
       * </pre>
       */
      public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.Builder> 
           getOperationBuilderList() {
        return getOperationFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilder<
          org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.Builder, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperationOrBuilder> 
          getOperationFieldBuilder() {
        if (operationBuilder_ == null) {
          operationBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
              org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.Builder, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperationOrBuilder>(
                  operation_,
                  ((bitField0_ & 0x00000004) == 0x00000004),
                  getParentForChildren(),
                  isClean());
          operation_ = null;
        }
        return operationBuilder_;
      }

      // repeated string address_path = 4;
      private com.google.protobuf.LazyStringList addressPath_ = com.google.protobuf.LazyStringArrayList.EMPTY;
      private void ensureAddressPathIsMutable() {
        if (!((bitField0_ & 0x00000008) == 0x00000008)) {
          addressPath_ = new com.google.protobuf.LazyStringArrayList(addressPath_);
          bitField0_ |= 0x00000008;
         }
      }
      /**
       * <code>repeated string address_path = 4;</code>
       *
       * <pre>
       *
       * The nodes on the "overt" path from the originator through the address
       * access graph leading up to (but excluding) the author. The path excludes
       * any initial segments of the complete path which come before a WRITE edge
       * in the graph. This field is empty if the author is either the originator's
       * entry point into the address graph or is accessed by a WRITE edge.
       *
       * For example, "wave-discuss@acmewave.com" may be the explicit participant of
       * a wavelet, and is set as the author of a delta. However, this group is
       * being asked to act on behalf of "peter@initech-corp.com", who is a member
       * of "wave-authors", which is in turn a member of "wave-discuss". In this
       * example, the delta would be configured as such:
       *  delta.author = "wave-discuss@acmewave.com"
       *  delta.addressPath = ["peter@initech-corp.com", "wave-authors@acmewave.com"]
       * </pre>
       */
      public java.util.List<java.lang.String>
          getAddressPathList() {
        return java.util.Collections.unmodifiableList(addressPath_);
      }
      /**
       * <code>repeated string address_path = 4;</code>
       *
       * <pre>
       *
       * The nodes on the "overt" path from the originator through the address
       * access graph leading up to (but excluding) the author. The path excludes
       * any initial segments of the complete path which come before a WRITE edge
       * in the graph. This field is empty if the author is either the originator's
       * entry point into the address graph or is accessed by a WRITE edge.
       *
       * For example, "wave-discuss@acmewave.com" may be the explicit participant of
       * a wavelet, and is set as the author of a delta. However, this group is
       * being asked to act on behalf of "peter@initech-corp.com", who is a member
       * of "wave-authors", which is in turn a member of "wave-discuss". In this
       * example, the delta would be configured as such:
       *  delta.author = "wave-discuss@acmewave.com"
       *  delta.addressPath = ["peter@initech-corp.com", "wave-authors@acmewave.com"]
       * </pre>
       */
      public int getAddressPathCount() {
        return addressPath_.size();
      }
      /**
       * <code>repeated string address_path = 4;</code>
       *
       * <pre>
       *
       * The nodes on the "overt" path from the originator through the address
       * access graph leading up to (but excluding) the author. The path excludes
       * any initial segments of the complete path which come before a WRITE edge
       * in the graph. This field is empty if the author is either the originator's
       * entry point into the address graph or is accessed by a WRITE edge.
       *
       * For example, "wave-discuss@acmewave.com" may be the explicit participant of
       * a wavelet, and is set as the author of a delta. However, this group is
       * being asked to act on behalf of "peter@initech-corp.com", who is a member
       * of "wave-authors", which is in turn a member of "wave-discuss". In this
       * example, the delta would be configured as such:
       *  delta.author = "wave-discuss@acmewave.com"
       *  delta.addressPath = ["peter@initech-corp.com", "wave-authors@acmewave.com"]
       * </pre>
       */
      public java.lang.String getAddressPath(int index) {
        return addressPath_.get(index);
      }
      /**
       * <code>repeated string address_path = 4;</code>
       *
       * <pre>
       *
       * The nodes on the "overt" path from the originator through the address
       * access graph leading up to (but excluding) the author. The path excludes
       * any initial segments of the complete path which come before a WRITE edge
       * in the graph. This field is empty if the author is either the originator's
       * entry point into the address graph or is accessed by a WRITE edge.
       *
       * For example, "wave-discuss@acmewave.com" may be the explicit participant of
       * a wavelet, and is set as the author of a delta. However, this group is
       * being asked to act on behalf of "peter@initech-corp.com", who is a member
       * of "wave-authors", which is in turn a member of "wave-discuss". In this
       * example, the delta would be configured as such:
       *  delta.author = "wave-discuss@acmewave.com"
       *  delta.addressPath = ["peter@initech-corp.com", "wave-authors@acmewave.com"]
       * </pre>
       */
      public com.google.protobuf.ByteString
          getAddressPathBytes(int index) {
        return addressPath_.getByteString(index);
      }
      /**
       * <code>repeated string address_path = 4;</code>
       *
       * <pre>
       *
       * The nodes on the "overt" path from the originator through the address
       * access graph leading up to (but excluding) the author. The path excludes
       * any initial segments of the complete path which come before a WRITE edge
       * in the graph. This field is empty if the author is either the originator's
       * entry point into the address graph or is accessed by a WRITE edge.
       *
       * For example, "wave-discuss@acmewave.com" may be the explicit participant of
       * a wavelet, and is set as the author of a delta. However, this group is
       * being asked to act on behalf of "peter@initech-corp.com", who is a member
       * of "wave-authors", which is in turn a member of "wave-discuss". In this
       * example, the delta would be configured as such:
       *  delta.author = "wave-discuss@acmewave.com"
       *  delta.addressPath = ["peter@initech-corp.com", "wave-authors@acmewave.com"]
       * </pre>
       */
      public Builder setAddressPath(
          int index, java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureAddressPathIsMutable();
        addressPath_.set(index, value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string address_path = 4;</code>
       *
       * <pre>
       *
       * The nodes on the "overt" path from the originator through the address
       * access graph leading up to (but excluding) the author. The path excludes
       * any initial segments of the complete path which come before a WRITE edge
       * in the graph. This field is empty if the author is either the originator's
       * entry point into the address graph or is accessed by a WRITE edge.
       *
       * For example, "wave-discuss@acmewave.com" may be the explicit participant of
       * a wavelet, and is set as the author of a delta. However, this group is
       * being asked to act on behalf of "peter@initech-corp.com", who is a member
       * of "wave-authors", which is in turn a member of "wave-discuss". In this
       * example, the delta would be configured as such:
       *  delta.author = "wave-discuss@acmewave.com"
       *  delta.addressPath = ["peter@initech-corp.com", "wave-authors@acmewave.com"]
       * </pre>
       */
      public Builder addAddressPath(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureAddressPathIsMutable();
        addressPath_.add(value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string address_path = 4;</code>
       *
       * <pre>
       *
       * The nodes on the "overt" path from the originator through the address
       * access graph leading up to (but excluding) the author. The path excludes
       * any initial segments of the complete path which come before a WRITE edge
       * in the graph. This field is empty if the author is either the originator's
       * entry point into the address graph or is accessed by a WRITE edge.
       *
       * For example, "wave-discuss@acmewave.com" may be the explicit participant of
       * a wavelet, and is set as the author of a delta. However, this group is
       * being asked to act on behalf of "peter@initech-corp.com", who is a member
       * of "wave-authors", which is in turn a member of "wave-discuss". In this
       * example, the delta would be configured as such:
       *  delta.author = "wave-discuss@acmewave.com"
       *  delta.addressPath = ["peter@initech-corp.com", "wave-authors@acmewave.com"]
       * </pre>
       */
      public Builder addAllAddressPath(
          java.lang.Iterable<java.lang.String> values) {
        ensureAddressPathIsMutable();
        super.addAll(values, addressPath_);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string address_path = 4;</code>
       *
       * <pre>
       *
       * The nodes on the "overt" path from the originator through the address
       * access graph leading up to (but excluding) the author. The path excludes
       * any initial segments of the complete path which come before a WRITE edge
       * in the graph. This field is empty if the author is either the originator's
       * entry point into the address graph or is accessed by a WRITE edge.
       *
       * For example, "wave-discuss@acmewave.com" may be the explicit participant of
       * a wavelet, and is set as the author of a delta. However, this group is
       * being asked to act on behalf of "peter@initech-corp.com", who is a member
       * of "wave-authors", which is in turn a member of "wave-discuss". In this
       * example, the delta would be configured as such:
       *  delta.author = "wave-discuss@acmewave.com"
       *  delta.addressPath = ["peter@initech-corp.com", "wave-authors@acmewave.com"]
       * </pre>
       */
      public Builder clearAddressPath() {
        addressPath_ = com.google.protobuf.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000008);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string address_path = 4;</code>
       *
       * <pre>
       *
       * The nodes on the "overt" path from the originator through the address
       * access graph leading up to (but excluding) the author. The path excludes
       * any initial segments of the complete path which come before a WRITE edge
       * in the graph. This field is empty if the author is either the originator's
       * entry point into the address graph or is accessed by a WRITE edge.
       *
       * For example, "wave-discuss@acmewave.com" may be the explicit participant of
       * a wavelet, and is set as the author of a delta. However, this group is
       * being asked to act on behalf of "peter@initech-corp.com", who is a member
       * of "wave-authors", which is in turn a member of "wave-discuss". In this
       * example, the delta would be configured as such:
       *  delta.author = "wave-discuss@acmewave.com"
       *  delta.addressPath = ["peter@initech-corp.com", "wave-authors@acmewave.com"]
       * </pre>
       */
      public Builder addAddressPathBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureAddressPathIsMutable();
        addressPath_.add(value);
        onChanged();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:federation.ProtocolWaveletDelta)
    }

    static {
      defaultInstance = new ProtocolWaveletDelta(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:federation.ProtocolWaveletDelta)
  }

  public interface ProtocolHashedVersionOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // required int64 version = 1;
    /**
     * <code>required int64 version = 1;</code>
     */
    boolean hasVersion();
    /**
     * <code>required int64 version = 1;</code>
     */
    long getVersion();

    // required bytes history_hash = 2;
    /**
     * <code>required bytes history_hash = 2;</code>
     */
    boolean hasHistoryHash();
    /**
     * <code>required bytes history_hash = 2;</code>
     */
    com.google.protobuf.ByteString getHistoryHash();
  }
  /**
   * Protobuf type {@code federation.ProtocolHashedVersion}
   *
   * <pre>
   **
   * Describes a wavelet version and the wavelet's history hash at that version.
   * </pre>
   */
  public static final class ProtocolHashedVersion extends
      com.google.protobuf.GeneratedMessage
      implements ProtocolHashedVersionOrBuilder {
    // Use ProtocolHashedVersion.newBuilder() to construct.
    private ProtocolHashedVersion(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private ProtocolHashedVersion(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final ProtocolHashedVersion defaultInstance;
    public static ProtocolHashedVersion getDefaultInstance() {
      return defaultInstance;
    }

    public ProtocolHashedVersion getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private ProtocolHashedVersion(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 8: {
              bitField0_ |= 0x00000001;
              version_ = input.readInt64();
              break;
            }
            case 18: {
              bitField0_ |= 0x00000002;
              historyHash_ = input.readBytes();
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolHashedVersion_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolHashedVersion_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.class, org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.Builder.class);
    }

    public static com.google.protobuf.Parser<ProtocolHashedVersion> PARSER =
        new com.google.protobuf.AbstractParser<ProtocolHashedVersion>() {
      public ProtocolHashedVersion parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new ProtocolHashedVersion(input, extensionRegistry);
      }
    };

    @java.lang.Override
    public com.google.protobuf.Parser<ProtocolHashedVersion> getParserForType() {
      return PARSER;
    }

    private int bitField0_;
    // required int64 version = 1;
    public static final int VERSION_FIELD_NUMBER = 1;
    private long version_;
    /**
     * <code>required int64 version = 1;</code>
     */
    public boolean hasVersion() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>required int64 version = 1;</code>
     */
    public long getVersion() {
      return version_;
    }

    // required bytes history_hash = 2;
    public static final int HISTORY_HASH_FIELD_NUMBER = 2;
    private com.google.protobuf.ByteString historyHash_;
    /**
     * <code>required bytes history_hash = 2;</code>
     */
    public boolean hasHistoryHash() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    /**
     * <code>required bytes history_hash = 2;</code>
     */
    public com.google.protobuf.ByteString getHistoryHash() {
      return historyHash_;
    }

    private void initFields() {
      version_ = 0L;
      historyHash_ = com.google.protobuf.ByteString.EMPTY;
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      if (!hasVersion()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasHistoryHash()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeInt64(1, version_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeBytes(2, historyHash_);
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, version_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(2, historyHash_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    public static org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code federation.ProtocolHashedVersion}
     *
     * <pre>
     **
     * Describes a wavelet version and the wavelet's history hash at that version.
     * </pre>
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements org.waveprotocol.wave.federation.Proto.ProtocolHashedVersionOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolHashedVersion_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolHashedVersion_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.class, org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.Builder.class);
      }

      // Construct using org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        version_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000001);
        historyHash_ = com.google.protobuf.ByteString.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000002);
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolHashedVersion_descriptor;
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion getDefaultInstanceForType() {
        return org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.getDefaultInstance();
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion build() {
        org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion buildPartial() {
        org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion result = new org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.version_ = version_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.historyHash_ = historyHash_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion) {
          return mergeFrom((org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion other) {
        if (other == org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.getDefaultInstance()) return this;
        if (other.hasVersion()) {
          setVersion(other.getVersion());
        }
        if (other.hasHistoryHash()) {
          setHistoryHash(other.getHistoryHash());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        if (!hasVersion()) {
          
          return false;
        }
        if (!hasHistoryHash()) {
          
          return false;
        }
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // required int64 version = 1;
      private long version_ ;
      /**
       * <code>required int64 version = 1;</code>
       */
      public boolean hasVersion() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>required int64 version = 1;</code>
       */
      public long getVersion() {
        return version_;
      }
      /**
       * <code>required int64 version = 1;</code>
       */
      public Builder setVersion(long value) {
        bitField0_ |= 0x00000001;
        version_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required int64 version = 1;</code>
       */
      public Builder clearVersion() {
        bitField0_ = (bitField0_ & ~0x00000001);
        version_ = 0L;
        onChanged();
        return this;
      }

      // required bytes history_hash = 2;
      private com.google.protobuf.ByteString historyHash_ = com.google.protobuf.ByteString.EMPTY;
      /**
       * <code>required bytes history_hash = 2;</code>
       */
      public boolean hasHistoryHash() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      /**
       * <code>required bytes history_hash = 2;</code>
       */
      public com.google.protobuf.ByteString getHistoryHash() {
        return historyHash_;
      }
      /**
       * <code>required bytes history_hash = 2;</code>
       */
      public Builder setHistoryHash(com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        historyHash_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required bytes history_hash = 2;</code>
       */
      public Builder clearHistoryHash() {
        bitField0_ = (bitField0_ & ~0x00000002);
        historyHash_ = getDefaultInstance().getHistoryHash();
        onChanged();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:federation.ProtocolHashedVersion)
    }

    static {
      defaultInstance = new ProtocolHashedVersion(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:federation.ProtocolHashedVersion)
  }

  public interface ProtocolWaveletOperationOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // optional string add_participant = 1;
    /**
     * <code>optional string add_participant = 1;</code>
     *
     * <pre>
     * Adds a new participant (canonicalized wave address) to the wavelet.
     * </pre>
     */
    boolean hasAddParticipant();
    /**
     * <code>optional string add_participant = 1;</code>
     *
     * <pre>
     * Adds a new participant (canonicalized wave address) to the wavelet.
     * </pre>
     */
    java.lang.String getAddParticipant();
    /**
     * <code>optional string add_participant = 1;</code>
     *
     * <pre>
     * Adds a new participant (canonicalized wave address) to the wavelet.
     * </pre>
     */
    com.google.protobuf.ByteString
        getAddParticipantBytes();

    // optional string remove_participant = 2;
    /**
     * <code>optional string remove_participant = 2;</code>
     *
     * <pre>
     * Removes an existing participant (canonicalized wave address) from the wavelet.
     * </pre>
     */
    boolean hasRemoveParticipant();
    /**
     * <code>optional string remove_participant = 2;</code>
     *
     * <pre>
     * Removes an existing participant (canonicalized wave address) from the wavelet.
     * </pre>
     */
    java.lang.String getRemoveParticipant();
    /**
     * <code>optional string remove_participant = 2;</code>
     *
     * <pre>
     * Removes an existing participant (canonicalized wave address) from the wavelet.
     * </pre>
     */
    com.google.protobuf.ByteString
        getRemoveParticipantBytes();

    // optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;
    /**
     * <code>optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;</code>
     *
     * <pre>
     * Mutates a document.
     * </pre>
     */
    boolean hasMutateDocument();
    /**
     * <code>optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;</code>
     *
     * <pre>
     * Mutates a document.
     * </pre>
     */
    org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument getMutateDocument();
    /**
     * <code>optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;</code>
     *
     * <pre>
     * Mutates a document.
     * </pre>
     */
    org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocumentOrBuilder getMutateDocumentOrBuilder();

    // optional bool no_op = 4;
    /**
     * <code>optional bool no_op = 4;</code>
     *
     * <pre>
     * Does nothing. True if set.
     * </pre>
     */
    boolean hasNoOp();
    /**
     * <code>optional bool no_op = 4;</code>
     *
     * <pre>
     * Does nothing. True if set.
     * </pre>
     */
    boolean getNoOp();
  }
  /**
   * Protobuf type {@code federation.ProtocolWaveletOperation}
   *
   * <pre>
   **
   * An operation within a delta. Exactly one of the following seven fields must be set
   * for this operation to be valid.
   * </pre>
   */
  public static final class ProtocolWaveletOperation extends
      com.google.protobuf.GeneratedMessage
      implements ProtocolWaveletOperationOrBuilder {
    // Use ProtocolWaveletOperation.newBuilder() to construct.
    private ProtocolWaveletOperation(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private ProtocolWaveletOperation(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final ProtocolWaveletOperation defaultInstance;
    public static ProtocolWaveletOperation getDefaultInstance() {
      return defaultInstance;
    }

    public ProtocolWaveletOperation getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private ProtocolWaveletOperation(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              bitField0_ |= 0x00000001;
              addParticipant_ = input.readBytes();
              break;
            }
            case 18: {
              bitField0_ |= 0x00000002;
              removeParticipant_ = input.readBytes();
              break;
            }
            case 26: {
              org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.Builder subBuilder = null;
              if (((bitField0_ & 0x00000004) == 0x00000004)) {
                subBuilder = mutateDocument_.toBuilder();
              }
              mutateDocument_ = input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(mutateDocument_);
                mutateDocument_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000004;
              break;
            }
            case 32: {
              bitField0_ |= 0x00000008;
              noOp_ = input.readBool();
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolWaveletOperation_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolWaveletOperation_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.class, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.Builder.class);
    }

    public static com.google.protobuf.Parser<ProtocolWaveletOperation> PARSER =
        new com.google.protobuf.AbstractParser<ProtocolWaveletOperation>() {
      public ProtocolWaveletOperation parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new ProtocolWaveletOperation(input, extensionRegistry);
      }
    };

    @java.lang.Override
    public com.google.protobuf.Parser<ProtocolWaveletOperation> getParserForType() {
      return PARSER;
    }

    public interface MutateDocumentOrBuilder
        extends com.google.protobuf.MessageOrBuilder {

      // required string document_id = 1;
      /**
       * <code>required string document_id = 1;</code>
       */
      boolean hasDocumentId();
      /**
       * <code>required string document_id = 1;</code>
       */
      java.lang.String getDocumentId();
      /**
       * <code>required string document_id = 1;</code>
       */
      com.google.protobuf.ByteString
          getDocumentIdBytes();

      // required .federation.ProtocolDocumentOperation document_operation = 2;
      /**
       * <code>required .federation.ProtocolDocumentOperation document_operation = 2;</code>
       */
      boolean hasDocumentOperation();
      /**
       * <code>required .federation.ProtocolDocumentOperation document_operation = 2;</code>
       */
      org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation getDocumentOperation();
      /**
       * <code>required .federation.ProtocolDocumentOperation document_operation = 2;</code>
       */
      org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperationOrBuilder getDocumentOperationOrBuilder();
    }
    /**
     * Protobuf type {@code federation.ProtocolWaveletOperation.MutateDocument}
     *
     * <pre>
     * A document operation. Mutates the contents of the specified document.
     * </pre>
     */
    public static final class MutateDocument extends
        com.google.protobuf.GeneratedMessage
        implements MutateDocumentOrBuilder {
      // Use MutateDocument.newBuilder() to construct.
      private MutateDocument(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
        super(builder);
        this.unknownFields = builder.getUnknownFields();
      }
      private MutateDocument(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

      private static final MutateDocument defaultInstance;
      public static MutateDocument getDefaultInstance() {
        return defaultInstance;
      }

      public MutateDocument getDefaultInstanceForType() {
        return defaultInstance;
      }

      private final com.google.protobuf.UnknownFieldSet unknownFields;
      @java.lang.Override
      public final com.google.protobuf.UnknownFieldSet
          getUnknownFields() {
        return this.unknownFields;
      }
      private MutateDocument(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        initFields();
        int mutable_bitField0_ = 0;
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
            com.google.protobuf.UnknownFieldSet.newBuilder();
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              default: {
                if (!parseUnknownField(input, unknownFields,
                                       extensionRegistry, tag)) {
                  done = true;
                }
                break;
              }
              case 10: {
                bitField0_ |= 0x00000001;
                documentId_ = input.readBytes();
                break;
              }
              case 18: {
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Builder subBuilder = null;
                if (((bitField0_ & 0x00000002) == 0x00000002)) {
                  subBuilder = documentOperation_.toBuilder();
                }
                documentOperation_ = input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.PARSER, extensionRegistry);
                if (subBuilder != null) {
                  subBuilder.mergeFrom(documentOperation_);
                  documentOperation_ = subBuilder.buildPartial();
                }
                bitField0_ |= 0x00000002;
                break;
              }
            }
          }
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(this);
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(
              e.getMessage()).setUnfinishedMessage(this);
        } finally {
          this.unknownFields = unknownFields.build();
          makeExtensionsImmutable();
        }
      }
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolWaveletOperation_MutateDocument_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolWaveletOperation_MutateDocument_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.class, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.Builder.class);
      }

      public static com.google.protobuf.Parser<MutateDocument> PARSER =
          new com.google.protobuf.AbstractParser<MutateDocument>() {
        public MutateDocument parsePartialFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return new MutateDocument(input, extensionRegistry);
        }
      };

      @java.lang.Override
      public com.google.protobuf.Parser<MutateDocument> getParserForType() {
        return PARSER;
      }

      private int bitField0_;
      // required string document_id = 1;
      public static final int DOCUMENT_ID_FIELD_NUMBER = 1;
      private java.lang.Object documentId_;
      /**
       * <code>required string document_id = 1;</code>
       */
      public boolean hasDocumentId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>required string document_id = 1;</code>
       */
      public java.lang.String getDocumentId() {
        java.lang.Object ref = documentId_;
        if (ref instanceof java.lang.String) {
          return (java.lang.String) ref;
        } else {
          com.google.protobuf.ByteString bs = 
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          if (bs.isValidUtf8()) {
            documentId_ = s;
          }
          return s;
        }
      }
      /**
       * <code>required string document_id = 1;</code>
       */
      public com.google.protobuf.ByteString
          getDocumentIdBytes() {
        java.lang.Object ref = documentId_;
        if (ref instanceof java.lang.String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          documentId_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }

      // required .federation.ProtocolDocumentOperation document_operation = 2;
      public static final int DOCUMENT_OPERATION_FIELD_NUMBER = 2;
      private org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation documentOperation_;
      /**
       * <code>required .federation.ProtocolDocumentOperation document_operation = 2;</code>
       */
      public boolean hasDocumentOperation() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      /**
       * <code>required .federation.ProtocolDocumentOperation document_operation = 2;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation getDocumentOperation() {
        return documentOperation_;
      }
      /**
       * <code>required .federation.ProtocolDocumentOperation document_operation = 2;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperationOrBuilder getDocumentOperationOrBuilder() {
        return documentOperation_;
      }

      private void initFields() {
        documentId_ = "";
        documentOperation_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.getDefaultInstance();
      }
      private byte memoizedIsInitialized = -1;
      public final boolean isInitialized() {
        byte isInitialized = memoizedIsInitialized;
        if (isInitialized != -1) return isInitialized == 1;

        if (!hasDocumentId()) {
          memoizedIsInitialized = 0;
          return false;
        }
        if (!hasDocumentOperation()) {
          memoizedIsInitialized = 0;
          return false;
        }
        if (!getDocumentOperation().isInitialized()) {
          memoizedIsInitialized = 0;
          return false;
        }
        memoizedIsInitialized = 1;
        return true;
      }

      public void writeTo(com.google.protobuf.CodedOutputStream output)
                          throws java.io.IOException {
        getSerializedSize();
        if (((bitField0_ & 0x00000001) == 0x00000001)) {
          output.writeBytes(1, getDocumentIdBytes());
        }
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          output.writeMessage(2, documentOperation_);
        }
        getUnknownFields().writeTo(output);
      }

      private int memoizedSerializedSize = -1;
      public int getSerializedSize() {
        int size = memoizedSerializedSize;
        if (size != -1) return size;

        size = 0;
        if (((bitField0_ & 0x00000001) == 0x00000001)) {
          size += com.google.protobuf.CodedOutputStream
            .computeBytesSize(1, getDocumentIdBytes());
        }
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          size += com.google.protobuf.CodedOutputStream
            .computeMessageSize(2, documentOperation_);
        }
        size += getUnknownFields().getSerializedSize();
        memoizedSerializedSize = size;
        return size;
      }

      private static final long serialVersionUID = 0L;
      @java.lang.Override
      protected java.lang.Object writeReplace()
          throws java.io.ObjectStreamException {
        return super.writeReplace();
      }

      public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument parseFrom(
          com.google.protobuf.ByteString data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument parseFrom(
          com.google.protobuf.ByteString data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument parseFrom(byte[] data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument parseFrom(
          byte[] data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument parseFrom(java.io.InputStream input)
          throws java.io.IOException {
        return PARSER.parseFrom(input);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument parseFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return PARSER.parseFrom(input, extensionRegistry);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument parseDelimitedFrom(java.io.InputStream input)
          throws java.io.IOException {
        return PARSER.parseDelimitedFrom(input);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument parseDelimitedFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return PARSER.parseDelimitedFrom(input, extensionRegistry);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument parseFrom(
          com.google.protobuf.CodedInputStream input)
          throws java.io.IOException {
        return PARSER.parseFrom(input);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument parseFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return PARSER.parseFrom(input, extensionRegistry);
      }

      public static Builder newBuilder() { return Builder.create(); }
      public Builder newBuilderForType() { return newBuilder(); }
      public static Builder newBuilder(org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument prototype) {
        return newBuilder().mergeFrom(prototype);
      }
      public Builder toBuilder() { return newBuilder(this); }

      @java.lang.Override
      protected Builder newBuilderForType(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        Builder builder = new Builder(parent);
        return builder;
      }
      /**
       * Protobuf type {@code federation.ProtocolWaveletOperation.MutateDocument}
       *
       * <pre>
       * A document operation. Mutates the contents of the specified document.
       * </pre>
       */
      public static final class Builder extends
          com.google.protobuf.GeneratedMessage.Builder<Builder>
         implements org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocumentOrBuilder {
        public static final com.google.protobuf.Descriptors.Descriptor
            getDescriptor() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolWaveletOperation_MutateDocument_descriptor;
        }

        protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
            internalGetFieldAccessorTable() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolWaveletOperation_MutateDocument_fieldAccessorTable
              .ensureFieldAccessorsInitialized(
                  org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.class, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.Builder.class);
        }

        // Construct using org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.newBuilder()
        private Builder() {
          maybeForceBuilderInitialization();
        }

        private Builder(
            com.google.protobuf.GeneratedMessage.BuilderParent parent) {
          super(parent);
          maybeForceBuilderInitialization();
        }
        private void maybeForceBuilderInitialization() {
          if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
            getDocumentOperationFieldBuilder();
          }
        }
        private static Builder create() {
          return new Builder();
        }

        public Builder clear() {
          super.clear();
          documentId_ = "";
          bitField0_ = (bitField0_ & ~0x00000001);
          if (documentOperationBuilder_ == null) {
            documentOperation_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.getDefaultInstance();
          } else {
            documentOperationBuilder_.clear();
          }
          bitField0_ = (bitField0_ & ~0x00000002);
          return this;
        }

        public Builder clone() {
          return create().mergeFrom(buildPartial());
        }

        public com.google.protobuf.Descriptors.Descriptor
            getDescriptorForType() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolWaveletOperation_MutateDocument_descriptor;
        }

        public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument getDefaultInstanceForType() {
          return org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.getDefaultInstance();
        }

        public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument build() {
          org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument result = buildPartial();
          if (!result.isInitialized()) {
            throw newUninitializedMessageException(result);
          }
          return result;
        }

        public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument buildPartial() {
          org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument result = new org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument(this);
          int from_bitField0_ = bitField0_;
          int to_bitField0_ = 0;
          if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
            to_bitField0_ |= 0x00000001;
          }
          result.documentId_ = documentId_;
          if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
            to_bitField0_ |= 0x00000002;
          }
          if (documentOperationBuilder_ == null) {
            result.documentOperation_ = documentOperation_;
          } else {
            result.documentOperation_ = documentOperationBuilder_.build();
          }
          result.bitField0_ = to_bitField0_;
          onBuilt();
          return result;
        }

        public Builder mergeFrom(com.google.protobuf.Message other) {
          if (other instanceof org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument) {
            return mergeFrom((org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument)other);
          } else {
            super.mergeFrom(other);
            return this;
          }
        }

        public Builder mergeFrom(org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument other) {
          if (other == org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.getDefaultInstance()) return this;
          if (other.hasDocumentId()) {
            bitField0_ |= 0x00000001;
            documentId_ = other.documentId_;
            onChanged();
          }
          if (other.hasDocumentOperation()) {
            mergeDocumentOperation(other.getDocumentOperation());
          }
          this.mergeUnknownFields(other.getUnknownFields());
          return this;
        }

        public final boolean isInitialized() {
          if (!hasDocumentId()) {
            
            return false;
          }
          if (!hasDocumentOperation()) {
            
            return false;
          }
          if (!getDocumentOperation().isInitialized()) {
            
            return false;
          }
          return true;
        }

        public Builder mergeFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument parsedMessage = null;
          try {
            parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
          } catch (com.google.protobuf.InvalidProtocolBufferException e) {
            parsedMessage = (org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument) e.getUnfinishedMessage();
            throw e;
          } finally {
            if (parsedMessage != null) {
              mergeFrom(parsedMessage);
            }
          }
          return this;
        }
        private int bitField0_;

        // required string document_id = 1;
        private java.lang.Object documentId_ = "";
        /**
         * <code>required string document_id = 1;</code>
         */
        public boolean hasDocumentId() {
          return ((bitField0_ & 0x00000001) == 0x00000001);
        }
        /**
         * <code>required string document_id = 1;</code>
         */
        public java.lang.String getDocumentId() {
          java.lang.Object ref = documentId_;
          if (!(ref instanceof java.lang.String)) {
            java.lang.String s = ((com.google.protobuf.ByteString) ref)
                .toStringUtf8();
            documentId_ = s;
            return s;
          } else {
            return (java.lang.String) ref;
          }
        }
        /**
         * <code>required string document_id = 1;</code>
         */
        public com.google.protobuf.ByteString
            getDocumentIdBytes() {
          java.lang.Object ref = documentId_;
          if (ref instanceof String) {
            com.google.protobuf.ByteString b = 
                com.google.protobuf.ByteString.copyFromUtf8(
                    (java.lang.String) ref);
            documentId_ = b;
            return b;
          } else {
            return (com.google.protobuf.ByteString) ref;
          }
        }
        /**
         * <code>required string document_id = 1;</code>
         */
        public Builder setDocumentId(
            java.lang.String value) {
          if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
          documentId_ = value;
          onChanged();
          return this;
        }
        /**
         * <code>required string document_id = 1;</code>
         */
        public Builder clearDocumentId() {
          bitField0_ = (bitField0_ & ~0x00000001);
          documentId_ = getDefaultInstance().getDocumentId();
          onChanged();
          return this;
        }
        /**
         * <code>required string document_id = 1;</code>
         */
        public Builder setDocumentIdBytes(
            com.google.protobuf.ByteString value) {
          if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
          documentId_ = value;
          onChanged();
          return this;
        }

        // required .federation.ProtocolDocumentOperation document_operation = 2;
        private org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation documentOperation_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.getDefaultInstance();
        private com.google.protobuf.SingleFieldBuilder<
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperationOrBuilder> documentOperationBuilder_;
        /**
         * <code>required .federation.ProtocolDocumentOperation document_operation = 2;</code>
         */
        public boolean hasDocumentOperation() {
          return ((bitField0_ & 0x00000002) == 0x00000002);
        }
        /**
         * <code>required .federation.ProtocolDocumentOperation document_operation = 2;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation getDocumentOperation() {
          if (documentOperationBuilder_ == null) {
            return documentOperation_;
          } else {
            return documentOperationBuilder_.getMessage();
          }
        }
        /**
         * <code>required .federation.ProtocolDocumentOperation document_operation = 2;</code>
         */
        public Builder setDocumentOperation(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation value) {
          if (documentOperationBuilder_ == null) {
            if (value == null) {
              throw new NullPointerException();
            }
            documentOperation_ = value;
            onChanged();
          } else {
            documentOperationBuilder_.setMessage(value);
          }
          bitField0_ |= 0x00000002;
          return this;
        }
        /**
         * <code>required .federation.ProtocolDocumentOperation document_operation = 2;</code>
         */
        public Builder setDocumentOperation(
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Builder builderForValue) {
          if (documentOperationBuilder_ == null) {
            documentOperation_ = builderForValue.build();
            onChanged();
          } else {
            documentOperationBuilder_.setMessage(builderForValue.build());
          }
          bitField0_ |= 0x00000002;
          return this;
        }
        /**
         * <code>required .federation.ProtocolDocumentOperation document_operation = 2;</code>
         */
        public Builder mergeDocumentOperation(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation value) {
          if (documentOperationBuilder_ == null) {
            if (((bitField0_ & 0x00000002) == 0x00000002) &&
                documentOperation_ != org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.getDefaultInstance()) {
              documentOperation_ =
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.newBuilder(documentOperation_).mergeFrom(value).buildPartial();
            } else {
              documentOperation_ = value;
            }
            onChanged();
          } else {
            documentOperationBuilder_.mergeFrom(value);
          }
          bitField0_ |= 0x00000002;
          return this;
        }
        /**
         * <code>required .federation.ProtocolDocumentOperation document_operation = 2;</code>
         */
        public Builder clearDocumentOperation() {
          if (documentOperationBuilder_ == null) {
            documentOperation_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.getDefaultInstance();
            onChanged();
          } else {
            documentOperationBuilder_.clear();
          }
          bitField0_ = (bitField0_ & ~0x00000002);
          return this;
        }
        /**
         * <code>required .federation.ProtocolDocumentOperation document_operation = 2;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Builder getDocumentOperationBuilder() {
          bitField0_ |= 0x00000002;
          onChanged();
          return getDocumentOperationFieldBuilder().getBuilder();
        }
        /**
         * <code>required .federation.ProtocolDocumentOperation document_operation = 2;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperationOrBuilder getDocumentOperationOrBuilder() {
          if (documentOperationBuilder_ != null) {
            return documentOperationBuilder_.getMessageOrBuilder();
          } else {
            return documentOperation_;
          }
        }
        /**
         * <code>required .federation.ProtocolDocumentOperation document_operation = 2;</code>
         */
        private com.google.protobuf.SingleFieldBuilder<
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperationOrBuilder> 
            getDocumentOperationFieldBuilder() {
          if (documentOperationBuilder_ == null) {
            documentOperationBuilder_ = new com.google.protobuf.SingleFieldBuilder<
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperationOrBuilder>(
                    documentOperation_,
                    getParentForChildren(),
                    isClean());
            documentOperation_ = null;
          }
          return documentOperationBuilder_;
        }

        // @@protoc_insertion_point(builder_scope:federation.ProtocolWaveletOperation.MutateDocument)
      }

      static {
        defaultInstance = new MutateDocument(true);
        defaultInstance.initFields();
      }

      // @@protoc_insertion_point(class_scope:federation.ProtocolWaveletOperation.MutateDocument)
    }

    private int bitField0_;
    // optional string add_participant = 1;
    public static final int ADD_PARTICIPANT_FIELD_NUMBER = 1;
    private java.lang.Object addParticipant_;
    /**
     * <code>optional string add_participant = 1;</code>
     *
     * <pre>
     * Adds a new participant (canonicalized wave address) to the wavelet.
     * </pre>
     */
    public boolean hasAddParticipant() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>optional string add_participant = 1;</code>
     *
     * <pre>
     * Adds a new participant (canonicalized wave address) to the wavelet.
     * </pre>
     */
    public java.lang.String getAddParticipant() {
      java.lang.Object ref = addParticipant_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          addParticipant_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string add_participant = 1;</code>
     *
     * <pre>
     * Adds a new participant (canonicalized wave address) to the wavelet.
     * </pre>
     */
    public com.google.protobuf.ByteString
        getAddParticipantBytes() {
      java.lang.Object ref = addParticipant_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        addParticipant_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string remove_participant = 2;
    public static final int REMOVE_PARTICIPANT_FIELD_NUMBER = 2;
    private java.lang.Object removeParticipant_;
    /**
     * <code>optional string remove_participant = 2;</code>
     *
     * <pre>
     * Removes an existing participant (canonicalized wave address) from the wavelet.
     * </pre>
     */
    public boolean hasRemoveParticipant() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    /**
     * <code>optional string remove_participant = 2;</code>
     *
     * <pre>
     * Removes an existing participant (canonicalized wave address) from the wavelet.
     * </pre>
     */
    public java.lang.String getRemoveParticipant() {
      java.lang.Object ref = removeParticipant_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          removeParticipant_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string remove_participant = 2;</code>
     *
     * <pre>
     * Removes an existing participant (canonicalized wave address) from the wavelet.
     * </pre>
     */
    public com.google.protobuf.ByteString
        getRemoveParticipantBytes() {
      java.lang.Object ref = removeParticipant_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        removeParticipant_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;
    public static final int MUTATE_DOCUMENT_FIELD_NUMBER = 3;
    private org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument mutateDocument_;
    /**
     * <code>optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;</code>
     *
     * <pre>
     * Mutates a document.
     * </pre>
     */
    public boolean hasMutateDocument() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    /**
     * <code>optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;</code>
     *
     * <pre>
     * Mutates a document.
     * </pre>
     */
    public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument getMutateDocument() {
      return mutateDocument_;
    }
    /**
     * <code>optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;</code>
     *
     * <pre>
     * Mutates a document.
     * </pre>
     */
    public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocumentOrBuilder getMutateDocumentOrBuilder() {
      return mutateDocument_;
    }

    // optional bool no_op = 4;
    public static final int NO_OP_FIELD_NUMBER = 4;
    private boolean noOp_;
    /**
     * <code>optional bool no_op = 4;</code>
     *
     * <pre>
     * Does nothing. True if set.
     * </pre>
     */
    public boolean hasNoOp() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    /**
     * <code>optional bool no_op = 4;</code>
     *
     * <pre>
     * Does nothing. True if set.
     * </pre>
     */
    public boolean getNoOp() {
      return noOp_;
    }

    private void initFields() {
      addParticipant_ = "";
      removeParticipant_ = "";
      mutateDocument_ = org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.getDefaultInstance();
      noOp_ = false;
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      if (hasMutateDocument()) {
        if (!getMutateDocument().isInitialized()) {
          memoizedIsInitialized = 0;
          return false;
        }
      }
      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeBytes(1, getAddParticipantBytes());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeBytes(2, getRemoveParticipantBytes());
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeMessage(3, mutateDocument_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeBool(4, noOp_);
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(1, getAddParticipantBytes());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(2, getRemoveParticipantBytes());
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(3, mutateDocument_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBoolSize(4, noOp_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code federation.ProtocolWaveletOperation}
     *
     * <pre>
     **
     * An operation within a delta. Exactly one of the following seven fields must be set
     * for this operation to be valid.
     * </pre>
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperationOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolWaveletOperation_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolWaveletOperation_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.class, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.Builder.class);
      }

      // Construct using org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
          getMutateDocumentFieldBuilder();
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        addParticipant_ = "";
        bitField0_ = (bitField0_ & ~0x00000001);
        removeParticipant_ = "";
        bitField0_ = (bitField0_ & ~0x00000002);
        if (mutateDocumentBuilder_ == null) {
          mutateDocument_ = org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.getDefaultInstance();
        } else {
          mutateDocumentBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000004);
        noOp_ = false;
        bitField0_ = (bitField0_ & ~0x00000008);
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolWaveletOperation_descriptor;
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation getDefaultInstanceForType() {
        return org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.getDefaultInstance();
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation build() {
        org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation buildPartial() {
        org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation result = new org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.addParticipant_ = addParticipant_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.removeParticipant_ = removeParticipant_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        if (mutateDocumentBuilder_ == null) {
          result.mutateDocument_ = mutateDocument_;
        } else {
          result.mutateDocument_ = mutateDocumentBuilder_.build();
        }
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.noOp_ = noOp_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation) {
          return mergeFrom((org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation other) {
        if (other == org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.getDefaultInstance()) return this;
        if (other.hasAddParticipant()) {
          bitField0_ |= 0x00000001;
          addParticipant_ = other.addParticipant_;
          onChanged();
        }
        if (other.hasRemoveParticipant()) {
          bitField0_ |= 0x00000002;
          removeParticipant_ = other.removeParticipant_;
          onChanged();
        }
        if (other.hasMutateDocument()) {
          mergeMutateDocument(other.getMutateDocument());
        }
        if (other.hasNoOp()) {
          setNoOp(other.getNoOp());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        if (hasMutateDocument()) {
          if (!getMutateDocument().isInitialized()) {
            
            return false;
          }
        }
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // optional string add_participant = 1;
      private java.lang.Object addParticipant_ = "";
      /**
       * <code>optional string add_participant = 1;</code>
       *
       * <pre>
       * Adds a new participant (canonicalized wave address) to the wavelet.
       * </pre>
       */
      public boolean hasAddParticipant() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>optional string add_participant = 1;</code>
       *
       * <pre>
       * Adds a new participant (canonicalized wave address) to the wavelet.
       * </pre>
       */
      public java.lang.String getAddParticipant() {
        java.lang.Object ref = addParticipant_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          addParticipant_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string add_participant = 1;</code>
       *
       * <pre>
       * Adds a new participant (canonicalized wave address) to the wavelet.
       * </pre>
       */
      public com.google.protobuf.ByteString
          getAddParticipantBytes() {
        java.lang.Object ref = addParticipant_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          addParticipant_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string add_participant = 1;</code>
       *
       * <pre>
       * Adds a new participant (canonicalized wave address) to the wavelet.
       * </pre>
       */
      public Builder setAddParticipant(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        addParticipant_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string add_participant = 1;</code>
       *
       * <pre>
       * Adds a new participant (canonicalized wave address) to the wavelet.
       * </pre>
       */
      public Builder clearAddParticipant() {
        bitField0_ = (bitField0_ & ~0x00000001);
        addParticipant_ = getDefaultInstance().getAddParticipant();
        onChanged();
        return this;
      }
      /**
       * <code>optional string add_participant = 1;</code>
       *
       * <pre>
       * Adds a new participant (canonicalized wave address) to the wavelet.
       * </pre>
       */
      public Builder setAddParticipantBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        addParticipant_ = value;
        onChanged();
        return this;
      }

      // optional string remove_participant = 2;
      private java.lang.Object removeParticipant_ = "";
      /**
       * <code>optional string remove_participant = 2;</code>
       *
       * <pre>
       * Removes an existing participant (canonicalized wave address) from the wavelet.
       * </pre>
       */
      public boolean hasRemoveParticipant() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      /**
       * <code>optional string remove_participant = 2;</code>
       *
       * <pre>
       * Removes an existing participant (canonicalized wave address) from the wavelet.
       * </pre>
       */
      public java.lang.String getRemoveParticipant() {
        java.lang.Object ref = removeParticipant_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          removeParticipant_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string remove_participant = 2;</code>
       *
       * <pre>
       * Removes an existing participant (canonicalized wave address) from the wavelet.
       * </pre>
       */
      public com.google.protobuf.ByteString
          getRemoveParticipantBytes() {
        java.lang.Object ref = removeParticipant_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          removeParticipant_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string remove_participant = 2;</code>
       *
       * <pre>
       * Removes an existing participant (canonicalized wave address) from the wavelet.
       * </pre>
       */
      public Builder setRemoveParticipant(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        removeParticipant_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string remove_participant = 2;</code>
       *
       * <pre>
       * Removes an existing participant (canonicalized wave address) from the wavelet.
       * </pre>
       */
      public Builder clearRemoveParticipant() {
        bitField0_ = (bitField0_ & ~0x00000002);
        removeParticipant_ = getDefaultInstance().getRemoveParticipant();
        onChanged();
        return this;
      }
      /**
       * <code>optional string remove_participant = 2;</code>
       *
       * <pre>
       * Removes an existing participant (canonicalized wave address) from the wavelet.
       * </pre>
       */
      public Builder setRemoveParticipantBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        removeParticipant_ = value;
        onChanged();
        return this;
      }

      // optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;
      private org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument mutateDocument_ = org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.getDefaultInstance();
      private com.google.protobuf.SingleFieldBuilder<
          org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.Builder, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocumentOrBuilder> mutateDocumentBuilder_;
      /**
       * <code>optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;</code>
       *
       * <pre>
       * Mutates a document.
       * </pre>
       */
      public boolean hasMutateDocument() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      /**
       * <code>optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;</code>
       *
       * <pre>
       * Mutates a document.
       * </pre>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument getMutateDocument() {
        if (mutateDocumentBuilder_ == null) {
          return mutateDocument_;
        } else {
          return mutateDocumentBuilder_.getMessage();
        }
      }
      /**
       * <code>optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;</code>
       *
       * <pre>
       * Mutates a document.
       * </pre>
       */
      public Builder setMutateDocument(org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument value) {
        if (mutateDocumentBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          mutateDocument_ = value;
          onChanged();
        } else {
          mutateDocumentBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000004;
        return this;
      }
      /**
       * <code>optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;</code>
       *
       * <pre>
       * Mutates a document.
       * </pre>
       */
      public Builder setMutateDocument(
          org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.Builder builderForValue) {
        if (mutateDocumentBuilder_ == null) {
          mutateDocument_ = builderForValue.build();
          onChanged();
        } else {
          mutateDocumentBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000004;
        return this;
      }
      /**
       * <code>optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;</code>
       *
       * <pre>
       * Mutates a document.
       * </pre>
       */
      public Builder mergeMutateDocument(org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument value) {
        if (mutateDocumentBuilder_ == null) {
          if (((bitField0_ & 0x00000004) == 0x00000004) &&
              mutateDocument_ != org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.getDefaultInstance()) {
            mutateDocument_ =
              org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.newBuilder(mutateDocument_).mergeFrom(value).buildPartial();
          } else {
            mutateDocument_ = value;
          }
          onChanged();
        } else {
          mutateDocumentBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000004;
        return this;
      }
      /**
       * <code>optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;</code>
       *
       * <pre>
       * Mutates a document.
       * </pre>
       */
      public Builder clearMutateDocument() {
        if (mutateDocumentBuilder_ == null) {
          mutateDocument_ = org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.getDefaultInstance();
          onChanged();
        } else {
          mutateDocumentBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000004);
        return this;
      }
      /**
       * <code>optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;</code>
       *
       * <pre>
       * Mutates a document.
       * </pre>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.Builder getMutateDocumentBuilder() {
        bitField0_ |= 0x00000004;
        onChanged();
        return getMutateDocumentFieldBuilder().getBuilder();
      }
      /**
       * <code>optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;</code>
       *
       * <pre>
       * Mutates a document.
       * </pre>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocumentOrBuilder getMutateDocumentOrBuilder() {
        if (mutateDocumentBuilder_ != null) {
          return mutateDocumentBuilder_.getMessageOrBuilder();
        } else {
          return mutateDocument_;
        }
      }
      /**
       * <code>optional .federation.ProtocolWaveletOperation.MutateDocument mutate_document = 3;</code>
       *
       * <pre>
       * Mutates a document.
       * </pre>
       */
      private com.google.protobuf.SingleFieldBuilder<
          org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.Builder, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocumentOrBuilder> 
          getMutateDocumentFieldBuilder() {
        if (mutateDocumentBuilder_ == null) {
          mutateDocumentBuilder_ = new com.google.protobuf.SingleFieldBuilder<
              org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocument.Builder, org.waveprotocol.wave.federation.Proto.ProtocolWaveletOperation.MutateDocumentOrBuilder>(
                  mutateDocument_,
                  getParentForChildren(),
                  isClean());
          mutateDocument_ = null;
        }
        return mutateDocumentBuilder_;
      }

      // optional bool no_op = 4;
      private boolean noOp_ ;
      /**
       * <code>optional bool no_op = 4;</code>
       *
       * <pre>
       * Does nothing. True if set.
       * </pre>
       */
      public boolean hasNoOp() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      /**
       * <code>optional bool no_op = 4;</code>
       *
       * <pre>
       * Does nothing. True if set.
       * </pre>
       */
      public boolean getNoOp() {
        return noOp_;
      }
      /**
       * <code>optional bool no_op = 4;</code>
       *
       * <pre>
       * Does nothing. True if set.
       * </pre>
       */
      public Builder setNoOp(boolean value) {
        bitField0_ |= 0x00000008;
        noOp_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional bool no_op = 4;</code>
       *
       * <pre>
       * Does nothing. True if set.
       * </pre>
       */
      public Builder clearNoOp() {
        bitField0_ = (bitField0_ & ~0x00000008);
        noOp_ = false;
        onChanged();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:federation.ProtocolWaveletOperation)
    }

    static {
      defaultInstance = new ProtocolWaveletOperation(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:federation.ProtocolWaveletOperation)
  }

  public interface ProtocolDocumentOperationOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // repeated .federation.ProtocolDocumentOperation.Component component = 1;
    /**
     * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
     */
    java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component> 
        getComponentList();
    /**
     * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
     */
    org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component getComponent(int index);
    /**
     * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
     */
    int getComponentCount();
    /**
     * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
     */
    java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.ComponentOrBuilder> 
        getComponentOrBuilderList();
    /**
     * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
     */
    org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.ComponentOrBuilder getComponentOrBuilder(
        int index);
  }
  /**
   * Protobuf type {@code federation.ProtocolDocumentOperation}
   *
   * <pre>
   **
   * A list of mutation components.
   * </pre>
   */
  public static final class ProtocolDocumentOperation extends
      com.google.protobuf.GeneratedMessage
      implements ProtocolDocumentOperationOrBuilder {
    // Use ProtocolDocumentOperation.newBuilder() to construct.
    private ProtocolDocumentOperation(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private ProtocolDocumentOperation(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final ProtocolDocumentOperation defaultInstance;
    public static ProtocolDocumentOperation getDefaultInstance() {
      return defaultInstance;
    }

    public ProtocolDocumentOperation getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private ProtocolDocumentOperation(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              if (!((mutable_bitField0_ & 0x00000001) == 0x00000001)) {
                component_ = new java.util.ArrayList<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component>();
                mutable_bitField0_ |= 0x00000001;
              }
              component_.add(input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.PARSER, extensionRegistry));
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000001) == 0x00000001)) {
          component_ = java.util.Collections.unmodifiableList(component_);
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.class, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Builder.class);
    }

    public static com.google.protobuf.Parser<ProtocolDocumentOperation> PARSER =
        new com.google.protobuf.AbstractParser<ProtocolDocumentOperation>() {
      public ProtocolDocumentOperation parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new ProtocolDocumentOperation(input, extensionRegistry);
      }
    };

    @java.lang.Override
    public com.google.protobuf.Parser<ProtocolDocumentOperation> getParserForType() {
      return PARSER;
    }

    public interface ComponentOrBuilder
        extends com.google.protobuf.MessageOrBuilder {

      // optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;</code>
       */
      boolean hasAnnotationBoundary();
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;</code>
       */
      org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary getAnnotationBoundary();
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;</code>
       */
      org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundaryOrBuilder getAnnotationBoundaryOrBuilder();

      // optional string characters = 2;
      /**
       * <code>optional string characters = 2;</code>
       */
      boolean hasCharacters();
      /**
       * <code>optional string characters = 2;</code>
       */
      java.lang.String getCharacters();
      /**
       * <code>optional string characters = 2;</code>
       */
      com.google.protobuf.ByteString
          getCharactersBytes();

      // optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;</code>
       */
      boolean hasElementStart();
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;</code>
       */
      org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart getElementStart();
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;</code>
       */
      org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStartOrBuilder getElementStartOrBuilder();

      // optional bool element_end = 4;
      /**
       * <code>optional bool element_end = 4;</code>
       */
      boolean hasElementEnd();
      /**
       * <code>optional bool element_end = 4;</code>
       */
      boolean getElementEnd();

      // optional int32 retain_item_count = 5;
      /**
       * <code>optional int32 retain_item_count = 5;</code>
       */
      boolean hasRetainItemCount();
      /**
       * <code>optional int32 retain_item_count = 5;</code>
       */
      int getRetainItemCount();

      // optional string delete_characters = 6;
      /**
       * <code>optional string delete_characters = 6;</code>
       */
      boolean hasDeleteCharacters();
      /**
       * <code>optional string delete_characters = 6;</code>
       */
      java.lang.String getDeleteCharacters();
      /**
       * <code>optional string delete_characters = 6;</code>
       */
      com.google.protobuf.ByteString
          getDeleteCharactersBytes();

      // optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;</code>
       */
      boolean hasDeleteElementStart();
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;</code>
       */
      org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart getDeleteElementStart();
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;</code>
       */
      org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStartOrBuilder getDeleteElementStartOrBuilder();

      // optional bool delete_element_end = 8;
      /**
       * <code>optional bool delete_element_end = 8;</code>
       */
      boolean hasDeleteElementEnd();
      /**
       * <code>optional bool delete_element_end = 8;</code>
       */
      boolean getDeleteElementEnd();

      // optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;</code>
       */
      boolean hasReplaceAttributes();
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;</code>
       */
      org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes getReplaceAttributes();
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;</code>
       */
      org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributesOrBuilder getReplaceAttributesOrBuilder();

      // optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;</code>
       */
      boolean hasUpdateAttributes();
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;</code>
       */
      org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes getUpdateAttributes();
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;</code>
       */
      org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributesOrBuilder getUpdateAttributesOrBuilder();
    }
    /**
     * Protobuf type {@code federation.ProtocolDocumentOperation.Component}
     *
     * <pre>
     **
     * A component of a document operation.  One (and only one) of the component
     * types must be set.
     * </pre>
     */
    public static final class Component extends
        com.google.protobuf.GeneratedMessage
        implements ComponentOrBuilder {
      // Use Component.newBuilder() to construct.
      private Component(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
        super(builder);
        this.unknownFields = builder.getUnknownFields();
      }
      private Component(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

      private static final Component defaultInstance;
      public static Component getDefaultInstance() {
        return defaultInstance;
      }

      public Component getDefaultInstanceForType() {
        return defaultInstance;
      }

      private final com.google.protobuf.UnknownFieldSet unknownFields;
      @java.lang.Override
      public final com.google.protobuf.UnknownFieldSet
          getUnknownFields() {
        return this.unknownFields;
      }
      private Component(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        initFields();
        int mutable_bitField0_ = 0;
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
            com.google.protobuf.UnknownFieldSet.newBuilder();
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              default: {
                if (!parseUnknownField(input, unknownFields,
                                       extensionRegistry, tag)) {
                  done = true;
                }
                break;
              }
              case 10: {
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.Builder subBuilder = null;
                if (((bitField0_ & 0x00000001) == 0x00000001)) {
                  subBuilder = annotationBoundary_.toBuilder();
                }
                annotationBoundary_ = input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.PARSER, extensionRegistry);
                if (subBuilder != null) {
                  subBuilder.mergeFrom(annotationBoundary_);
                  annotationBoundary_ = subBuilder.buildPartial();
                }
                bitField0_ |= 0x00000001;
                break;
              }
              case 18: {
                bitField0_ |= 0x00000002;
                characters_ = input.readBytes();
                break;
              }
              case 26: {
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.Builder subBuilder = null;
                if (((bitField0_ & 0x00000004) == 0x00000004)) {
                  subBuilder = elementStart_.toBuilder();
                }
                elementStart_ = input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.PARSER, extensionRegistry);
                if (subBuilder != null) {
                  subBuilder.mergeFrom(elementStart_);
                  elementStart_ = subBuilder.buildPartial();
                }
                bitField0_ |= 0x00000004;
                break;
              }
              case 32: {
                bitField0_ |= 0x00000008;
                elementEnd_ = input.readBool();
                break;
              }
              case 40: {
                bitField0_ |= 0x00000010;
                retainItemCount_ = input.readInt32();
                break;
              }
              case 50: {
                bitField0_ |= 0x00000020;
                deleteCharacters_ = input.readBytes();
                break;
              }
              case 58: {
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.Builder subBuilder = null;
                if (((bitField0_ & 0x00000040) == 0x00000040)) {
                  subBuilder = deleteElementStart_.toBuilder();
                }
                deleteElementStart_ = input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.PARSER, extensionRegistry);
                if (subBuilder != null) {
                  subBuilder.mergeFrom(deleteElementStart_);
                  deleteElementStart_ = subBuilder.buildPartial();
                }
                bitField0_ |= 0x00000040;
                break;
              }
              case 64: {
                bitField0_ |= 0x00000080;
                deleteElementEnd_ = input.readBool();
                break;
              }
              case 74: {
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.Builder subBuilder = null;
                if (((bitField0_ & 0x00000100) == 0x00000100)) {
                  subBuilder = replaceAttributes_.toBuilder();
                }
                replaceAttributes_ = input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.PARSER, extensionRegistry);
                if (subBuilder != null) {
                  subBuilder.mergeFrom(replaceAttributes_);
                  replaceAttributes_ = subBuilder.buildPartial();
                }
                bitField0_ |= 0x00000100;
                break;
              }
              case 82: {
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.Builder subBuilder = null;
                if (((bitField0_ & 0x00000200) == 0x00000200)) {
                  subBuilder = updateAttributes_.toBuilder();
                }
                updateAttributes_ = input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.PARSER, extensionRegistry);
                if (subBuilder != null) {
                  subBuilder.mergeFrom(updateAttributes_);
                  updateAttributes_ = subBuilder.buildPartial();
                }
                bitField0_ |= 0x00000200;
                break;
              }
            }
          }
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(this);
        } catch (java.io.IOException e) {
          throw new com.google.protobuf.InvalidProtocolBufferException(
              e.getMessage()).setUnfinishedMessage(this);
        } finally {
          this.unknownFields = unknownFields.build();
          makeExtensionsImmutable();
        }
      }
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.class, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.Builder.class);
      }

      public static com.google.protobuf.Parser<Component> PARSER =
          new com.google.protobuf.AbstractParser<Component>() {
        public Component parsePartialFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return new Component(input, extensionRegistry);
        }
      };

      @java.lang.Override
      public com.google.protobuf.Parser<Component> getParserForType() {
        return PARSER;
      }

      public interface KeyValuePairOrBuilder
          extends com.google.protobuf.MessageOrBuilder {

        // required string key = 1;
        /**
         * <code>required string key = 1;</code>
         */
        boolean hasKey();
        /**
         * <code>required string key = 1;</code>
         */
        java.lang.String getKey();
        /**
         * <code>required string key = 1;</code>
         */
        com.google.protobuf.ByteString
            getKeyBytes();

        // required string value = 2;
        /**
         * <code>required string value = 2;</code>
         */
        boolean hasValue();
        /**
         * <code>required string value = 2;</code>
         */
        java.lang.String getValue();
        /**
         * <code>required string value = 2;</code>
         */
        com.google.protobuf.ByteString
            getValueBytes();
      }
      /**
       * Protobuf type {@code federation.ProtocolDocumentOperation.Component.KeyValuePair}
       */
      public static final class KeyValuePair extends
          com.google.protobuf.GeneratedMessage
          implements KeyValuePairOrBuilder {
        // Use KeyValuePair.newBuilder() to construct.
        private KeyValuePair(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
          super(builder);
          this.unknownFields = builder.getUnknownFields();
        }
        private KeyValuePair(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

        private static final KeyValuePair defaultInstance;
        public static KeyValuePair getDefaultInstance() {
          return defaultInstance;
        }

        public KeyValuePair getDefaultInstanceForType() {
          return defaultInstance;
        }

        private final com.google.protobuf.UnknownFieldSet unknownFields;
        @java.lang.Override
        public final com.google.protobuf.UnknownFieldSet
            getUnknownFields() {
          return this.unknownFields;
        }
        private KeyValuePair(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          initFields();
          int mutable_bitField0_ = 0;
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
              com.google.protobuf.UnknownFieldSet.newBuilder();
          try {
            boolean done = false;
            while (!done) {
              int tag = input.readTag();
              switch (tag) {
                case 0:
                  done = true;
                  break;
                default: {
                  if (!parseUnknownField(input, unknownFields,
                                         extensionRegistry, tag)) {
                    done = true;
                  }
                  break;
                }
                case 10: {
                  bitField0_ |= 0x00000001;
                  key_ = input.readBytes();
                  break;
                }
                case 18: {
                  bitField0_ |= 0x00000002;
                  value_ = input.readBytes();
                  break;
                }
              }
            }
          } catch (com.google.protobuf.InvalidProtocolBufferException e) {
            throw e.setUnfinishedMessage(this);
          } catch (java.io.IOException e) {
            throw new com.google.protobuf.InvalidProtocolBufferException(
                e.getMessage()).setUnfinishedMessage(this);
          } finally {
            this.unknownFields = unknownFields.build();
            makeExtensionsImmutable();
          }
        }
        public static final com.google.protobuf.Descriptors.Descriptor
            getDescriptor() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_KeyValuePair_descriptor;
        }

        protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
            internalGetFieldAccessorTable() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_KeyValuePair_fieldAccessorTable
              .ensureFieldAccessorsInitialized(
                  org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.class, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder.class);
        }

        public static com.google.protobuf.Parser<KeyValuePair> PARSER =
            new com.google.protobuf.AbstractParser<KeyValuePair>() {
          public KeyValuePair parsePartialFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws com.google.protobuf.InvalidProtocolBufferException {
            return new KeyValuePair(input, extensionRegistry);
          }
        };

        @java.lang.Override
        public com.google.protobuf.Parser<KeyValuePair> getParserForType() {
          return PARSER;
        }

        private int bitField0_;
        // required string key = 1;
        public static final int KEY_FIELD_NUMBER = 1;
        private java.lang.Object key_;
        /**
         * <code>required string key = 1;</code>
         */
        public boolean hasKey() {
          return ((bitField0_ & 0x00000001) == 0x00000001);
        }
        /**
         * <code>required string key = 1;</code>
         */
        public java.lang.String getKey() {
          java.lang.Object ref = key_;
          if (ref instanceof java.lang.String) {
            return (java.lang.String) ref;
          } else {
            com.google.protobuf.ByteString bs = 
                (com.google.protobuf.ByteString) ref;
            java.lang.String s = bs.toStringUtf8();
            if (bs.isValidUtf8()) {
              key_ = s;
            }
            return s;
          }
        }
        /**
         * <code>required string key = 1;</code>
         */
        public com.google.protobuf.ByteString
            getKeyBytes() {
          java.lang.Object ref = key_;
          if (ref instanceof java.lang.String) {
            com.google.protobuf.ByteString b = 
                com.google.protobuf.ByteString.copyFromUtf8(
                    (java.lang.String) ref);
            key_ = b;
            return b;
          } else {
            return (com.google.protobuf.ByteString) ref;
          }
        }

        // required string value = 2;
        public static final int VALUE_FIELD_NUMBER = 2;
        private java.lang.Object value_;
        /**
         * <code>required string value = 2;</code>
         */
        public boolean hasValue() {
          return ((bitField0_ & 0x00000002) == 0x00000002);
        }
        /**
         * <code>required string value = 2;</code>
         */
        public java.lang.String getValue() {
          java.lang.Object ref = value_;
          if (ref instanceof java.lang.String) {
            return (java.lang.String) ref;
          } else {
            com.google.protobuf.ByteString bs = 
                (com.google.protobuf.ByteString) ref;
            java.lang.String s = bs.toStringUtf8();
            if (bs.isValidUtf8()) {
              value_ = s;
            }
            return s;
          }
        }
        /**
         * <code>required string value = 2;</code>
         */
        public com.google.protobuf.ByteString
            getValueBytes() {
          java.lang.Object ref = value_;
          if (ref instanceof java.lang.String) {
            com.google.protobuf.ByteString b = 
                com.google.protobuf.ByteString.copyFromUtf8(
                    (java.lang.String) ref);
            value_ = b;
            return b;
          } else {
            return (com.google.protobuf.ByteString) ref;
          }
        }

        private void initFields() {
          key_ = "";
          value_ = "";
        }
        private byte memoizedIsInitialized = -1;
        public final boolean isInitialized() {
          byte isInitialized = memoizedIsInitialized;
          if (isInitialized != -1) return isInitialized == 1;

          if (!hasKey()) {
            memoizedIsInitialized = 0;
            return false;
          }
          if (!hasValue()) {
            memoizedIsInitialized = 0;
            return false;
          }
          memoizedIsInitialized = 1;
          return true;
        }

        public void writeTo(com.google.protobuf.CodedOutputStream output)
                            throws java.io.IOException {
          getSerializedSize();
          if (((bitField0_ & 0x00000001) == 0x00000001)) {
            output.writeBytes(1, getKeyBytes());
          }
          if (((bitField0_ & 0x00000002) == 0x00000002)) {
            output.writeBytes(2, getValueBytes());
          }
          getUnknownFields().writeTo(output);
        }

        private int memoizedSerializedSize = -1;
        public int getSerializedSize() {
          int size = memoizedSerializedSize;
          if (size != -1) return size;

          size = 0;
          if (((bitField0_ & 0x00000001) == 0x00000001)) {
            size += com.google.protobuf.CodedOutputStream
              .computeBytesSize(1, getKeyBytes());
          }
          if (((bitField0_ & 0x00000002) == 0x00000002)) {
            size += com.google.protobuf.CodedOutputStream
              .computeBytesSize(2, getValueBytes());
          }
          size += getUnknownFields().getSerializedSize();
          memoizedSerializedSize = size;
          return size;
        }

        private static final long serialVersionUID = 0L;
        @java.lang.Override
        protected java.lang.Object writeReplace()
            throws java.io.ObjectStreamException {
          return super.writeReplace();
        }

        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair parseFrom(
            com.google.protobuf.ByteString data)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair parseFrom(
            com.google.protobuf.ByteString data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair parseFrom(byte[] data)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair parseFrom(
            byte[] data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair parseFrom(java.io.InputStream input)
            throws java.io.IOException {
          return PARSER.parseFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair parseFrom(
            java.io.InputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseFrom(input, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair parseDelimitedFrom(java.io.InputStream input)
            throws java.io.IOException {
          return PARSER.parseDelimitedFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair parseDelimitedFrom(
            java.io.InputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseDelimitedFrom(input, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair parseFrom(
            com.google.protobuf.CodedInputStream input)
            throws java.io.IOException {
          return PARSER.parseFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair parseFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseFrom(input, extensionRegistry);
        }

        public static Builder newBuilder() { return Builder.create(); }
        public Builder newBuilderForType() { return newBuilder(); }
        public static Builder newBuilder(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair prototype) {
          return newBuilder().mergeFrom(prototype);
        }
        public Builder toBuilder() { return newBuilder(this); }

        @java.lang.Override
        protected Builder newBuilderForType(
            com.google.protobuf.GeneratedMessage.BuilderParent parent) {
          Builder builder = new Builder(parent);
          return builder;
        }
        /**
         * Protobuf type {@code federation.ProtocolDocumentOperation.Component.KeyValuePair}
         */
        public static final class Builder extends
            com.google.protobuf.GeneratedMessage.Builder<Builder>
           implements org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder {
          public static final com.google.protobuf.Descriptors.Descriptor
              getDescriptor() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_KeyValuePair_descriptor;
          }

          protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
              internalGetFieldAccessorTable() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_KeyValuePair_fieldAccessorTable
                .ensureFieldAccessorsInitialized(
                    org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.class, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder.class);
          }

          // Construct using org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.newBuilder()
          private Builder() {
            maybeForceBuilderInitialization();
          }

          private Builder(
              com.google.protobuf.GeneratedMessage.BuilderParent parent) {
            super(parent);
            maybeForceBuilderInitialization();
          }
          private void maybeForceBuilderInitialization() {
            if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
            }
          }
          private static Builder create() {
            return new Builder();
          }

          public Builder clear() {
            super.clear();
            key_ = "";
            bitField0_ = (bitField0_ & ~0x00000001);
            value_ = "";
            bitField0_ = (bitField0_ & ~0x00000002);
            return this;
          }

          public Builder clone() {
            return create().mergeFrom(buildPartial());
          }

          public com.google.protobuf.Descriptors.Descriptor
              getDescriptorForType() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_KeyValuePair_descriptor;
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair getDefaultInstanceForType() {
            return org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.getDefaultInstance();
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair build() {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair result = buildPartial();
            if (!result.isInitialized()) {
              throw newUninitializedMessageException(result);
            }
            return result;
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair buildPartial() {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair result = new org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair(this);
            int from_bitField0_ = bitField0_;
            int to_bitField0_ = 0;
            if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
              to_bitField0_ |= 0x00000001;
            }
            result.key_ = key_;
            if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
              to_bitField0_ |= 0x00000002;
            }
            result.value_ = value_;
            result.bitField0_ = to_bitField0_;
            onBuilt();
            return result;
          }

          public Builder mergeFrom(com.google.protobuf.Message other) {
            if (other instanceof org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair) {
              return mergeFrom((org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair)other);
            } else {
              super.mergeFrom(other);
              return this;
            }
          }

          public Builder mergeFrom(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair other) {
            if (other == org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.getDefaultInstance()) return this;
            if (other.hasKey()) {
              bitField0_ |= 0x00000001;
              key_ = other.key_;
              onChanged();
            }
            if (other.hasValue()) {
              bitField0_ |= 0x00000002;
              value_ = other.value_;
              onChanged();
            }
            this.mergeUnknownFields(other.getUnknownFields());
            return this;
          }

          public final boolean isInitialized() {
            if (!hasKey()) {
              
              return false;
            }
            if (!hasValue()) {
              
              return false;
            }
            return true;
          }

          public Builder mergeFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws java.io.IOException {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair parsedMessage = null;
            try {
              parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
            } catch (com.google.protobuf.InvalidProtocolBufferException e) {
              parsedMessage = (org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair) e.getUnfinishedMessage();
              throw e;
            } finally {
              if (parsedMessage != null) {
                mergeFrom(parsedMessage);
              }
            }
            return this;
          }
          private int bitField0_;

          // required string key = 1;
          private java.lang.Object key_ = "";
          /**
           * <code>required string key = 1;</code>
           */
          public boolean hasKey() {
            return ((bitField0_ & 0x00000001) == 0x00000001);
          }
          /**
           * <code>required string key = 1;</code>
           */
          public java.lang.String getKey() {
            java.lang.Object ref = key_;
            if (!(ref instanceof java.lang.String)) {
              java.lang.String s = ((com.google.protobuf.ByteString) ref)
                  .toStringUtf8();
              key_ = s;
              return s;
            } else {
              return (java.lang.String) ref;
            }
          }
          /**
           * <code>required string key = 1;</code>
           */
          public com.google.protobuf.ByteString
              getKeyBytes() {
            java.lang.Object ref = key_;
            if (ref instanceof String) {
              com.google.protobuf.ByteString b = 
                  com.google.protobuf.ByteString.copyFromUtf8(
                      (java.lang.String) ref);
              key_ = b;
              return b;
            } else {
              return (com.google.protobuf.ByteString) ref;
            }
          }
          /**
           * <code>required string key = 1;</code>
           */
          public Builder setKey(
              java.lang.String value) {
            if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
            key_ = value;
            onChanged();
            return this;
          }
          /**
           * <code>required string key = 1;</code>
           */
          public Builder clearKey() {
            bitField0_ = (bitField0_ & ~0x00000001);
            key_ = getDefaultInstance().getKey();
            onChanged();
            return this;
          }
          /**
           * <code>required string key = 1;</code>
           */
          public Builder setKeyBytes(
              com.google.protobuf.ByteString value) {
            if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
            key_ = value;
            onChanged();
            return this;
          }

          // required string value = 2;
          private java.lang.Object value_ = "";
          /**
           * <code>required string value = 2;</code>
           */
          public boolean hasValue() {
            return ((bitField0_ & 0x00000002) == 0x00000002);
          }
          /**
           * <code>required string value = 2;</code>
           */
          public java.lang.String getValue() {
            java.lang.Object ref = value_;
            if (!(ref instanceof java.lang.String)) {
              java.lang.String s = ((com.google.protobuf.ByteString) ref)
                  .toStringUtf8();
              value_ = s;
              return s;
            } else {
              return (java.lang.String) ref;
            }
          }
          /**
           * <code>required string value = 2;</code>
           */
          public com.google.protobuf.ByteString
              getValueBytes() {
            java.lang.Object ref = value_;
            if (ref instanceof String) {
              com.google.protobuf.ByteString b = 
                  com.google.protobuf.ByteString.copyFromUtf8(
                      (java.lang.String) ref);
              value_ = b;
              return b;
            } else {
              return (com.google.protobuf.ByteString) ref;
            }
          }
          /**
           * <code>required string value = 2;</code>
           */
          public Builder setValue(
              java.lang.String value) {
            if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
            value_ = value;
            onChanged();
            return this;
          }
          /**
           * <code>required string value = 2;</code>
           */
          public Builder clearValue() {
            bitField0_ = (bitField0_ & ~0x00000002);
            value_ = getDefaultInstance().getValue();
            onChanged();
            return this;
          }
          /**
           * <code>required string value = 2;</code>
           */
          public Builder setValueBytes(
              com.google.protobuf.ByteString value) {
            if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
            value_ = value;
            onChanged();
            return this;
          }

          // @@protoc_insertion_point(builder_scope:federation.ProtocolDocumentOperation.Component.KeyValuePair)
        }

        static {
          defaultInstance = new KeyValuePair(true);
          defaultInstance.initFields();
        }

        // @@protoc_insertion_point(class_scope:federation.ProtocolDocumentOperation.Component.KeyValuePair)
      }

      public interface KeyValueUpdateOrBuilder
          extends com.google.protobuf.MessageOrBuilder {

        // required string key = 1;
        /**
         * <code>required string key = 1;</code>
         */
        boolean hasKey();
        /**
         * <code>required string key = 1;</code>
         */
        java.lang.String getKey();
        /**
         * <code>required string key = 1;</code>
         */
        com.google.protobuf.ByteString
            getKeyBytes();

        // optional string old_value = 2;
        /**
         * <code>optional string old_value = 2;</code>
         *
         * <pre>
         * Absent field means that the attribute was absent/the annotation
         * was null.
         * </pre>
         */
        boolean hasOldValue();
        /**
         * <code>optional string old_value = 2;</code>
         *
         * <pre>
         * Absent field means that the attribute was absent/the annotation
         * was null.
         * </pre>
         */
        java.lang.String getOldValue();
        /**
         * <code>optional string old_value = 2;</code>
         *
         * <pre>
         * Absent field means that the attribute was absent/the annotation
         * was null.
         * </pre>
         */
        com.google.protobuf.ByteString
            getOldValueBytes();

        // optional string new_value = 3;
        /**
         * <code>optional string new_value = 3;</code>
         *
         * <pre>
         * Absent field means that the attribute should be removed/the annotation
         * should be set to null.
         * </pre>
         */
        boolean hasNewValue();
        /**
         * <code>optional string new_value = 3;</code>
         *
         * <pre>
         * Absent field means that the attribute should be removed/the annotation
         * should be set to null.
         * </pre>
         */
        java.lang.String getNewValue();
        /**
         * <code>optional string new_value = 3;</code>
         *
         * <pre>
         * Absent field means that the attribute should be removed/the annotation
         * should be set to null.
         * </pre>
         */
        com.google.protobuf.ByteString
            getNewValueBytes();
      }
      /**
       * Protobuf type {@code federation.ProtocolDocumentOperation.Component.KeyValueUpdate}
       */
      public static final class KeyValueUpdate extends
          com.google.protobuf.GeneratedMessage
          implements KeyValueUpdateOrBuilder {
        // Use KeyValueUpdate.newBuilder() to construct.
        private KeyValueUpdate(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
          super(builder);
          this.unknownFields = builder.getUnknownFields();
        }
        private KeyValueUpdate(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

        private static final KeyValueUpdate defaultInstance;
        public static KeyValueUpdate getDefaultInstance() {
          return defaultInstance;
        }

        public KeyValueUpdate getDefaultInstanceForType() {
          return defaultInstance;
        }

        private final com.google.protobuf.UnknownFieldSet unknownFields;
        @java.lang.Override
        public final com.google.protobuf.UnknownFieldSet
            getUnknownFields() {
          return this.unknownFields;
        }
        private KeyValueUpdate(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          initFields();
          int mutable_bitField0_ = 0;
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
              com.google.protobuf.UnknownFieldSet.newBuilder();
          try {
            boolean done = false;
            while (!done) {
              int tag = input.readTag();
              switch (tag) {
                case 0:
                  done = true;
                  break;
                default: {
                  if (!parseUnknownField(input, unknownFields,
                                         extensionRegistry, tag)) {
                    done = true;
                  }
                  break;
                }
                case 10: {
                  bitField0_ |= 0x00000001;
                  key_ = input.readBytes();
                  break;
                }
                case 18: {
                  bitField0_ |= 0x00000002;
                  oldValue_ = input.readBytes();
                  break;
                }
                case 26: {
                  bitField0_ |= 0x00000004;
                  newValue_ = input.readBytes();
                  break;
                }
              }
            }
          } catch (com.google.protobuf.InvalidProtocolBufferException e) {
            throw e.setUnfinishedMessage(this);
          } catch (java.io.IOException e) {
            throw new com.google.protobuf.InvalidProtocolBufferException(
                e.getMessage()).setUnfinishedMessage(this);
          } finally {
            this.unknownFields = unknownFields.build();
            makeExtensionsImmutable();
          }
        }
        public static final com.google.protobuf.Descriptors.Descriptor
            getDescriptor() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_KeyValueUpdate_descriptor;
        }

        protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
            internalGetFieldAccessorTable() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_KeyValueUpdate_fieldAccessorTable
              .ensureFieldAccessorsInitialized(
                  org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.class, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder.class);
        }

        public static com.google.protobuf.Parser<KeyValueUpdate> PARSER =
            new com.google.protobuf.AbstractParser<KeyValueUpdate>() {
          public KeyValueUpdate parsePartialFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws com.google.protobuf.InvalidProtocolBufferException {
            return new KeyValueUpdate(input, extensionRegistry);
          }
        };

        @java.lang.Override
        public com.google.protobuf.Parser<KeyValueUpdate> getParserForType() {
          return PARSER;
        }

        private int bitField0_;
        // required string key = 1;
        public static final int KEY_FIELD_NUMBER = 1;
        private java.lang.Object key_;
        /**
         * <code>required string key = 1;</code>
         */
        public boolean hasKey() {
          return ((bitField0_ & 0x00000001) == 0x00000001);
        }
        /**
         * <code>required string key = 1;</code>
         */
        public java.lang.String getKey() {
          java.lang.Object ref = key_;
          if (ref instanceof java.lang.String) {
            return (java.lang.String) ref;
          } else {
            com.google.protobuf.ByteString bs = 
                (com.google.protobuf.ByteString) ref;
            java.lang.String s = bs.toStringUtf8();
            if (bs.isValidUtf8()) {
              key_ = s;
            }
            return s;
          }
        }
        /**
         * <code>required string key = 1;</code>
         */
        public com.google.protobuf.ByteString
            getKeyBytes() {
          java.lang.Object ref = key_;
          if (ref instanceof java.lang.String) {
            com.google.protobuf.ByteString b = 
                com.google.protobuf.ByteString.copyFromUtf8(
                    (java.lang.String) ref);
            key_ = b;
            return b;
          } else {
            return (com.google.protobuf.ByteString) ref;
          }
        }

        // optional string old_value = 2;
        public static final int OLD_VALUE_FIELD_NUMBER = 2;
        private java.lang.Object oldValue_;
        /**
         * <code>optional string old_value = 2;</code>
         *
         * <pre>
         * Absent field means that the attribute was absent/the annotation
         * was null.
         * </pre>
         */
        public boolean hasOldValue() {
          return ((bitField0_ & 0x00000002) == 0x00000002);
        }
        /**
         * <code>optional string old_value = 2;</code>
         *
         * <pre>
         * Absent field means that the attribute was absent/the annotation
         * was null.
         * </pre>
         */
        public java.lang.String getOldValue() {
          java.lang.Object ref = oldValue_;
          if (ref instanceof java.lang.String) {
            return (java.lang.String) ref;
          } else {
            com.google.protobuf.ByteString bs = 
                (com.google.protobuf.ByteString) ref;
            java.lang.String s = bs.toStringUtf8();
            if (bs.isValidUtf8()) {
              oldValue_ = s;
            }
            return s;
          }
        }
        /**
         * <code>optional string old_value = 2;</code>
         *
         * <pre>
         * Absent field means that the attribute was absent/the annotation
         * was null.
         * </pre>
         */
        public com.google.protobuf.ByteString
            getOldValueBytes() {
          java.lang.Object ref = oldValue_;
          if (ref instanceof java.lang.String) {
            com.google.protobuf.ByteString b = 
                com.google.protobuf.ByteString.copyFromUtf8(
                    (java.lang.String) ref);
            oldValue_ = b;
            return b;
          } else {
            return (com.google.protobuf.ByteString) ref;
          }
        }

        // optional string new_value = 3;
        public static final int NEW_VALUE_FIELD_NUMBER = 3;
        private java.lang.Object newValue_;
        /**
         * <code>optional string new_value = 3;</code>
         *
         * <pre>
         * Absent field means that the attribute should be removed/the annotation
         * should be set to null.
         * </pre>
         */
        public boolean hasNewValue() {
          return ((bitField0_ & 0x00000004) == 0x00000004);
        }
        /**
         * <code>optional string new_value = 3;</code>
         *
         * <pre>
         * Absent field means that the attribute should be removed/the annotation
         * should be set to null.
         * </pre>
         */
        public java.lang.String getNewValue() {
          java.lang.Object ref = newValue_;
          if (ref instanceof java.lang.String) {
            return (java.lang.String) ref;
          } else {
            com.google.protobuf.ByteString bs = 
                (com.google.protobuf.ByteString) ref;
            java.lang.String s = bs.toStringUtf8();
            if (bs.isValidUtf8()) {
              newValue_ = s;
            }
            return s;
          }
        }
        /**
         * <code>optional string new_value = 3;</code>
         *
         * <pre>
         * Absent field means that the attribute should be removed/the annotation
         * should be set to null.
         * </pre>
         */
        public com.google.protobuf.ByteString
            getNewValueBytes() {
          java.lang.Object ref = newValue_;
          if (ref instanceof java.lang.String) {
            com.google.protobuf.ByteString b = 
                com.google.protobuf.ByteString.copyFromUtf8(
                    (java.lang.String) ref);
            newValue_ = b;
            return b;
          } else {
            return (com.google.protobuf.ByteString) ref;
          }
        }

        private void initFields() {
          key_ = "";
          oldValue_ = "";
          newValue_ = "";
        }
        private byte memoizedIsInitialized = -1;
        public final boolean isInitialized() {
          byte isInitialized = memoizedIsInitialized;
          if (isInitialized != -1) return isInitialized == 1;

          if (!hasKey()) {
            memoizedIsInitialized = 0;
            return false;
          }
          memoizedIsInitialized = 1;
          return true;
        }

        public void writeTo(com.google.protobuf.CodedOutputStream output)
                            throws java.io.IOException {
          getSerializedSize();
          if (((bitField0_ & 0x00000001) == 0x00000001)) {
            output.writeBytes(1, getKeyBytes());
          }
          if (((bitField0_ & 0x00000002) == 0x00000002)) {
            output.writeBytes(2, getOldValueBytes());
          }
          if (((bitField0_ & 0x00000004) == 0x00000004)) {
            output.writeBytes(3, getNewValueBytes());
          }
          getUnknownFields().writeTo(output);
        }

        private int memoizedSerializedSize = -1;
        public int getSerializedSize() {
          int size = memoizedSerializedSize;
          if (size != -1) return size;

          size = 0;
          if (((bitField0_ & 0x00000001) == 0x00000001)) {
            size += com.google.protobuf.CodedOutputStream
              .computeBytesSize(1, getKeyBytes());
          }
          if (((bitField0_ & 0x00000002) == 0x00000002)) {
            size += com.google.protobuf.CodedOutputStream
              .computeBytesSize(2, getOldValueBytes());
          }
          if (((bitField0_ & 0x00000004) == 0x00000004)) {
            size += com.google.protobuf.CodedOutputStream
              .computeBytesSize(3, getNewValueBytes());
          }
          size += getUnknownFields().getSerializedSize();
          memoizedSerializedSize = size;
          return size;
        }

        private static final long serialVersionUID = 0L;
        @java.lang.Override
        protected java.lang.Object writeReplace()
            throws java.io.ObjectStreamException {
          return super.writeReplace();
        }

        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate parseFrom(
            com.google.protobuf.ByteString data)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate parseFrom(
            com.google.protobuf.ByteString data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate parseFrom(byte[] data)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate parseFrom(
            byte[] data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate parseFrom(java.io.InputStream input)
            throws java.io.IOException {
          return PARSER.parseFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate parseFrom(
            java.io.InputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseFrom(input, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate parseDelimitedFrom(java.io.InputStream input)
            throws java.io.IOException {
          return PARSER.parseDelimitedFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate parseDelimitedFrom(
            java.io.InputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseDelimitedFrom(input, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate parseFrom(
            com.google.protobuf.CodedInputStream input)
            throws java.io.IOException {
          return PARSER.parseFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate parseFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseFrom(input, extensionRegistry);
        }

        public static Builder newBuilder() { return Builder.create(); }
        public Builder newBuilderForType() { return newBuilder(); }
        public static Builder newBuilder(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate prototype) {
          return newBuilder().mergeFrom(prototype);
        }
        public Builder toBuilder() { return newBuilder(this); }

        @java.lang.Override
        protected Builder newBuilderForType(
            com.google.protobuf.GeneratedMessage.BuilderParent parent) {
          Builder builder = new Builder(parent);
          return builder;
        }
        /**
         * Protobuf type {@code federation.ProtocolDocumentOperation.Component.KeyValueUpdate}
         */
        public static final class Builder extends
            com.google.protobuf.GeneratedMessage.Builder<Builder>
           implements org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder {
          public static final com.google.protobuf.Descriptors.Descriptor
              getDescriptor() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_KeyValueUpdate_descriptor;
          }

          protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
              internalGetFieldAccessorTable() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_KeyValueUpdate_fieldAccessorTable
                .ensureFieldAccessorsInitialized(
                    org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.class, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder.class);
          }

          // Construct using org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.newBuilder()
          private Builder() {
            maybeForceBuilderInitialization();
          }

          private Builder(
              com.google.protobuf.GeneratedMessage.BuilderParent parent) {
            super(parent);
            maybeForceBuilderInitialization();
          }
          private void maybeForceBuilderInitialization() {
            if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
            }
          }
          private static Builder create() {
            return new Builder();
          }

          public Builder clear() {
            super.clear();
            key_ = "";
            bitField0_ = (bitField0_ & ~0x00000001);
            oldValue_ = "";
            bitField0_ = (bitField0_ & ~0x00000002);
            newValue_ = "";
            bitField0_ = (bitField0_ & ~0x00000004);
            return this;
          }

          public Builder clone() {
            return create().mergeFrom(buildPartial());
          }

          public com.google.protobuf.Descriptors.Descriptor
              getDescriptorForType() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_KeyValueUpdate_descriptor;
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate getDefaultInstanceForType() {
            return org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.getDefaultInstance();
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate build() {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate result = buildPartial();
            if (!result.isInitialized()) {
              throw newUninitializedMessageException(result);
            }
            return result;
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate buildPartial() {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate result = new org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate(this);
            int from_bitField0_ = bitField0_;
            int to_bitField0_ = 0;
            if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
              to_bitField0_ |= 0x00000001;
            }
            result.key_ = key_;
            if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
              to_bitField0_ |= 0x00000002;
            }
            result.oldValue_ = oldValue_;
            if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
              to_bitField0_ |= 0x00000004;
            }
            result.newValue_ = newValue_;
            result.bitField0_ = to_bitField0_;
            onBuilt();
            return result;
          }

          public Builder mergeFrom(com.google.protobuf.Message other) {
            if (other instanceof org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate) {
              return mergeFrom((org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate)other);
            } else {
              super.mergeFrom(other);
              return this;
            }
          }

          public Builder mergeFrom(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate other) {
            if (other == org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.getDefaultInstance()) return this;
            if (other.hasKey()) {
              bitField0_ |= 0x00000001;
              key_ = other.key_;
              onChanged();
            }
            if (other.hasOldValue()) {
              bitField0_ |= 0x00000002;
              oldValue_ = other.oldValue_;
              onChanged();
            }
            if (other.hasNewValue()) {
              bitField0_ |= 0x00000004;
              newValue_ = other.newValue_;
              onChanged();
            }
            this.mergeUnknownFields(other.getUnknownFields());
            return this;
          }

          public final boolean isInitialized() {
            if (!hasKey()) {
              
              return false;
            }
            return true;
          }

          public Builder mergeFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws java.io.IOException {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate parsedMessage = null;
            try {
              parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
            } catch (com.google.protobuf.InvalidProtocolBufferException e) {
              parsedMessage = (org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate) e.getUnfinishedMessage();
              throw e;
            } finally {
              if (parsedMessage != null) {
                mergeFrom(parsedMessage);
              }
            }
            return this;
          }
          private int bitField0_;

          // required string key = 1;
          private java.lang.Object key_ = "";
          /**
           * <code>required string key = 1;</code>
           */
          public boolean hasKey() {
            return ((bitField0_ & 0x00000001) == 0x00000001);
          }
          /**
           * <code>required string key = 1;</code>
           */
          public java.lang.String getKey() {
            java.lang.Object ref = key_;
            if (!(ref instanceof java.lang.String)) {
              java.lang.String s = ((com.google.protobuf.ByteString) ref)
                  .toStringUtf8();
              key_ = s;
              return s;
            } else {
              return (java.lang.String) ref;
            }
          }
          /**
           * <code>required string key = 1;</code>
           */
          public com.google.protobuf.ByteString
              getKeyBytes() {
            java.lang.Object ref = key_;
            if (ref instanceof String) {
              com.google.protobuf.ByteString b = 
                  com.google.protobuf.ByteString.copyFromUtf8(
                      (java.lang.String) ref);
              key_ = b;
              return b;
            } else {
              return (com.google.protobuf.ByteString) ref;
            }
          }
          /**
           * <code>required string key = 1;</code>
           */
          public Builder setKey(
              java.lang.String value) {
            if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
            key_ = value;
            onChanged();
            return this;
          }
          /**
           * <code>required string key = 1;</code>
           */
          public Builder clearKey() {
            bitField0_ = (bitField0_ & ~0x00000001);
            key_ = getDefaultInstance().getKey();
            onChanged();
            return this;
          }
          /**
           * <code>required string key = 1;</code>
           */
          public Builder setKeyBytes(
              com.google.protobuf.ByteString value) {
            if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
            key_ = value;
            onChanged();
            return this;
          }

          // optional string old_value = 2;
          private java.lang.Object oldValue_ = "";
          /**
           * <code>optional string old_value = 2;</code>
           *
           * <pre>
           * Absent field means that the attribute was absent/the annotation
           * was null.
           * </pre>
           */
          public boolean hasOldValue() {
            return ((bitField0_ & 0x00000002) == 0x00000002);
          }
          /**
           * <code>optional string old_value = 2;</code>
           *
           * <pre>
           * Absent field means that the attribute was absent/the annotation
           * was null.
           * </pre>
           */
          public java.lang.String getOldValue() {
            java.lang.Object ref = oldValue_;
            if (!(ref instanceof java.lang.String)) {
              java.lang.String s = ((com.google.protobuf.ByteString) ref)
                  .toStringUtf8();
              oldValue_ = s;
              return s;
            } else {
              return (java.lang.String) ref;
            }
          }
          /**
           * <code>optional string old_value = 2;</code>
           *
           * <pre>
           * Absent field means that the attribute was absent/the annotation
           * was null.
           * </pre>
           */
          public com.google.protobuf.ByteString
              getOldValueBytes() {
            java.lang.Object ref = oldValue_;
            if (ref instanceof String) {
              com.google.protobuf.ByteString b = 
                  com.google.protobuf.ByteString.copyFromUtf8(
                      (java.lang.String) ref);
              oldValue_ = b;
              return b;
            } else {
              return (com.google.protobuf.ByteString) ref;
            }
          }
          /**
           * <code>optional string old_value = 2;</code>
           *
           * <pre>
           * Absent field means that the attribute was absent/the annotation
           * was null.
           * </pre>
           */
          public Builder setOldValue(
              java.lang.String value) {
            if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
            oldValue_ = value;
            onChanged();
            return this;
          }
          /**
           * <code>optional string old_value = 2;</code>
           *
           * <pre>
           * Absent field means that the attribute was absent/the annotation
           * was null.
           * </pre>
           */
          public Builder clearOldValue() {
            bitField0_ = (bitField0_ & ~0x00000002);
            oldValue_ = getDefaultInstance().getOldValue();
            onChanged();
            return this;
          }
          /**
           * <code>optional string old_value = 2;</code>
           *
           * <pre>
           * Absent field means that the attribute was absent/the annotation
           * was null.
           * </pre>
           */
          public Builder setOldValueBytes(
              com.google.protobuf.ByteString value) {
            if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
            oldValue_ = value;
            onChanged();
            return this;
          }

          // optional string new_value = 3;
          private java.lang.Object newValue_ = "";
          /**
           * <code>optional string new_value = 3;</code>
           *
           * <pre>
           * Absent field means that the attribute should be removed/the annotation
           * should be set to null.
           * </pre>
           */
          public boolean hasNewValue() {
            return ((bitField0_ & 0x00000004) == 0x00000004);
          }
          /**
           * <code>optional string new_value = 3;</code>
           *
           * <pre>
           * Absent field means that the attribute should be removed/the annotation
           * should be set to null.
           * </pre>
           */
          public java.lang.String getNewValue() {
            java.lang.Object ref = newValue_;
            if (!(ref instanceof java.lang.String)) {
              java.lang.String s = ((com.google.protobuf.ByteString) ref)
                  .toStringUtf8();
              newValue_ = s;
              return s;
            } else {
              return (java.lang.String) ref;
            }
          }
          /**
           * <code>optional string new_value = 3;</code>
           *
           * <pre>
           * Absent field means that the attribute should be removed/the annotation
           * should be set to null.
           * </pre>
           */
          public com.google.protobuf.ByteString
              getNewValueBytes() {
            java.lang.Object ref = newValue_;
            if (ref instanceof String) {
              com.google.protobuf.ByteString b = 
                  com.google.protobuf.ByteString.copyFromUtf8(
                      (java.lang.String) ref);
              newValue_ = b;
              return b;
            } else {
              return (com.google.protobuf.ByteString) ref;
            }
          }
          /**
           * <code>optional string new_value = 3;</code>
           *
           * <pre>
           * Absent field means that the attribute should be removed/the annotation
           * should be set to null.
           * </pre>
           */
          public Builder setNewValue(
              java.lang.String value) {
            if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
            newValue_ = value;
            onChanged();
            return this;
          }
          /**
           * <code>optional string new_value = 3;</code>
           *
           * <pre>
           * Absent field means that the attribute should be removed/the annotation
           * should be set to null.
           * </pre>
           */
          public Builder clearNewValue() {
            bitField0_ = (bitField0_ & ~0x00000004);
            newValue_ = getDefaultInstance().getNewValue();
            onChanged();
            return this;
          }
          /**
           * <code>optional string new_value = 3;</code>
           *
           * <pre>
           * Absent field means that the attribute should be removed/the annotation
           * should be set to null.
           * </pre>
           */
          public Builder setNewValueBytes(
              com.google.protobuf.ByteString value) {
            if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
            newValue_ = value;
            onChanged();
            return this;
          }

          // @@protoc_insertion_point(builder_scope:federation.ProtocolDocumentOperation.Component.KeyValueUpdate)
        }

        static {
          defaultInstance = new KeyValueUpdate(true);
          defaultInstance.initFields();
        }

        // @@protoc_insertion_point(class_scope:federation.ProtocolDocumentOperation.Component.KeyValueUpdate)
      }

      public interface ElementStartOrBuilder
          extends com.google.protobuf.MessageOrBuilder {

        // required string type = 1;
        /**
         * <code>required string type = 1;</code>
         */
        boolean hasType();
        /**
         * <code>required string type = 1;</code>
         */
        java.lang.String getType();
        /**
         * <code>required string type = 1;</code>
         */
        com.google.protobuf.ByteString
            getTypeBytes();

        // repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> 
            getAttributeList();
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair getAttribute(int index);
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        int getAttributeCount();
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder> 
            getAttributeOrBuilderList();
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder getAttributeOrBuilder(
            int index);
      }
      /**
       * Protobuf type {@code federation.ProtocolDocumentOperation.Component.ElementStart}
       */
      public static final class ElementStart extends
          com.google.protobuf.GeneratedMessage
          implements ElementStartOrBuilder {
        // Use ElementStart.newBuilder() to construct.
        private ElementStart(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
          super(builder);
          this.unknownFields = builder.getUnknownFields();
        }
        private ElementStart(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

        private static final ElementStart defaultInstance;
        public static ElementStart getDefaultInstance() {
          return defaultInstance;
        }

        public ElementStart getDefaultInstanceForType() {
          return defaultInstance;
        }

        private final com.google.protobuf.UnknownFieldSet unknownFields;
        @java.lang.Override
        public final com.google.protobuf.UnknownFieldSet
            getUnknownFields() {
          return this.unknownFields;
        }
        private ElementStart(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          initFields();
          int mutable_bitField0_ = 0;
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
              com.google.protobuf.UnknownFieldSet.newBuilder();
          try {
            boolean done = false;
            while (!done) {
              int tag = input.readTag();
              switch (tag) {
                case 0:
                  done = true;
                  break;
                default: {
                  if (!parseUnknownField(input, unknownFields,
                                         extensionRegistry, tag)) {
                    done = true;
                  }
                  break;
                }
                case 10: {
                  bitField0_ |= 0x00000001;
                  type_ = input.readBytes();
                  break;
                }
                case 18: {
                  if (!((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
                    attribute_ = new java.util.ArrayList<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair>();
                    mutable_bitField0_ |= 0x00000002;
                  }
                  attribute_.add(input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.PARSER, extensionRegistry));
                  break;
                }
              }
            }
          } catch (com.google.protobuf.InvalidProtocolBufferException e) {
            throw e.setUnfinishedMessage(this);
          } catch (java.io.IOException e) {
            throw new com.google.protobuf.InvalidProtocolBufferException(
                e.getMessage()).setUnfinishedMessage(this);
          } finally {
            if (((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
              attribute_ = java.util.Collections.unmodifiableList(attribute_);
            }
            this.unknownFields = unknownFields.build();
            makeExtensionsImmutable();
          }
        }
        public static final com.google.protobuf.Descriptors.Descriptor
            getDescriptor() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_ElementStart_descriptor;
        }

        protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
            internalGetFieldAccessorTable() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_ElementStart_fieldAccessorTable
              .ensureFieldAccessorsInitialized(
                  org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.class, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.Builder.class);
        }

        public static com.google.protobuf.Parser<ElementStart> PARSER =
            new com.google.protobuf.AbstractParser<ElementStart>() {
          public ElementStart parsePartialFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws com.google.protobuf.InvalidProtocolBufferException {
            return new ElementStart(input, extensionRegistry);
          }
        };

        @java.lang.Override
        public com.google.protobuf.Parser<ElementStart> getParserForType() {
          return PARSER;
        }

        private int bitField0_;
        // required string type = 1;
        public static final int TYPE_FIELD_NUMBER = 1;
        private java.lang.Object type_;
        /**
         * <code>required string type = 1;</code>
         */
        public boolean hasType() {
          return ((bitField0_ & 0x00000001) == 0x00000001);
        }
        /**
         * <code>required string type = 1;</code>
         */
        public java.lang.String getType() {
          java.lang.Object ref = type_;
          if (ref instanceof java.lang.String) {
            return (java.lang.String) ref;
          } else {
            com.google.protobuf.ByteString bs = 
                (com.google.protobuf.ByteString) ref;
            java.lang.String s = bs.toStringUtf8();
            if (bs.isValidUtf8()) {
              type_ = s;
            }
            return s;
          }
        }
        /**
         * <code>required string type = 1;</code>
         */
        public com.google.protobuf.ByteString
            getTypeBytes() {
          java.lang.Object ref = type_;
          if (ref instanceof java.lang.String) {
            com.google.protobuf.ByteString b = 
                com.google.protobuf.ByteString.copyFromUtf8(
                    (java.lang.String) ref);
            type_ = b;
            return b;
          } else {
            return (com.google.protobuf.ByteString) ref;
          }
        }

        // repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;
        public static final int ATTRIBUTE_FIELD_NUMBER = 2;
        private java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> attribute_;
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> getAttributeList() {
          return attribute_;
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        public java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder> 
            getAttributeOrBuilderList() {
          return attribute_;
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        public int getAttributeCount() {
          return attribute_.size();
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair getAttribute(int index) {
          return attribute_.get(index);
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder getAttributeOrBuilder(
            int index) {
          return attribute_.get(index);
        }

        private void initFields() {
          type_ = "";
          attribute_ = java.util.Collections.emptyList();
        }
        private byte memoizedIsInitialized = -1;
        public final boolean isInitialized() {
          byte isInitialized = memoizedIsInitialized;
          if (isInitialized != -1) return isInitialized == 1;

          if (!hasType()) {
            memoizedIsInitialized = 0;
            return false;
          }
          for (int i = 0; i < getAttributeCount(); i++) {
            if (!getAttribute(i).isInitialized()) {
              memoizedIsInitialized = 0;
              return false;
            }
          }
          memoizedIsInitialized = 1;
          return true;
        }

        public void writeTo(com.google.protobuf.CodedOutputStream output)
                            throws java.io.IOException {
          getSerializedSize();
          if (((bitField0_ & 0x00000001) == 0x00000001)) {
            output.writeBytes(1, getTypeBytes());
          }
          for (int i = 0; i < attribute_.size(); i++) {
            output.writeMessage(2, attribute_.get(i));
          }
          getUnknownFields().writeTo(output);
        }

        private int memoizedSerializedSize = -1;
        public int getSerializedSize() {
          int size = memoizedSerializedSize;
          if (size != -1) return size;

          size = 0;
          if (((bitField0_ & 0x00000001) == 0x00000001)) {
            size += com.google.protobuf.CodedOutputStream
              .computeBytesSize(1, getTypeBytes());
          }
          for (int i = 0; i < attribute_.size(); i++) {
            size += com.google.protobuf.CodedOutputStream
              .computeMessageSize(2, attribute_.get(i));
          }
          size += getUnknownFields().getSerializedSize();
          memoizedSerializedSize = size;
          return size;
        }

        private static final long serialVersionUID = 0L;
        @java.lang.Override
        protected java.lang.Object writeReplace()
            throws java.io.ObjectStreamException {
          return super.writeReplace();
        }

        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart parseFrom(
            com.google.protobuf.ByteString data)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart parseFrom(
            com.google.protobuf.ByteString data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart parseFrom(byte[] data)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart parseFrom(
            byte[] data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart parseFrom(java.io.InputStream input)
            throws java.io.IOException {
          return PARSER.parseFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart parseFrom(
            java.io.InputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseFrom(input, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart parseDelimitedFrom(java.io.InputStream input)
            throws java.io.IOException {
          return PARSER.parseDelimitedFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart parseDelimitedFrom(
            java.io.InputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseDelimitedFrom(input, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart parseFrom(
            com.google.protobuf.CodedInputStream input)
            throws java.io.IOException {
          return PARSER.parseFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart parseFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseFrom(input, extensionRegistry);
        }

        public static Builder newBuilder() { return Builder.create(); }
        public Builder newBuilderForType() { return newBuilder(); }
        public static Builder newBuilder(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart prototype) {
          return newBuilder().mergeFrom(prototype);
        }
        public Builder toBuilder() { return newBuilder(this); }

        @java.lang.Override
        protected Builder newBuilderForType(
            com.google.protobuf.GeneratedMessage.BuilderParent parent) {
          Builder builder = new Builder(parent);
          return builder;
        }
        /**
         * Protobuf type {@code federation.ProtocolDocumentOperation.Component.ElementStart}
         */
        public static final class Builder extends
            com.google.protobuf.GeneratedMessage.Builder<Builder>
           implements org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStartOrBuilder {
          public static final com.google.protobuf.Descriptors.Descriptor
              getDescriptor() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_ElementStart_descriptor;
          }

          protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
              internalGetFieldAccessorTable() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_ElementStart_fieldAccessorTable
                .ensureFieldAccessorsInitialized(
                    org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.class, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.Builder.class);
          }

          // Construct using org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.newBuilder()
          private Builder() {
            maybeForceBuilderInitialization();
          }

          private Builder(
              com.google.protobuf.GeneratedMessage.BuilderParent parent) {
            super(parent);
            maybeForceBuilderInitialization();
          }
          private void maybeForceBuilderInitialization() {
            if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
              getAttributeFieldBuilder();
            }
          }
          private static Builder create() {
            return new Builder();
          }

          public Builder clear() {
            super.clear();
            type_ = "";
            bitField0_ = (bitField0_ & ~0x00000001);
            if (attributeBuilder_ == null) {
              attribute_ = java.util.Collections.emptyList();
              bitField0_ = (bitField0_ & ~0x00000002);
            } else {
              attributeBuilder_.clear();
            }
            return this;
          }

          public Builder clone() {
            return create().mergeFrom(buildPartial());
          }

          public com.google.protobuf.Descriptors.Descriptor
              getDescriptorForType() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_ElementStart_descriptor;
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart getDefaultInstanceForType() {
            return org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.getDefaultInstance();
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart build() {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart result = buildPartial();
            if (!result.isInitialized()) {
              throw newUninitializedMessageException(result);
            }
            return result;
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart buildPartial() {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart result = new org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart(this);
            int from_bitField0_ = bitField0_;
            int to_bitField0_ = 0;
            if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
              to_bitField0_ |= 0x00000001;
            }
            result.type_ = type_;
            if (attributeBuilder_ == null) {
              if (((bitField0_ & 0x00000002) == 0x00000002)) {
                attribute_ = java.util.Collections.unmodifiableList(attribute_);
                bitField0_ = (bitField0_ & ~0x00000002);
              }
              result.attribute_ = attribute_;
            } else {
              result.attribute_ = attributeBuilder_.build();
            }
            result.bitField0_ = to_bitField0_;
            onBuilt();
            return result;
          }

          public Builder mergeFrom(com.google.protobuf.Message other) {
            if (other instanceof org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart) {
              return mergeFrom((org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart)other);
            } else {
              super.mergeFrom(other);
              return this;
            }
          }

          public Builder mergeFrom(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart other) {
            if (other == org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.getDefaultInstance()) return this;
            if (other.hasType()) {
              bitField0_ |= 0x00000001;
              type_ = other.type_;
              onChanged();
            }
            if (attributeBuilder_ == null) {
              if (!other.attribute_.isEmpty()) {
                if (attribute_.isEmpty()) {
                  attribute_ = other.attribute_;
                  bitField0_ = (bitField0_ & ~0x00000002);
                } else {
                  ensureAttributeIsMutable();
                  attribute_.addAll(other.attribute_);
                }
                onChanged();
              }
            } else {
              if (!other.attribute_.isEmpty()) {
                if (attributeBuilder_.isEmpty()) {
                  attributeBuilder_.dispose();
                  attributeBuilder_ = null;
                  attribute_ = other.attribute_;
                  bitField0_ = (bitField0_ & ~0x00000002);
                  attributeBuilder_ = 
                    com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                       getAttributeFieldBuilder() : null;
                } else {
                  attributeBuilder_.addAllMessages(other.attribute_);
                }
              }
            }
            this.mergeUnknownFields(other.getUnknownFields());
            return this;
          }

          public final boolean isInitialized() {
            if (!hasType()) {
              
              return false;
            }
            for (int i = 0; i < getAttributeCount(); i++) {
              if (!getAttribute(i).isInitialized()) {
                
                return false;
              }
            }
            return true;
          }

          public Builder mergeFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws java.io.IOException {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart parsedMessage = null;
            try {
              parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
            } catch (com.google.protobuf.InvalidProtocolBufferException e) {
              parsedMessage = (org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart) e.getUnfinishedMessage();
              throw e;
            } finally {
              if (parsedMessage != null) {
                mergeFrom(parsedMessage);
              }
            }
            return this;
          }
          private int bitField0_;

          // required string type = 1;
          private java.lang.Object type_ = "";
          /**
           * <code>required string type = 1;</code>
           */
          public boolean hasType() {
            return ((bitField0_ & 0x00000001) == 0x00000001);
          }
          /**
           * <code>required string type = 1;</code>
           */
          public java.lang.String getType() {
            java.lang.Object ref = type_;
            if (!(ref instanceof java.lang.String)) {
              java.lang.String s = ((com.google.protobuf.ByteString) ref)
                  .toStringUtf8();
              type_ = s;
              return s;
            } else {
              return (java.lang.String) ref;
            }
          }
          /**
           * <code>required string type = 1;</code>
           */
          public com.google.protobuf.ByteString
              getTypeBytes() {
            java.lang.Object ref = type_;
            if (ref instanceof String) {
              com.google.protobuf.ByteString b = 
                  com.google.protobuf.ByteString.copyFromUtf8(
                      (java.lang.String) ref);
              type_ = b;
              return b;
            } else {
              return (com.google.protobuf.ByteString) ref;
            }
          }
          /**
           * <code>required string type = 1;</code>
           */
          public Builder setType(
              java.lang.String value) {
            if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
            type_ = value;
            onChanged();
            return this;
          }
          /**
           * <code>required string type = 1;</code>
           */
          public Builder clearType() {
            bitField0_ = (bitField0_ & ~0x00000001);
            type_ = getDefaultInstance().getType();
            onChanged();
            return this;
          }
          /**
           * <code>required string type = 1;</code>
           */
          public Builder setTypeBytes(
              com.google.protobuf.ByteString value) {
            if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
            type_ = value;
            onChanged();
            return this;
          }

          // repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;
          private java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> attribute_ =
            java.util.Collections.emptyList();
          private void ensureAttributeIsMutable() {
            if (!((bitField0_ & 0x00000002) == 0x00000002)) {
              attribute_ = new java.util.ArrayList<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair>(attribute_);
              bitField0_ |= 0x00000002;
             }
          }

          private com.google.protobuf.RepeatedFieldBuilder<
              org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder> attributeBuilder_;

          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> getAttributeList() {
            if (attributeBuilder_ == null) {
              return java.util.Collections.unmodifiableList(attribute_);
            } else {
              return attributeBuilder_.getMessageList();
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public int getAttributeCount() {
            if (attributeBuilder_ == null) {
              return attribute_.size();
            } else {
              return attributeBuilder_.getCount();
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair getAttribute(int index) {
            if (attributeBuilder_ == null) {
              return attribute_.get(index);
            } else {
              return attributeBuilder_.getMessage(index);
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder setAttribute(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair value) {
            if (attributeBuilder_ == null) {
              if (value == null) {
                throw new NullPointerException();
              }
              ensureAttributeIsMutable();
              attribute_.set(index, value);
              onChanged();
            } else {
              attributeBuilder_.setMessage(index, value);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder setAttribute(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder builderForValue) {
            if (attributeBuilder_ == null) {
              ensureAttributeIsMutable();
              attribute_.set(index, builderForValue.build());
              onChanged();
            } else {
              attributeBuilder_.setMessage(index, builderForValue.build());
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder addAttribute(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair value) {
            if (attributeBuilder_ == null) {
              if (value == null) {
                throw new NullPointerException();
              }
              ensureAttributeIsMutable();
              attribute_.add(value);
              onChanged();
            } else {
              attributeBuilder_.addMessage(value);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder addAttribute(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair value) {
            if (attributeBuilder_ == null) {
              if (value == null) {
                throw new NullPointerException();
              }
              ensureAttributeIsMutable();
              attribute_.add(index, value);
              onChanged();
            } else {
              attributeBuilder_.addMessage(index, value);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder addAttribute(
              org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder builderForValue) {
            if (attributeBuilder_ == null) {
              ensureAttributeIsMutable();
              attribute_.add(builderForValue.build());
              onChanged();
            } else {
              attributeBuilder_.addMessage(builderForValue.build());
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder addAttribute(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder builderForValue) {
            if (attributeBuilder_ == null) {
              ensureAttributeIsMutable();
              attribute_.add(index, builderForValue.build());
              onChanged();
            } else {
              attributeBuilder_.addMessage(index, builderForValue.build());
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder addAllAttribute(
              java.lang.Iterable<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> values) {
            if (attributeBuilder_ == null) {
              ensureAttributeIsMutable();
              super.addAll(values, attribute_);
              onChanged();
            } else {
              attributeBuilder_.addAllMessages(values);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder clearAttribute() {
            if (attributeBuilder_ == null) {
              attribute_ = java.util.Collections.emptyList();
              bitField0_ = (bitField0_ & ~0x00000002);
              onChanged();
            } else {
              attributeBuilder_.clear();
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder removeAttribute(int index) {
            if (attributeBuilder_ == null) {
              ensureAttributeIsMutable();
              attribute_.remove(index);
              onChanged();
            } else {
              attributeBuilder_.remove(index);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder getAttributeBuilder(
              int index) {
            return getAttributeFieldBuilder().getBuilder(index);
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder getAttributeOrBuilder(
              int index) {
            if (attributeBuilder_ == null) {
              return attribute_.get(index);  } else {
              return attributeBuilder_.getMessageOrBuilder(index);
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder> 
               getAttributeOrBuilderList() {
            if (attributeBuilder_ != null) {
              return attributeBuilder_.getMessageOrBuilderList();
            } else {
              return java.util.Collections.unmodifiableList(attribute_);
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder addAttributeBuilder() {
            return getAttributeFieldBuilder().addBuilder(
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.getDefaultInstance());
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder addAttributeBuilder(
              int index) {
            return getAttributeFieldBuilder().addBuilder(
                index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.getDefaultInstance());
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder> 
               getAttributeBuilderList() {
            return getAttributeFieldBuilder().getBuilderList();
          }
          private com.google.protobuf.RepeatedFieldBuilder<
              org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder> 
              getAttributeFieldBuilder() {
            if (attributeBuilder_ == null) {
              attributeBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
                  org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder>(
                      attribute_,
                      ((bitField0_ & 0x00000002) == 0x00000002),
                      getParentForChildren(),
                      isClean());
              attribute_ = null;
            }
            return attributeBuilder_;
          }

          // @@protoc_insertion_point(builder_scope:federation.ProtocolDocumentOperation.Component.ElementStart)
        }

        static {
          defaultInstance = new ElementStart(true);
          defaultInstance.initFields();
        }

        // @@protoc_insertion_point(class_scope:federation.ProtocolDocumentOperation.Component.ElementStart)
      }

      public interface ReplaceAttributesOrBuilder
          extends com.google.protobuf.MessageOrBuilder {

        // optional bool empty = 1;
        /**
         * <code>optional bool empty = 1;</code>
         *
         * <pre>
         * This field is set to true if and only if both oldAttributes and
         * newAttributes are empty.  It is needed to ensure that the optional
         * replaceAttributes component field is not dropped during serialization.
         * </pre>
         */
        boolean hasEmpty();
        /**
         * <code>optional bool empty = 1;</code>
         *
         * <pre>
         * This field is set to true if and only if both oldAttributes and
         * newAttributes are empty.  It is needed to ensure that the optional
         * replaceAttributes component field is not dropped during serialization.
         * </pre>
         */
        boolean getEmpty();

        // repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> 
            getOldAttributeList();
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair getOldAttribute(int index);
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        int getOldAttributeCount();
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder> 
            getOldAttributeOrBuilderList();
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder getOldAttributeOrBuilder(
            int index);

        // repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> 
            getNewAttributeList();
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair getNewAttribute(int index);
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        int getNewAttributeCount();
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder> 
            getNewAttributeOrBuilderList();
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder getNewAttributeOrBuilder(
            int index);
      }
      /**
       * Protobuf type {@code federation.ProtocolDocumentOperation.Component.ReplaceAttributes}
       */
      public static final class ReplaceAttributes extends
          com.google.protobuf.GeneratedMessage
          implements ReplaceAttributesOrBuilder {
        // Use ReplaceAttributes.newBuilder() to construct.
        private ReplaceAttributes(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
          super(builder);
          this.unknownFields = builder.getUnknownFields();
        }
        private ReplaceAttributes(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

        private static final ReplaceAttributes defaultInstance;
        public static ReplaceAttributes getDefaultInstance() {
          return defaultInstance;
        }

        public ReplaceAttributes getDefaultInstanceForType() {
          return defaultInstance;
        }

        private final com.google.protobuf.UnknownFieldSet unknownFields;
        @java.lang.Override
        public final com.google.protobuf.UnknownFieldSet
            getUnknownFields() {
          return this.unknownFields;
        }
        private ReplaceAttributes(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          initFields();
          int mutable_bitField0_ = 0;
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
              com.google.protobuf.UnknownFieldSet.newBuilder();
          try {
            boolean done = false;
            while (!done) {
              int tag = input.readTag();
              switch (tag) {
                case 0:
                  done = true;
                  break;
                default: {
                  if (!parseUnknownField(input, unknownFields,
                                         extensionRegistry, tag)) {
                    done = true;
                  }
                  break;
                }
                case 8: {
                  bitField0_ |= 0x00000001;
                  empty_ = input.readBool();
                  break;
                }
                case 18: {
                  if (!((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
                    oldAttribute_ = new java.util.ArrayList<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair>();
                    mutable_bitField0_ |= 0x00000002;
                  }
                  oldAttribute_.add(input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.PARSER, extensionRegistry));
                  break;
                }
                case 26: {
                  if (!((mutable_bitField0_ & 0x00000004) == 0x00000004)) {
                    newAttribute_ = new java.util.ArrayList<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair>();
                    mutable_bitField0_ |= 0x00000004;
                  }
                  newAttribute_.add(input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.PARSER, extensionRegistry));
                  break;
                }
              }
            }
          } catch (com.google.protobuf.InvalidProtocolBufferException e) {
            throw e.setUnfinishedMessage(this);
          } catch (java.io.IOException e) {
            throw new com.google.protobuf.InvalidProtocolBufferException(
                e.getMessage()).setUnfinishedMessage(this);
          } finally {
            if (((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
              oldAttribute_ = java.util.Collections.unmodifiableList(oldAttribute_);
            }
            if (((mutable_bitField0_ & 0x00000004) == 0x00000004)) {
              newAttribute_ = java.util.Collections.unmodifiableList(newAttribute_);
            }
            this.unknownFields = unknownFields.build();
            makeExtensionsImmutable();
          }
        }
        public static final com.google.protobuf.Descriptors.Descriptor
            getDescriptor() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_ReplaceAttributes_descriptor;
        }

        protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
            internalGetFieldAccessorTable() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_ReplaceAttributes_fieldAccessorTable
              .ensureFieldAccessorsInitialized(
                  org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.class, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.Builder.class);
        }

        public static com.google.protobuf.Parser<ReplaceAttributes> PARSER =
            new com.google.protobuf.AbstractParser<ReplaceAttributes>() {
          public ReplaceAttributes parsePartialFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws com.google.protobuf.InvalidProtocolBufferException {
            return new ReplaceAttributes(input, extensionRegistry);
          }
        };

        @java.lang.Override
        public com.google.protobuf.Parser<ReplaceAttributes> getParserForType() {
          return PARSER;
        }

        private int bitField0_;
        // optional bool empty = 1;
        public static final int EMPTY_FIELD_NUMBER = 1;
        private boolean empty_;
        /**
         * <code>optional bool empty = 1;</code>
         *
         * <pre>
         * This field is set to true if and only if both oldAttributes and
         * newAttributes are empty.  It is needed to ensure that the optional
         * replaceAttributes component field is not dropped during serialization.
         * </pre>
         */
        public boolean hasEmpty() {
          return ((bitField0_ & 0x00000001) == 0x00000001);
        }
        /**
         * <code>optional bool empty = 1;</code>
         *
         * <pre>
         * This field is set to true if and only if both oldAttributes and
         * newAttributes are empty.  It is needed to ensure that the optional
         * replaceAttributes component field is not dropped during serialization.
         * </pre>
         */
        public boolean getEmpty() {
          return empty_;
        }

        // repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;
        public static final int OLD_ATTRIBUTE_FIELD_NUMBER = 2;
        private java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> oldAttribute_;
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> getOldAttributeList() {
          return oldAttribute_;
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        public java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder> 
            getOldAttributeOrBuilderList() {
          return oldAttribute_;
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        public int getOldAttributeCount() {
          return oldAttribute_.size();
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair getOldAttribute(int index) {
          return oldAttribute_.get(index);
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder getOldAttributeOrBuilder(
            int index) {
          return oldAttribute_.get(index);
        }

        // repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;
        public static final int NEW_ATTRIBUTE_FIELD_NUMBER = 3;
        private java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> newAttribute_;
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> getNewAttributeList() {
          return newAttribute_;
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        public java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder> 
            getNewAttributeOrBuilderList() {
          return newAttribute_;
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        public int getNewAttributeCount() {
          return newAttribute_.size();
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair getNewAttribute(int index) {
          return newAttribute_.get(index);
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
         *
         * <pre>
         * MUST NOT have two pairs with the same key.
         * </pre>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder getNewAttributeOrBuilder(
            int index) {
          return newAttribute_.get(index);
        }

        private void initFields() {
          empty_ = false;
          oldAttribute_ = java.util.Collections.emptyList();
          newAttribute_ = java.util.Collections.emptyList();
        }
        private byte memoizedIsInitialized = -1;
        public final boolean isInitialized() {
          byte isInitialized = memoizedIsInitialized;
          if (isInitialized != -1) return isInitialized == 1;

          for (int i = 0; i < getOldAttributeCount(); i++) {
            if (!getOldAttribute(i).isInitialized()) {
              memoizedIsInitialized = 0;
              return false;
            }
          }
          for (int i = 0; i < getNewAttributeCount(); i++) {
            if (!getNewAttribute(i).isInitialized()) {
              memoizedIsInitialized = 0;
              return false;
            }
          }
          memoizedIsInitialized = 1;
          return true;
        }

        public void writeTo(com.google.protobuf.CodedOutputStream output)
                            throws java.io.IOException {
          getSerializedSize();
          if (((bitField0_ & 0x00000001) == 0x00000001)) {
            output.writeBool(1, empty_);
          }
          for (int i = 0; i < oldAttribute_.size(); i++) {
            output.writeMessage(2, oldAttribute_.get(i));
          }
          for (int i = 0; i < newAttribute_.size(); i++) {
            output.writeMessage(3, newAttribute_.get(i));
          }
          getUnknownFields().writeTo(output);
        }

        private int memoizedSerializedSize = -1;
        public int getSerializedSize() {
          int size = memoizedSerializedSize;
          if (size != -1) return size;

          size = 0;
          if (((bitField0_ & 0x00000001) == 0x00000001)) {
            size += com.google.protobuf.CodedOutputStream
              .computeBoolSize(1, empty_);
          }
          for (int i = 0; i < oldAttribute_.size(); i++) {
            size += com.google.protobuf.CodedOutputStream
              .computeMessageSize(2, oldAttribute_.get(i));
          }
          for (int i = 0; i < newAttribute_.size(); i++) {
            size += com.google.protobuf.CodedOutputStream
              .computeMessageSize(3, newAttribute_.get(i));
          }
          size += getUnknownFields().getSerializedSize();
          memoizedSerializedSize = size;
          return size;
        }

        private static final long serialVersionUID = 0L;
        @java.lang.Override
        protected java.lang.Object writeReplace()
            throws java.io.ObjectStreamException {
          return super.writeReplace();
        }

        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes parseFrom(
            com.google.protobuf.ByteString data)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes parseFrom(
            com.google.protobuf.ByteString data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes parseFrom(byte[] data)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes parseFrom(
            byte[] data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes parseFrom(java.io.InputStream input)
            throws java.io.IOException {
          return PARSER.parseFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes parseFrom(
            java.io.InputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseFrom(input, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes parseDelimitedFrom(java.io.InputStream input)
            throws java.io.IOException {
          return PARSER.parseDelimitedFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes parseDelimitedFrom(
            java.io.InputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseDelimitedFrom(input, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes parseFrom(
            com.google.protobuf.CodedInputStream input)
            throws java.io.IOException {
          return PARSER.parseFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes parseFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseFrom(input, extensionRegistry);
        }

        public static Builder newBuilder() { return Builder.create(); }
        public Builder newBuilderForType() { return newBuilder(); }
        public static Builder newBuilder(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes prototype) {
          return newBuilder().mergeFrom(prototype);
        }
        public Builder toBuilder() { return newBuilder(this); }

        @java.lang.Override
        protected Builder newBuilderForType(
            com.google.protobuf.GeneratedMessage.BuilderParent parent) {
          Builder builder = new Builder(parent);
          return builder;
        }
        /**
         * Protobuf type {@code federation.ProtocolDocumentOperation.Component.ReplaceAttributes}
         */
        public static final class Builder extends
            com.google.protobuf.GeneratedMessage.Builder<Builder>
           implements org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributesOrBuilder {
          public static final com.google.protobuf.Descriptors.Descriptor
              getDescriptor() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_ReplaceAttributes_descriptor;
          }

          protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
              internalGetFieldAccessorTable() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_ReplaceAttributes_fieldAccessorTable
                .ensureFieldAccessorsInitialized(
                    org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.class, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.Builder.class);
          }

          // Construct using org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.newBuilder()
          private Builder() {
            maybeForceBuilderInitialization();
          }

          private Builder(
              com.google.protobuf.GeneratedMessage.BuilderParent parent) {
            super(parent);
            maybeForceBuilderInitialization();
          }
          private void maybeForceBuilderInitialization() {
            if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
              getOldAttributeFieldBuilder();
              getNewAttributeFieldBuilder();
            }
          }
          private static Builder create() {
            return new Builder();
          }

          public Builder clear() {
            super.clear();
            empty_ = false;
            bitField0_ = (bitField0_ & ~0x00000001);
            if (oldAttributeBuilder_ == null) {
              oldAttribute_ = java.util.Collections.emptyList();
              bitField0_ = (bitField0_ & ~0x00000002);
            } else {
              oldAttributeBuilder_.clear();
            }
            if (newAttributeBuilder_ == null) {
              newAttribute_ = java.util.Collections.emptyList();
              bitField0_ = (bitField0_ & ~0x00000004);
            } else {
              newAttributeBuilder_.clear();
            }
            return this;
          }

          public Builder clone() {
            return create().mergeFrom(buildPartial());
          }

          public com.google.protobuf.Descriptors.Descriptor
              getDescriptorForType() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_ReplaceAttributes_descriptor;
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes getDefaultInstanceForType() {
            return org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.getDefaultInstance();
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes build() {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes result = buildPartial();
            if (!result.isInitialized()) {
              throw newUninitializedMessageException(result);
            }
            return result;
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes buildPartial() {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes result = new org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes(this);
            int from_bitField0_ = bitField0_;
            int to_bitField0_ = 0;
            if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
              to_bitField0_ |= 0x00000001;
            }
            result.empty_ = empty_;
            if (oldAttributeBuilder_ == null) {
              if (((bitField0_ & 0x00000002) == 0x00000002)) {
                oldAttribute_ = java.util.Collections.unmodifiableList(oldAttribute_);
                bitField0_ = (bitField0_ & ~0x00000002);
              }
              result.oldAttribute_ = oldAttribute_;
            } else {
              result.oldAttribute_ = oldAttributeBuilder_.build();
            }
            if (newAttributeBuilder_ == null) {
              if (((bitField0_ & 0x00000004) == 0x00000004)) {
                newAttribute_ = java.util.Collections.unmodifiableList(newAttribute_);
                bitField0_ = (bitField0_ & ~0x00000004);
              }
              result.newAttribute_ = newAttribute_;
            } else {
              result.newAttribute_ = newAttributeBuilder_.build();
            }
            result.bitField0_ = to_bitField0_;
            onBuilt();
            return result;
          }

          public Builder mergeFrom(com.google.protobuf.Message other) {
            if (other instanceof org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes) {
              return mergeFrom((org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes)other);
            } else {
              super.mergeFrom(other);
              return this;
            }
          }

          public Builder mergeFrom(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes other) {
            if (other == org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.getDefaultInstance()) return this;
            if (other.hasEmpty()) {
              setEmpty(other.getEmpty());
            }
            if (oldAttributeBuilder_ == null) {
              if (!other.oldAttribute_.isEmpty()) {
                if (oldAttribute_.isEmpty()) {
                  oldAttribute_ = other.oldAttribute_;
                  bitField0_ = (bitField0_ & ~0x00000002);
                } else {
                  ensureOldAttributeIsMutable();
                  oldAttribute_.addAll(other.oldAttribute_);
                }
                onChanged();
              }
            } else {
              if (!other.oldAttribute_.isEmpty()) {
                if (oldAttributeBuilder_.isEmpty()) {
                  oldAttributeBuilder_.dispose();
                  oldAttributeBuilder_ = null;
                  oldAttribute_ = other.oldAttribute_;
                  bitField0_ = (bitField0_ & ~0x00000002);
                  oldAttributeBuilder_ = 
                    com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                       getOldAttributeFieldBuilder() : null;
                } else {
                  oldAttributeBuilder_.addAllMessages(other.oldAttribute_);
                }
              }
            }
            if (newAttributeBuilder_ == null) {
              if (!other.newAttribute_.isEmpty()) {
                if (newAttribute_.isEmpty()) {
                  newAttribute_ = other.newAttribute_;
                  bitField0_ = (bitField0_ & ~0x00000004);
                } else {
                  ensureNewAttributeIsMutable();
                  newAttribute_.addAll(other.newAttribute_);
                }
                onChanged();
              }
            } else {
              if (!other.newAttribute_.isEmpty()) {
                if (newAttributeBuilder_.isEmpty()) {
                  newAttributeBuilder_.dispose();
                  newAttributeBuilder_ = null;
                  newAttribute_ = other.newAttribute_;
                  bitField0_ = (bitField0_ & ~0x00000004);
                  newAttributeBuilder_ = 
                    com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                       getNewAttributeFieldBuilder() : null;
                } else {
                  newAttributeBuilder_.addAllMessages(other.newAttribute_);
                }
              }
            }
            this.mergeUnknownFields(other.getUnknownFields());
            return this;
          }

          public final boolean isInitialized() {
            for (int i = 0; i < getOldAttributeCount(); i++) {
              if (!getOldAttribute(i).isInitialized()) {
                
                return false;
              }
            }
            for (int i = 0; i < getNewAttributeCount(); i++) {
              if (!getNewAttribute(i).isInitialized()) {
                
                return false;
              }
            }
            return true;
          }

          public Builder mergeFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws java.io.IOException {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes parsedMessage = null;
            try {
              parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
            } catch (com.google.protobuf.InvalidProtocolBufferException e) {
              parsedMessage = (org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes) e.getUnfinishedMessage();
              throw e;
            } finally {
              if (parsedMessage != null) {
                mergeFrom(parsedMessage);
              }
            }
            return this;
          }
          private int bitField0_;

          // optional bool empty = 1;
          private boolean empty_ ;
          /**
           * <code>optional bool empty = 1;</code>
           *
           * <pre>
           * This field is set to true if and only if both oldAttributes and
           * newAttributes are empty.  It is needed to ensure that the optional
           * replaceAttributes component field is not dropped during serialization.
           * </pre>
           */
          public boolean hasEmpty() {
            return ((bitField0_ & 0x00000001) == 0x00000001);
          }
          /**
           * <code>optional bool empty = 1;</code>
           *
           * <pre>
           * This field is set to true if and only if both oldAttributes and
           * newAttributes are empty.  It is needed to ensure that the optional
           * replaceAttributes component field is not dropped during serialization.
           * </pre>
           */
          public boolean getEmpty() {
            return empty_;
          }
          /**
           * <code>optional bool empty = 1;</code>
           *
           * <pre>
           * This field is set to true if and only if both oldAttributes and
           * newAttributes are empty.  It is needed to ensure that the optional
           * replaceAttributes component field is not dropped during serialization.
           * </pre>
           */
          public Builder setEmpty(boolean value) {
            bitField0_ |= 0x00000001;
            empty_ = value;
            onChanged();
            return this;
          }
          /**
           * <code>optional bool empty = 1;</code>
           *
           * <pre>
           * This field is set to true if and only if both oldAttributes and
           * newAttributes are empty.  It is needed to ensure that the optional
           * replaceAttributes component field is not dropped during serialization.
           * </pre>
           */
          public Builder clearEmpty() {
            bitField0_ = (bitField0_ & ~0x00000001);
            empty_ = false;
            onChanged();
            return this;
          }

          // repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;
          private java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> oldAttribute_ =
            java.util.Collections.emptyList();
          private void ensureOldAttributeIsMutable() {
            if (!((bitField0_ & 0x00000002) == 0x00000002)) {
              oldAttribute_ = new java.util.ArrayList<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair>(oldAttribute_);
              bitField0_ |= 0x00000002;
             }
          }

          private com.google.protobuf.RepeatedFieldBuilder<
              org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder> oldAttributeBuilder_;

          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> getOldAttributeList() {
            if (oldAttributeBuilder_ == null) {
              return java.util.Collections.unmodifiableList(oldAttribute_);
            } else {
              return oldAttributeBuilder_.getMessageList();
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public int getOldAttributeCount() {
            if (oldAttributeBuilder_ == null) {
              return oldAttribute_.size();
            } else {
              return oldAttributeBuilder_.getCount();
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair getOldAttribute(int index) {
            if (oldAttributeBuilder_ == null) {
              return oldAttribute_.get(index);
            } else {
              return oldAttributeBuilder_.getMessage(index);
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder setOldAttribute(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair value) {
            if (oldAttributeBuilder_ == null) {
              if (value == null) {
                throw new NullPointerException();
              }
              ensureOldAttributeIsMutable();
              oldAttribute_.set(index, value);
              onChanged();
            } else {
              oldAttributeBuilder_.setMessage(index, value);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder setOldAttribute(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder builderForValue) {
            if (oldAttributeBuilder_ == null) {
              ensureOldAttributeIsMutable();
              oldAttribute_.set(index, builderForValue.build());
              onChanged();
            } else {
              oldAttributeBuilder_.setMessage(index, builderForValue.build());
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder addOldAttribute(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair value) {
            if (oldAttributeBuilder_ == null) {
              if (value == null) {
                throw new NullPointerException();
              }
              ensureOldAttributeIsMutable();
              oldAttribute_.add(value);
              onChanged();
            } else {
              oldAttributeBuilder_.addMessage(value);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder addOldAttribute(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair value) {
            if (oldAttributeBuilder_ == null) {
              if (value == null) {
                throw new NullPointerException();
              }
              ensureOldAttributeIsMutable();
              oldAttribute_.add(index, value);
              onChanged();
            } else {
              oldAttributeBuilder_.addMessage(index, value);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder addOldAttribute(
              org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder builderForValue) {
            if (oldAttributeBuilder_ == null) {
              ensureOldAttributeIsMutable();
              oldAttribute_.add(builderForValue.build());
              onChanged();
            } else {
              oldAttributeBuilder_.addMessage(builderForValue.build());
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder addOldAttribute(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder builderForValue) {
            if (oldAttributeBuilder_ == null) {
              ensureOldAttributeIsMutable();
              oldAttribute_.add(index, builderForValue.build());
              onChanged();
            } else {
              oldAttributeBuilder_.addMessage(index, builderForValue.build());
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder addAllOldAttribute(
              java.lang.Iterable<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> values) {
            if (oldAttributeBuilder_ == null) {
              ensureOldAttributeIsMutable();
              super.addAll(values, oldAttribute_);
              onChanged();
            } else {
              oldAttributeBuilder_.addAllMessages(values);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder clearOldAttribute() {
            if (oldAttributeBuilder_ == null) {
              oldAttribute_ = java.util.Collections.emptyList();
              bitField0_ = (bitField0_ & ~0x00000002);
              onChanged();
            } else {
              oldAttributeBuilder_.clear();
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder removeOldAttribute(int index) {
            if (oldAttributeBuilder_ == null) {
              ensureOldAttributeIsMutable();
              oldAttribute_.remove(index);
              onChanged();
            } else {
              oldAttributeBuilder_.remove(index);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder getOldAttributeBuilder(
              int index) {
            return getOldAttributeFieldBuilder().getBuilder(index);
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder getOldAttributeOrBuilder(
              int index) {
            if (oldAttributeBuilder_ == null) {
              return oldAttribute_.get(index);  } else {
              return oldAttributeBuilder_.getMessageOrBuilder(index);
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder> 
               getOldAttributeOrBuilderList() {
            if (oldAttributeBuilder_ != null) {
              return oldAttributeBuilder_.getMessageOrBuilderList();
            } else {
              return java.util.Collections.unmodifiableList(oldAttribute_);
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder addOldAttributeBuilder() {
            return getOldAttributeFieldBuilder().addBuilder(
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.getDefaultInstance());
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder addOldAttributeBuilder(
              int index) {
            return getOldAttributeFieldBuilder().addBuilder(
                index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.getDefaultInstance());
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair old_attribute = 2;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder> 
               getOldAttributeBuilderList() {
            return getOldAttributeFieldBuilder().getBuilderList();
          }
          private com.google.protobuf.RepeatedFieldBuilder<
              org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder> 
              getOldAttributeFieldBuilder() {
            if (oldAttributeBuilder_ == null) {
              oldAttributeBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
                  org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder>(
                      oldAttribute_,
                      ((bitField0_ & 0x00000002) == 0x00000002),
                      getParentForChildren(),
                      isClean());
              oldAttribute_ = null;
            }
            return oldAttributeBuilder_;
          }

          // repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;
          private java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> newAttribute_ =
            java.util.Collections.emptyList();
          private void ensureNewAttributeIsMutable() {
            if (!((bitField0_ & 0x00000004) == 0x00000004)) {
              newAttribute_ = new java.util.ArrayList<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair>(newAttribute_);
              bitField0_ |= 0x00000004;
             }
          }

          private com.google.protobuf.RepeatedFieldBuilder<
              org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder> newAttributeBuilder_;

          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> getNewAttributeList() {
            if (newAttributeBuilder_ == null) {
              return java.util.Collections.unmodifiableList(newAttribute_);
            } else {
              return newAttributeBuilder_.getMessageList();
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public int getNewAttributeCount() {
            if (newAttributeBuilder_ == null) {
              return newAttribute_.size();
            } else {
              return newAttributeBuilder_.getCount();
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair getNewAttribute(int index) {
            if (newAttributeBuilder_ == null) {
              return newAttribute_.get(index);
            } else {
              return newAttributeBuilder_.getMessage(index);
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder setNewAttribute(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair value) {
            if (newAttributeBuilder_ == null) {
              if (value == null) {
                throw new NullPointerException();
              }
              ensureNewAttributeIsMutable();
              newAttribute_.set(index, value);
              onChanged();
            } else {
              newAttributeBuilder_.setMessage(index, value);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder setNewAttribute(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder builderForValue) {
            if (newAttributeBuilder_ == null) {
              ensureNewAttributeIsMutable();
              newAttribute_.set(index, builderForValue.build());
              onChanged();
            } else {
              newAttributeBuilder_.setMessage(index, builderForValue.build());
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder addNewAttribute(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair value) {
            if (newAttributeBuilder_ == null) {
              if (value == null) {
                throw new NullPointerException();
              }
              ensureNewAttributeIsMutable();
              newAttribute_.add(value);
              onChanged();
            } else {
              newAttributeBuilder_.addMessage(value);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder addNewAttribute(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair value) {
            if (newAttributeBuilder_ == null) {
              if (value == null) {
                throw new NullPointerException();
              }
              ensureNewAttributeIsMutable();
              newAttribute_.add(index, value);
              onChanged();
            } else {
              newAttributeBuilder_.addMessage(index, value);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder addNewAttribute(
              org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder builderForValue) {
            if (newAttributeBuilder_ == null) {
              ensureNewAttributeIsMutable();
              newAttribute_.add(builderForValue.build());
              onChanged();
            } else {
              newAttributeBuilder_.addMessage(builderForValue.build());
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder addNewAttribute(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder builderForValue) {
            if (newAttributeBuilder_ == null) {
              ensureNewAttributeIsMutable();
              newAttribute_.add(index, builderForValue.build());
              onChanged();
            } else {
              newAttributeBuilder_.addMessage(index, builderForValue.build());
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder addAllNewAttribute(
              java.lang.Iterable<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair> values) {
            if (newAttributeBuilder_ == null) {
              ensureNewAttributeIsMutable();
              super.addAll(values, newAttribute_);
              onChanged();
            } else {
              newAttributeBuilder_.addAllMessages(values);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder clearNewAttribute() {
            if (newAttributeBuilder_ == null) {
              newAttribute_ = java.util.Collections.emptyList();
              bitField0_ = (bitField0_ & ~0x00000004);
              onChanged();
            } else {
              newAttributeBuilder_.clear();
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public Builder removeNewAttribute(int index) {
            if (newAttributeBuilder_ == null) {
              ensureNewAttributeIsMutable();
              newAttribute_.remove(index);
              onChanged();
            } else {
              newAttributeBuilder_.remove(index);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder getNewAttributeBuilder(
              int index) {
            return getNewAttributeFieldBuilder().getBuilder(index);
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder getNewAttributeOrBuilder(
              int index) {
            if (newAttributeBuilder_ == null) {
              return newAttribute_.get(index);  } else {
              return newAttributeBuilder_.getMessageOrBuilder(index);
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder> 
               getNewAttributeOrBuilderList() {
            if (newAttributeBuilder_ != null) {
              return newAttributeBuilder_.getMessageOrBuilderList();
            } else {
              return java.util.Collections.unmodifiableList(newAttribute_);
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder addNewAttributeBuilder() {
            return getNewAttributeFieldBuilder().addBuilder(
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.getDefaultInstance());
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder addNewAttributeBuilder(
              int index) {
            return getNewAttributeFieldBuilder().addBuilder(
                index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.getDefaultInstance());
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValuePair new_attribute = 3;</code>
           *
           * <pre>
           * MUST NOT have two pairs with the same key.
           * </pre>
           */
          public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder> 
               getNewAttributeBuilderList() {
            return getNewAttributeFieldBuilder().getBuilderList();
          }
          private com.google.protobuf.RepeatedFieldBuilder<
              org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder> 
              getNewAttributeFieldBuilder() {
            if (newAttributeBuilder_ == null) {
              newAttributeBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
                  org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePair.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValuePairOrBuilder>(
                      newAttribute_,
                      ((bitField0_ & 0x00000004) == 0x00000004),
                      getParentForChildren(),
                      isClean());
              newAttribute_ = null;
            }
            return newAttributeBuilder_;
          }

          // @@protoc_insertion_point(builder_scope:federation.ProtocolDocumentOperation.Component.ReplaceAttributes)
        }

        static {
          defaultInstance = new ReplaceAttributes(true);
          defaultInstance.initFields();
        }

        // @@protoc_insertion_point(class_scope:federation.ProtocolDocumentOperation.Component.ReplaceAttributes)
      }

      public interface UpdateAttributesOrBuilder
          extends com.google.protobuf.MessageOrBuilder {

        // optional bool empty = 1;
        /**
         * <code>optional bool empty = 1;</code>
         *
         * <pre>
         * This field is set to true if and only if attributeUpdates are empty.
         * It is needed to ensure that the optional updateAttributes
         * component field is not dropped during serialization.
         * </pre>
         */
        boolean hasEmpty();
        /**
         * <code>optional bool empty = 1;</code>
         *
         * <pre>
         * This field is set to true if and only if attributeUpdates are empty.
         * It is needed to ensure that the optional updateAttributes
         * component field is not dropped during serialization.
         * </pre>
         */
        boolean getEmpty();

        // repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.
         * </pre>
         */
        java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate> 
            getAttributeUpdateList();
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.
         * </pre>
         */
        org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate getAttributeUpdate(int index);
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.
         * </pre>
         */
        int getAttributeUpdateCount();
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.
         * </pre>
         */
        java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder> 
            getAttributeUpdateOrBuilderList();
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.
         * </pre>
         */
        org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder getAttributeUpdateOrBuilder(
            int index);
      }
      /**
       * Protobuf type {@code federation.ProtocolDocumentOperation.Component.UpdateAttributes}
       */
      public static final class UpdateAttributes extends
          com.google.protobuf.GeneratedMessage
          implements UpdateAttributesOrBuilder {
        // Use UpdateAttributes.newBuilder() to construct.
        private UpdateAttributes(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
          super(builder);
          this.unknownFields = builder.getUnknownFields();
        }
        private UpdateAttributes(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

        private static final UpdateAttributes defaultInstance;
        public static UpdateAttributes getDefaultInstance() {
          return defaultInstance;
        }

        public UpdateAttributes getDefaultInstanceForType() {
          return defaultInstance;
        }

        private final com.google.protobuf.UnknownFieldSet unknownFields;
        @java.lang.Override
        public final com.google.protobuf.UnknownFieldSet
            getUnknownFields() {
          return this.unknownFields;
        }
        private UpdateAttributes(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          initFields();
          int mutable_bitField0_ = 0;
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
              com.google.protobuf.UnknownFieldSet.newBuilder();
          try {
            boolean done = false;
            while (!done) {
              int tag = input.readTag();
              switch (tag) {
                case 0:
                  done = true;
                  break;
                default: {
                  if (!parseUnknownField(input, unknownFields,
                                         extensionRegistry, tag)) {
                    done = true;
                  }
                  break;
                }
                case 8: {
                  bitField0_ |= 0x00000001;
                  empty_ = input.readBool();
                  break;
                }
                case 18: {
                  if (!((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
                    attributeUpdate_ = new java.util.ArrayList<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate>();
                    mutable_bitField0_ |= 0x00000002;
                  }
                  attributeUpdate_.add(input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.PARSER, extensionRegistry));
                  break;
                }
              }
            }
          } catch (com.google.protobuf.InvalidProtocolBufferException e) {
            throw e.setUnfinishedMessage(this);
          } catch (java.io.IOException e) {
            throw new com.google.protobuf.InvalidProtocolBufferException(
                e.getMessage()).setUnfinishedMessage(this);
          } finally {
            if (((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
              attributeUpdate_ = java.util.Collections.unmodifiableList(attributeUpdate_);
            }
            this.unknownFields = unknownFields.build();
            makeExtensionsImmutable();
          }
        }
        public static final com.google.protobuf.Descriptors.Descriptor
            getDescriptor() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_UpdateAttributes_descriptor;
        }

        protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
            internalGetFieldAccessorTable() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_UpdateAttributes_fieldAccessorTable
              .ensureFieldAccessorsInitialized(
                  org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.class, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.Builder.class);
        }

        public static com.google.protobuf.Parser<UpdateAttributes> PARSER =
            new com.google.protobuf.AbstractParser<UpdateAttributes>() {
          public UpdateAttributes parsePartialFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws com.google.protobuf.InvalidProtocolBufferException {
            return new UpdateAttributes(input, extensionRegistry);
          }
        };

        @java.lang.Override
        public com.google.protobuf.Parser<UpdateAttributes> getParserForType() {
          return PARSER;
        }

        private int bitField0_;
        // optional bool empty = 1;
        public static final int EMPTY_FIELD_NUMBER = 1;
        private boolean empty_;
        /**
         * <code>optional bool empty = 1;</code>
         *
         * <pre>
         * This field is set to true if and only if attributeUpdates are empty.
         * It is needed to ensure that the optional updateAttributes
         * component field is not dropped during serialization.
         * </pre>
         */
        public boolean hasEmpty() {
          return ((bitField0_ & 0x00000001) == 0x00000001);
        }
        /**
         * <code>optional bool empty = 1;</code>
         *
         * <pre>
         * This field is set to true if and only if attributeUpdates are empty.
         * It is needed to ensure that the optional updateAttributes
         * component field is not dropped during serialization.
         * </pre>
         */
        public boolean getEmpty() {
          return empty_;
        }

        // repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;
        public static final int ATTRIBUTE_UPDATE_FIELD_NUMBER = 2;
        private java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate> attributeUpdate_;
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.
         * </pre>
         */
        public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate> getAttributeUpdateList() {
          return attributeUpdate_;
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.
         * </pre>
         */
        public java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder> 
            getAttributeUpdateOrBuilderList() {
          return attributeUpdate_;
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.
         * </pre>
         */
        public int getAttributeUpdateCount() {
          return attributeUpdate_.size();
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.
         * </pre>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate getAttributeUpdate(int index) {
          return attributeUpdate_.get(index);
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.
         * </pre>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder getAttributeUpdateOrBuilder(
            int index) {
          return attributeUpdate_.get(index);
        }

        private void initFields() {
          empty_ = false;
          attributeUpdate_ = java.util.Collections.emptyList();
        }
        private byte memoizedIsInitialized = -1;
        public final boolean isInitialized() {
          byte isInitialized = memoizedIsInitialized;
          if (isInitialized != -1) return isInitialized == 1;

          for (int i = 0; i < getAttributeUpdateCount(); i++) {
            if (!getAttributeUpdate(i).isInitialized()) {
              memoizedIsInitialized = 0;
              return false;
            }
          }
          memoizedIsInitialized = 1;
          return true;
        }

        public void writeTo(com.google.protobuf.CodedOutputStream output)
                            throws java.io.IOException {
          getSerializedSize();
          if (((bitField0_ & 0x00000001) == 0x00000001)) {
            output.writeBool(1, empty_);
          }
          for (int i = 0; i < attributeUpdate_.size(); i++) {
            output.writeMessage(2, attributeUpdate_.get(i));
          }
          getUnknownFields().writeTo(output);
        }

        private int memoizedSerializedSize = -1;
        public int getSerializedSize() {
          int size = memoizedSerializedSize;
          if (size != -1) return size;

          size = 0;
          if (((bitField0_ & 0x00000001) == 0x00000001)) {
            size += com.google.protobuf.CodedOutputStream
              .computeBoolSize(1, empty_);
          }
          for (int i = 0; i < attributeUpdate_.size(); i++) {
            size += com.google.protobuf.CodedOutputStream
              .computeMessageSize(2, attributeUpdate_.get(i));
          }
          size += getUnknownFields().getSerializedSize();
          memoizedSerializedSize = size;
          return size;
        }

        private static final long serialVersionUID = 0L;
        @java.lang.Override
        protected java.lang.Object writeReplace()
            throws java.io.ObjectStreamException {
          return super.writeReplace();
        }

        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes parseFrom(
            com.google.protobuf.ByteString data)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes parseFrom(
            com.google.protobuf.ByteString data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes parseFrom(byte[] data)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes parseFrom(
            byte[] data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes parseFrom(java.io.InputStream input)
            throws java.io.IOException {
          return PARSER.parseFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes parseFrom(
            java.io.InputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseFrom(input, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes parseDelimitedFrom(java.io.InputStream input)
            throws java.io.IOException {
          return PARSER.parseDelimitedFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes parseDelimitedFrom(
            java.io.InputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseDelimitedFrom(input, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes parseFrom(
            com.google.protobuf.CodedInputStream input)
            throws java.io.IOException {
          return PARSER.parseFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes parseFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseFrom(input, extensionRegistry);
        }

        public static Builder newBuilder() { return Builder.create(); }
        public Builder newBuilderForType() { return newBuilder(); }
        public static Builder newBuilder(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes prototype) {
          return newBuilder().mergeFrom(prototype);
        }
        public Builder toBuilder() { return newBuilder(this); }

        @java.lang.Override
        protected Builder newBuilderForType(
            com.google.protobuf.GeneratedMessage.BuilderParent parent) {
          Builder builder = new Builder(parent);
          return builder;
        }
        /**
         * Protobuf type {@code federation.ProtocolDocumentOperation.Component.UpdateAttributes}
         */
        public static final class Builder extends
            com.google.protobuf.GeneratedMessage.Builder<Builder>
           implements org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributesOrBuilder {
          public static final com.google.protobuf.Descriptors.Descriptor
              getDescriptor() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_UpdateAttributes_descriptor;
          }

          protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
              internalGetFieldAccessorTable() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_UpdateAttributes_fieldAccessorTable
                .ensureFieldAccessorsInitialized(
                    org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.class, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.Builder.class);
          }

          // Construct using org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.newBuilder()
          private Builder() {
            maybeForceBuilderInitialization();
          }

          private Builder(
              com.google.protobuf.GeneratedMessage.BuilderParent parent) {
            super(parent);
            maybeForceBuilderInitialization();
          }
          private void maybeForceBuilderInitialization() {
            if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
              getAttributeUpdateFieldBuilder();
            }
          }
          private static Builder create() {
            return new Builder();
          }

          public Builder clear() {
            super.clear();
            empty_ = false;
            bitField0_ = (bitField0_ & ~0x00000001);
            if (attributeUpdateBuilder_ == null) {
              attributeUpdate_ = java.util.Collections.emptyList();
              bitField0_ = (bitField0_ & ~0x00000002);
            } else {
              attributeUpdateBuilder_.clear();
            }
            return this;
          }

          public Builder clone() {
            return create().mergeFrom(buildPartial());
          }

          public com.google.protobuf.Descriptors.Descriptor
              getDescriptorForType() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_UpdateAttributes_descriptor;
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes getDefaultInstanceForType() {
            return org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.getDefaultInstance();
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes build() {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes result = buildPartial();
            if (!result.isInitialized()) {
              throw newUninitializedMessageException(result);
            }
            return result;
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes buildPartial() {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes result = new org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes(this);
            int from_bitField0_ = bitField0_;
            int to_bitField0_ = 0;
            if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
              to_bitField0_ |= 0x00000001;
            }
            result.empty_ = empty_;
            if (attributeUpdateBuilder_ == null) {
              if (((bitField0_ & 0x00000002) == 0x00000002)) {
                attributeUpdate_ = java.util.Collections.unmodifiableList(attributeUpdate_);
                bitField0_ = (bitField0_ & ~0x00000002);
              }
              result.attributeUpdate_ = attributeUpdate_;
            } else {
              result.attributeUpdate_ = attributeUpdateBuilder_.build();
            }
            result.bitField0_ = to_bitField0_;
            onBuilt();
            return result;
          }

          public Builder mergeFrom(com.google.protobuf.Message other) {
            if (other instanceof org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes) {
              return mergeFrom((org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes)other);
            } else {
              super.mergeFrom(other);
              return this;
            }
          }

          public Builder mergeFrom(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes other) {
            if (other == org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.getDefaultInstance()) return this;
            if (other.hasEmpty()) {
              setEmpty(other.getEmpty());
            }
            if (attributeUpdateBuilder_ == null) {
              if (!other.attributeUpdate_.isEmpty()) {
                if (attributeUpdate_.isEmpty()) {
                  attributeUpdate_ = other.attributeUpdate_;
                  bitField0_ = (bitField0_ & ~0x00000002);
                } else {
                  ensureAttributeUpdateIsMutable();
                  attributeUpdate_.addAll(other.attributeUpdate_);
                }
                onChanged();
              }
            } else {
              if (!other.attributeUpdate_.isEmpty()) {
                if (attributeUpdateBuilder_.isEmpty()) {
                  attributeUpdateBuilder_.dispose();
                  attributeUpdateBuilder_ = null;
                  attributeUpdate_ = other.attributeUpdate_;
                  bitField0_ = (bitField0_ & ~0x00000002);
                  attributeUpdateBuilder_ = 
                    com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                       getAttributeUpdateFieldBuilder() : null;
                } else {
                  attributeUpdateBuilder_.addAllMessages(other.attributeUpdate_);
                }
              }
            }
            this.mergeUnknownFields(other.getUnknownFields());
            return this;
          }

          public final boolean isInitialized() {
            for (int i = 0; i < getAttributeUpdateCount(); i++) {
              if (!getAttributeUpdate(i).isInitialized()) {
                
                return false;
              }
            }
            return true;
          }

          public Builder mergeFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws java.io.IOException {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes parsedMessage = null;
            try {
              parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
            } catch (com.google.protobuf.InvalidProtocolBufferException e) {
              parsedMessage = (org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes) e.getUnfinishedMessage();
              throw e;
            } finally {
              if (parsedMessage != null) {
                mergeFrom(parsedMessage);
              }
            }
            return this;
          }
          private int bitField0_;

          // optional bool empty = 1;
          private boolean empty_ ;
          /**
           * <code>optional bool empty = 1;</code>
           *
           * <pre>
           * This field is set to true if and only if attributeUpdates are empty.
           * It is needed to ensure that the optional updateAttributes
           * component field is not dropped during serialization.
           * </pre>
           */
          public boolean hasEmpty() {
            return ((bitField0_ & 0x00000001) == 0x00000001);
          }
          /**
           * <code>optional bool empty = 1;</code>
           *
           * <pre>
           * This field is set to true if and only if attributeUpdates are empty.
           * It is needed to ensure that the optional updateAttributes
           * component field is not dropped during serialization.
           * </pre>
           */
          public boolean getEmpty() {
            return empty_;
          }
          /**
           * <code>optional bool empty = 1;</code>
           *
           * <pre>
           * This field is set to true if and only if attributeUpdates are empty.
           * It is needed to ensure that the optional updateAttributes
           * component field is not dropped during serialization.
           * </pre>
           */
          public Builder setEmpty(boolean value) {
            bitField0_ |= 0x00000001;
            empty_ = value;
            onChanged();
            return this;
          }
          /**
           * <code>optional bool empty = 1;</code>
           *
           * <pre>
           * This field is set to true if and only if attributeUpdates are empty.
           * It is needed to ensure that the optional updateAttributes
           * component field is not dropped during serialization.
           * </pre>
           */
          public Builder clearEmpty() {
            bitField0_ = (bitField0_ & ~0x00000001);
            empty_ = false;
            onChanged();
            return this;
          }

          // repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;
          private java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate> attributeUpdate_ =
            java.util.Collections.emptyList();
          private void ensureAttributeUpdateIsMutable() {
            if (!((bitField0_ & 0x00000002) == 0x00000002)) {
              attributeUpdate_ = new java.util.ArrayList<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate>(attributeUpdate_);
              bitField0_ |= 0x00000002;
             }
          }

          private com.google.protobuf.RepeatedFieldBuilder<
              org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder> attributeUpdateBuilder_;

          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate> getAttributeUpdateList() {
            if (attributeUpdateBuilder_ == null) {
              return java.util.Collections.unmodifiableList(attributeUpdate_);
            } else {
              return attributeUpdateBuilder_.getMessageList();
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public int getAttributeUpdateCount() {
            if (attributeUpdateBuilder_ == null) {
              return attributeUpdate_.size();
            } else {
              return attributeUpdateBuilder_.getCount();
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate getAttributeUpdate(int index) {
            if (attributeUpdateBuilder_ == null) {
              return attributeUpdate_.get(index);
            } else {
              return attributeUpdateBuilder_.getMessage(index);
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public Builder setAttributeUpdate(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate value) {
            if (attributeUpdateBuilder_ == null) {
              if (value == null) {
                throw new NullPointerException();
              }
              ensureAttributeUpdateIsMutable();
              attributeUpdate_.set(index, value);
              onChanged();
            } else {
              attributeUpdateBuilder_.setMessage(index, value);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public Builder setAttributeUpdate(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder builderForValue) {
            if (attributeUpdateBuilder_ == null) {
              ensureAttributeUpdateIsMutable();
              attributeUpdate_.set(index, builderForValue.build());
              onChanged();
            } else {
              attributeUpdateBuilder_.setMessage(index, builderForValue.build());
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public Builder addAttributeUpdate(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate value) {
            if (attributeUpdateBuilder_ == null) {
              if (value == null) {
                throw new NullPointerException();
              }
              ensureAttributeUpdateIsMutable();
              attributeUpdate_.add(value);
              onChanged();
            } else {
              attributeUpdateBuilder_.addMessage(value);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public Builder addAttributeUpdate(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate value) {
            if (attributeUpdateBuilder_ == null) {
              if (value == null) {
                throw new NullPointerException();
              }
              ensureAttributeUpdateIsMutable();
              attributeUpdate_.add(index, value);
              onChanged();
            } else {
              attributeUpdateBuilder_.addMessage(index, value);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public Builder addAttributeUpdate(
              org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder builderForValue) {
            if (attributeUpdateBuilder_ == null) {
              ensureAttributeUpdateIsMutable();
              attributeUpdate_.add(builderForValue.build());
              onChanged();
            } else {
              attributeUpdateBuilder_.addMessage(builderForValue.build());
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public Builder addAttributeUpdate(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder builderForValue) {
            if (attributeUpdateBuilder_ == null) {
              ensureAttributeUpdateIsMutable();
              attributeUpdate_.add(index, builderForValue.build());
              onChanged();
            } else {
              attributeUpdateBuilder_.addMessage(index, builderForValue.build());
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public Builder addAllAttributeUpdate(
              java.lang.Iterable<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate> values) {
            if (attributeUpdateBuilder_ == null) {
              ensureAttributeUpdateIsMutable();
              super.addAll(values, attributeUpdate_);
              onChanged();
            } else {
              attributeUpdateBuilder_.addAllMessages(values);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public Builder clearAttributeUpdate() {
            if (attributeUpdateBuilder_ == null) {
              attributeUpdate_ = java.util.Collections.emptyList();
              bitField0_ = (bitField0_ & ~0x00000002);
              onChanged();
            } else {
              attributeUpdateBuilder_.clear();
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public Builder removeAttributeUpdate(int index) {
            if (attributeUpdateBuilder_ == null) {
              ensureAttributeUpdateIsMutable();
              attributeUpdate_.remove(index);
              onChanged();
            } else {
              attributeUpdateBuilder_.remove(index);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder getAttributeUpdateBuilder(
              int index) {
            return getAttributeUpdateFieldBuilder().getBuilder(index);
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder getAttributeUpdateOrBuilder(
              int index) {
            if (attributeUpdateBuilder_ == null) {
              return attributeUpdate_.get(index);  } else {
              return attributeUpdateBuilder_.getMessageOrBuilder(index);
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder> 
               getAttributeUpdateOrBuilderList() {
            if (attributeUpdateBuilder_ != null) {
              return attributeUpdateBuilder_.getMessageOrBuilderList();
            } else {
              return java.util.Collections.unmodifiableList(attributeUpdate_);
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder addAttributeUpdateBuilder() {
            return getAttributeUpdateFieldBuilder().addBuilder(
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.getDefaultInstance());
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder addAttributeUpdateBuilder(
              int index) {
            return getAttributeUpdateFieldBuilder().addBuilder(
                index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.getDefaultInstance());
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate attribute_update = 2;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.
           * </pre>
           */
          public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder> 
               getAttributeUpdateBuilderList() {
            return getAttributeUpdateFieldBuilder().getBuilderList();
          }
          private com.google.protobuf.RepeatedFieldBuilder<
              org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder> 
              getAttributeUpdateFieldBuilder() {
            if (attributeUpdateBuilder_ == null) {
              attributeUpdateBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
                  org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder>(
                      attributeUpdate_,
                      ((bitField0_ & 0x00000002) == 0x00000002),
                      getParentForChildren(),
                      isClean());
              attributeUpdate_ = null;
            }
            return attributeUpdateBuilder_;
          }

          // @@protoc_insertion_point(builder_scope:federation.ProtocolDocumentOperation.Component.UpdateAttributes)
        }

        static {
          defaultInstance = new UpdateAttributes(true);
          defaultInstance.initFields();
        }

        // @@protoc_insertion_point(class_scope:federation.ProtocolDocumentOperation.Component.UpdateAttributes)
      }

      public interface AnnotationBoundaryOrBuilder
          extends com.google.protobuf.MessageOrBuilder {

        // optional bool empty = 1;
        /**
         * <code>optional bool empty = 1;</code>
         *
         * <pre>
         * This field is set to true if and only if both ends and changes are
         * empty.  It is needed to ensure that the optional annotationBoundary
         * component field is not dropped during serialization.
         * </pre>
         */
        boolean hasEmpty();
        /**
         * <code>optional bool empty = 1;</code>
         *
         * <pre>
         * This field is set to true if and only if both ends and changes are
         * empty.  It is needed to ensure that the optional annotationBoundary
         * component field is not dropped during serialization.
         * </pre>
         */
        boolean getEmpty();

        // repeated string end = 2;
        /**
         * <code>repeated string end = 2;</code>
         *
         * <pre>
         * MUST NOT have the same string twice.
         * </pre>
         */
        java.util.List<java.lang.String>
        getEndList();
        /**
         * <code>repeated string end = 2;</code>
         *
         * <pre>
         * MUST NOT have the same string twice.
         * </pre>
         */
        int getEndCount();
        /**
         * <code>repeated string end = 2;</code>
         *
         * <pre>
         * MUST NOT have the same string twice.
         * </pre>
         */
        java.lang.String getEnd(int index);
        /**
         * <code>repeated string end = 2;</code>
         *
         * <pre>
         * MUST NOT have the same string twice.
         * </pre>
         */
        com.google.protobuf.ByteString
            getEndBytes(int index);

        // repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.  MUST NOT
         * contain any of the strings listed in the 'end' field.
         * </pre>
         */
        java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate> 
            getChangeList();
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.  MUST NOT
         * contain any of the strings listed in the 'end' field.
         * </pre>
         */
        org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate getChange(int index);
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.  MUST NOT
         * contain any of the strings listed in the 'end' field.
         * </pre>
         */
        int getChangeCount();
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.  MUST NOT
         * contain any of the strings listed in the 'end' field.
         * </pre>
         */
        java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder> 
            getChangeOrBuilderList();
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.  MUST NOT
         * contain any of the strings listed in the 'end' field.
         * </pre>
         */
        org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder getChangeOrBuilder(
            int index);
      }
      /**
       * Protobuf type {@code federation.ProtocolDocumentOperation.Component.AnnotationBoundary}
       */
      public static final class AnnotationBoundary extends
          com.google.protobuf.GeneratedMessage
          implements AnnotationBoundaryOrBuilder {
        // Use AnnotationBoundary.newBuilder() to construct.
        private AnnotationBoundary(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
          super(builder);
          this.unknownFields = builder.getUnknownFields();
        }
        private AnnotationBoundary(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

        private static final AnnotationBoundary defaultInstance;
        public static AnnotationBoundary getDefaultInstance() {
          return defaultInstance;
        }

        public AnnotationBoundary getDefaultInstanceForType() {
          return defaultInstance;
        }

        private final com.google.protobuf.UnknownFieldSet unknownFields;
        @java.lang.Override
        public final com.google.protobuf.UnknownFieldSet
            getUnknownFields() {
          return this.unknownFields;
        }
        private AnnotationBoundary(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          initFields();
          int mutable_bitField0_ = 0;
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
              com.google.protobuf.UnknownFieldSet.newBuilder();
          try {
            boolean done = false;
            while (!done) {
              int tag = input.readTag();
              switch (tag) {
                case 0:
                  done = true;
                  break;
                default: {
                  if (!parseUnknownField(input, unknownFields,
                                         extensionRegistry, tag)) {
                    done = true;
                  }
                  break;
                }
                case 8: {
                  bitField0_ |= 0x00000001;
                  empty_ = input.readBool();
                  break;
                }
                case 18: {
                  if (!((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
                    end_ = new com.google.protobuf.LazyStringArrayList();
                    mutable_bitField0_ |= 0x00000002;
                  }
                  end_.add(input.readBytes());
                  break;
                }
                case 26: {
                  if (!((mutable_bitField0_ & 0x00000004) == 0x00000004)) {
                    change_ = new java.util.ArrayList<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate>();
                    mutable_bitField0_ |= 0x00000004;
                  }
                  change_.add(input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.PARSER, extensionRegistry));
                  break;
                }
              }
            }
          } catch (com.google.protobuf.InvalidProtocolBufferException e) {
            throw e.setUnfinishedMessage(this);
          } catch (java.io.IOException e) {
            throw new com.google.protobuf.InvalidProtocolBufferException(
                e.getMessage()).setUnfinishedMessage(this);
          } finally {
            if (((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
              end_ = new com.google.protobuf.UnmodifiableLazyStringList(end_);
            }
            if (((mutable_bitField0_ & 0x00000004) == 0x00000004)) {
              change_ = java.util.Collections.unmodifiableList(change_);
            }
            this.unknownFields = unknownFields.build();
            makeExtensionsImmutable();
          }
        }
        public static final com.google.protobuf.Descriptors.Descriptor
            getDescriptor() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_AnnotationBoundary_descriptor;
        }

        protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
            internalGetFieldAccessorTable() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_AnnotationBoundary_fieldAccessorTable
              .ensureFieldAccessorsInitialized(
                  org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.class, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.Builder.class);
        }

        public static com.google.protobuf.Parser<AnnotationBoundary> PARSER =
            new com.google.protobuf.AbstractParser<AnnotationBoundary>() {
          public AnnotationBoundary parsePartialFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws com.google.protobuf.InvalidProtocolBufferException {
            return new AnnotationBoundary(input, extensionRegistry);
          }
        };

        @java.lang.Override
        public com.google.protobuf.Parser<AnnotationBoundary> getParserForType() {
          return PARSER;
        }

        private int bitField0_;
        // optional bool empty = 1;
        public static final int EMPTY_FIELD_NUMBER = 1;
        private boolean empty_;
        /**
         * <code>optional bool empty = 1;</code>
         *
         * <pre>
         * This field is set to true if and only if both ends and changes are
         * empty.  It is needed to ensure that the optional annotationBoundary
         * component field is not dropped during serialization.
         * </pre>
         */
        public boolean hasEmpty() {
          return ((bitField0_ & 0x00000001) == 0x00000001);
        }
        /**
         * <code>optional bool empty = 1;</code>
         *
         * <pre>
         * This field is set to true if and only if both ends and changes are
         * empty.  It is needed to ensure that the optional annotationBoundary
         * component field is not dropped during serialization.
         * </pre>
         */
        public boolean getEmpty() {
          return empty_;
        }

        // repeated string end = 2;
        public static final int END_FIELD_NUMBER = 2;
        private com.google.protobuf.LazyStringList end_;
        /**
         * <code>repeated string end = 2;</code>
         *
         * <pre>
         * MUST NOT have the same string twice.
         * </pre>
         */
        public java.util.List<java.lang.String>
            getEndList() {
          return end_;
        }
        /**
         * <code>repeated string end = 2;</code>
         *
         * <pre>
         * MUST NOT have the same string twice.
         * </pre>
         */
        public int getEndCount() {
          return end_.size();
        }
        /**
         * <code>repeated string end = 2;</code>
         *
         * <pre>
         * MUST NOT have the same string twice.
         * </pre>
         */
        public java.lang.String getEnd(int index) {
          return end_.get(index);
        }
        /**
         * <code>repeated string end = 2;</code>
         *
         * <pre>
         * MUST NOT have the same string twice.
         * </pre>
         */
        public com.google.protobuf.ByteString
            getEndBytes(int index) {
          return end_.getByteString(index);
        }

        // repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;
        public static final int CHANGE_FIELD_NUMBER = 3;
        private java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate> change_;
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.  MUST NOT
         * contain any of the strings listed in the 'end' field.
         * </pre>
         */
        public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate> getChangeList() {
          return change_;
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.  MUST NOT
         * contain any of the strings listed in the 'end' field.
         * </pre>
         */
        public java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder> 
            getChangeOrBuilderList() {
          return change_;
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.  MUST NOT
         * contain any of the strings listed in the 'end' field.
         * </pre>
         */
        public int getChangeCount() {
          return change_.size();
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.  MUST NOT
         * contain any of the strings listed in the 'end' field.
         * </pre>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate getChange(int index) {
          return change_.get(index);
        }
        /**
         * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
         *
         * <pre>
         * MUST NOT have two updates with the same key.  MUST NOT
         * contain any of the strings listed in the 'end' field.
         * </pre>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder getChangeOrBuilder(
            int index) {
          return change_.get(index);
        }

        private void initFields() {
          empty_ = false;
          end_ = com.google.protobuf.LazyStringArrayList.EMPTY;
          change_ = java.util.Collections.emptyList();
        }
        private byte memoizedIsInitialized = -1;
        public final boolean isInitialized() {
          byte isInitialized = memoizedIsInitialized;
          if (isInitialized != -1) return isInitialized == 1;

          for (int i = 0; i < getChangeCount(); i++) {
            if (!getChange(i).isInitialized()) {
              memoizedIsInitialized = 0;
              return false;
            }
          }
          memoizedIsInitialized = 1;
          return true;
        }

        public void writeTo(com.google.protobuf.CodedOutputStream output)
                            throws java.io.IOException {
          getSerializedSize();
          if (((bitField0_ & 0x00000001) == 0x00000001)) {
            output.writeBool(1, empty_);
          }
          for (int i = 0; i < end_.size(); i++) {
            output.writeBytes(2, end_.getByteString(i));
          }
          for (int i = 0; i < change_.size(); i++) {
            output.writeMessage(3, change_.get(i));
          }
          getUnknownFields().writeTo(output);
        }

        private int memoizedSerializedSize = -1;
        public int getSerializedSize() {
          int size = memoizedSerializedSize;
          if (size != -1) return size;

          size = 0;
          if (((bitField0_ & 0x00000001) == 0x00000001)) {
            size += com.google.protobuf.CodedOutputStream
              .computeBoolSize(1, empty_);
          }
          {
            int dataSize = 0;
            for (int i = 0; i < end_.size(); i++) {
              dataSize += com.google.protobuf.CodedOutputStream
                .computeBytesSizeNoTag(end_.getByteString(i));
            }
            size += dataSize;
            size += 1 * getEndList().size();
          }
          for (int i = 0; i < change_.size(); i++) {
            size += com.google.protobuf.CodedOutputStream
              .computeMessageSize(3, change_.get(i));
          }
          size += getUnknownFields().getSerializedSize();
          memoizedSerializedSize = size;
          return size;
        }

        private static final long serialVersionUID = 0L;
        @java.lang.Override
        protected java.lang.Object writeReplace()
            throws java.io.ObjectStreamException {
          return super.writeReplace();
        }

        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary parseFrom(
            com.google.protobuf.ByteString data)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary parseFrom(
            com.google.protobuf.ByteString data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary parseFrom(byte[] data)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary parseFrom(
            byte[] data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          return PARSER.parseFrom(data, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary parseFrom(java.io.InputStream input)
            throws java.io.IOException {
          return PARSER.parseFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary parseFrom(
            java.io.InputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseFrom(input, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary parseDelimitedFrom(java.io.InputStream input)
            throws java.io.IOException {
          return PARSER.parseDelimitedFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary parseDelimitedFrom(
            java.io.InputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseDelimitedFrom(input, extensionRegistry);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary parseFrom(
            com.google.protobuf.CodedInputStream input)
            throws java.io.IOException {
          return PARSER.parseFrom(input);
        }
        public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary parseFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          return PARSER.parseFrom(input, extensionRegistry);
        }

        public static Builder newBuilder() { return Builder.create(); }
        public Builder newBuilderForType() { return newBuilder(); }
        public static Builder newBuilder(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary prototype) {
          return newBuilder().mergeFrom(prototype);
        }
        public Builder toBuilder() { return newBuilder(this); }

        @java.lang.Override
        protected Builder newBuilderForType(
            com.google.protobuf.GeneratedMessage.BuilderParent parent) {
          Builder builder = new Builder(parent);
          return builder;
        }
        /**
         * Protobuf type {@code federation.ProtocolDocumentOperation.Component.AnnotationBoundary}
         */
        public static final class Builder extends
            com.google.protobuf.GeneratedMessage.Builder<Builder>
           implements org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundaryOrBuilder {
          public static final com.google.protobuf.Descriptors.Descriptor
              getDescriptor() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_AnnotationBoundary_descriptor;
          }

          protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
              internalGetFieldAccessorTable() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_AnnotationBoundary_fieldAccessorTable
                .ensureFieldAccessorsInitialized(
                    org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.class, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.Builder.class);
          }

          // Construct using org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.newBuilder()
          private Builder() {
            maybeForceBuilderInitialization();
          }

          private Builder(
              com.google.protobuf.GeneratedMessage.BuilderParent parent) {
            super(parent);
            maybeForceBuilderInitialization();
          }
          private void maybeForceBuilderInitialization() {
            if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
              getChangeFieldBuilder();
            }
          }
          private static Builder create() {
            return new Builder();
          }

          public Builder clear() {
            super.clear();
            empty_ = false;
            bitField0_ = (bitField0_ & ~0x00000001);
            end_ = com.google.protobuf.LazyStringArrayList.EMPTY;
            bitField0_ = (bitField0_ & ~0x00000002);
            if (changeBuilder_ == null) {
              change_ = java.util.Collections.emptyList();
              bitField0_ = (bitField0_ & ~0x00000004);
            } else {
              changeBuilder_.clear();
            }
            return this;
          }

          public Builder clone() {
            return create().mergeFrom(buildPartial());
          }

          public com.google.protobuf.Descriptors.Descriptor
              getDescriptorForType() {
            return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_AnnotationBoundary_descriptor;
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary getDefaultInstanceForType() {
            return org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.getDefaultInstance();
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary build() {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary result = buildPartial();
            if (!result.isInitialized()) {
              throw newUninitializedMessageException(result);
            }
            return result;
          }

          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary buildPartial() {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary result = new org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary(this);
            int from_bitField0_ = bitField0_;
            int to_bitField0_ = 0;
            if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
              to_bitField0_ |= 0x00000001;
            }
            result.empty_ = empty_;
            if (((bitField0_ & 0x00000002) == 0x00000002)) {
              end_ = new com.google.protobuf.UnmodifiableLazyStringList(
                  end_);
              bitField0_ = (bitField0_ & ~0x00000002);
            }
            result.end_ = end_;
            if (changeBuilder_ == null) {
              if (((bitField0_ & 0x00000004) == 0x00000004)) {
                change_ = java.util.Collections.unmodifiableList(change_);
                bitField0_ = (bitField0_ & ~0x00000004);
              }
              result.change_ = change_;
            } else {
              result.change_ = changeBuilder_.build();
            }
            result.bitField0_ = to_bitField0_;
            onBuilt();
            return result;
          }

          public Builder mergeFrom(com.google.protobuf.Message other) {
            if (other instanceof org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary) {
              return mergeFrom((org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary)other);
            } else {
              super.mergeFrom(other);
              return this;
            }
          }

          public Builder mergeFrom(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary other) {
            if (other == org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.getDefaultInstance()) return this;
            if (other.hasEmpty()) {
              setEmpty(other.getEmpty());
            }
            if (!other.end_.isEmpty()) {
              if (end_.isEmpty()) {
                end_ = other.end_;
                bitField0_ = (bitField0_ & ~0x00000002);
              } else {
                ensureEndIsMutable();
                end_.addAll(other.end_);
              }
              onChanged();
            }
            if (changeBuilder_ == null) {
              if (!other.change_.isEmpty()) {
                if (change_.isEmpty()) {
                  change_ = other.change_;
                  bitField0_ = (bitField0_ & ~0x00000004);
                } else {
                  ensureChangeIsMutable();
                  change_.addAll(other.change_);
                }
                onChanged();
              }
            } else {
              if (!other.change_.isEmpty()) {
                if (changeBuilder_.isEmpty()) {
                  changeBuilder_.dispose();
                  changeBuilder_ = null;
                  change_ = other.change_;
                  bitField0_ = (bitField0_ & ~0x00000004);
                  changeBuilder_ = 
                    com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                       getChangeFieldBuilder() : null;
                } else {
                  changeBuilder_.addAllMessages(other.change_);
                }
              }
            }
            this.mergeUnknownFields(other.getUnknownFields());
            return this;
          }

          public final boolean isInitialized() {
            for (int i = 0; i < getChangeCount(); i++) {
              if (!getChange(i).isInitialized()) {
                
                return false;
              }
            }
            return true;
          }

          public Builder mergeFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws java.io.IOException {
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary parsedMessage = null;
            try {
              parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
            } catch (com.google.protobuf.InvalidProtocolBufferException e) {
              parsedMessage = (org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary) e.getUnfinishedMessage();
              throw e;
            } finally {
              if (parsedMessage != null) {
                mergeFrom(parsedMessage);
              }
            }
            return this;
          }
          private int bitField0_;

          // optional bool empty = 1;
          private boolean empty_ ;
          /**
           * <code>optional bool empty = 1;</code>
           *
           * <pre>
           * This field is set to true if and only if both ends and changes are
           * empty.  It is needed to ensure that the optional annotationBoundary
           * component field is not dropped during serialization.
           * </pre>
           */
          public boolean hasEmpty() {
            return ((bitField0_ & 0x00000001) == 0x00000001);
          }
          /**
           * <code>optional bool empty = 1;</code>
           *
           * <pre>
           * This field is set to true if and only if both ends and changes are
           * empty.  It is needed to ensure that the optional annotationBoundary
           * component field is not dropped during serialization.
           * </pre>
           */
          public boolean getEmpty() {
            return empty_;
          }
          /**
           * <code>optional bool empty = 1;</code>
           *
           * <pre>
           * This field is set to true if and only if both ends and changes are
           * empty.  It is needed to ensure that the optional annotationBoundary
           * component field is not dropped during serialization.
           * </pre>
           */
          public Builder setEmpty(boolean value) {
            bitField0_ |= 0x00000001;
            empty_ = value;
            onChanged();
            return this;
          }
          /**
           * <code>optional bool empty = 1;</code>
           *
           * <pre>
           * This field is set to true if and only if both ends and changes are
           * empty.  It is needed to ensure that the optional annotationBoundary
           * component field is not dropped during serialization.
           * </pre>
           */
          public Builder clearEmpty() {
            bitField0_ = (bitField0_ & ~0x00000001);
            empty_ = false;
            onChanged();
            return this;
          }

          // repeated string end = 2;
          private com.google.protobuf.LazyStringList end_ = com.google.protobuf.LazyStringArrayList.EMPTY;
          private void ensureEndIsMutable() {
            if (!((bitField0_ & 0x00000002) == 0x00000002)) {
              end_ = new com.google.protobuf.LazyStringArrayList(end_);
              bitField0_ |= 0x00000002;
             }
          }
          /**
           * <code>repeated string end = 2;</code>
           *
           * <pre>
           * MUST NOT have the same string twice.
           * </pre>
           */
          public java.util.List<java.lang.String>
              getEndList() {
            return java.util.Collections.unmodifiableList(end_);
          }
          /**
           * <code>repeated string end = 2;</code>
           *
           * <pre>
           * MUST NOT have the same string twice.
           * </pre>
           */
          public int getEndCount() {
            return end_.size();
          }
          /**
           * <code>repeated string end = 2;</code>
           *
           * <pre>
           * MUST NOT have the same string twice.
           * </pre>
           */
          public java.lang.String getEnd(int index) {
            return end_.get(index);
          }
          /**
           * <code>repeated string end = 2;</code>
           *
           * <pre>
           * MUST NOT have the same string twice.
           * </pre>
           */
          public com.google.protobuf.ByteString
              getEndBytes(int index) {
            return end_.getByteString(index);
          }
          /**
           * <code>repeated string end = 2;</code>
           *
           * <pre>
           * MUST NOT have the same string twice.
           * </pre>
           */
          public Builder setEnd(
              int index, java.lang.String value) {
            if (value == null) {
    throw new NullPointerException();
  }
  ensureEndIsMutable();
            end_.set(index, value);
            onChanged();
            return this;
          }
          /**
           * <code>repeated string end = 2;</code>
           *
           * <pre>
           * MUST NOT have the same string twice.
           * </pre>
           */
          public Builder addEnd(
              java.lang.String value) {
            if (value == null) {
    throw new NullPointerException();
  }
  ensureEndIsMutable();
            end_.add(value);
            onChanged();
            return this;
          }
          /**
           * <code>repeated string end = 2;</code>
           *
           * <pre>
           * MUST NOT have the same string twice.
           * </pre>
           */
          public Builder addAllEnd(
              java.lang.Iterable<java.lang.String> values) {
            ensureEndIsMutable();
            super.addAll(values, end_);
            onChanged();
            return this;
          }
          /**
           * <code>repeated string end = 2;</code>
           *
           * <pre>
           * MUST NOT have the same string twice.
           * </pre>
           */
          public Builder clearEnd() {
            end_ = com.google.protobuf.LazyStringArrayList.EMPTY;
            bitField0_ = (bitField0_ & ~0x00000002);
            onChanged();
            return this;
          }
          /**
           * <code>repeated string end = 2;</code>
           *
           * <pre>
           * MUST NOT have the same string twice.
           * </pre>
           */
          public Builder addEndBytes(
              com.google.protobuf.ByteString value) {
            if (value == null) {
    throw new NullPointerException();
  }
  ensureEndIsMutable();
            end_.add(value);
            onChanged();
            return this;
          }

          // repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;
          private java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate> change_ =
            java.util.Collections.emptyList();
          private void ensureChangeIsMutable() {
            if (!((bitField0_ & 0x00000004) == 0x00000004)) {
              change_ = new java.util.ArrayList<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate>(change_);
              bitField0_ |= 0x00000004;
             }
          }

          private com.google.protobuf.RepeatedFieldBuilder<
              org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder> changeBuilder_;

          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate> getChangeList() {
            if (changeBuilder_ == null) {
              return java.util.Collections.unmodifiableList(change_);
            } else {
              return changeBuilder_.getMessageList();
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public int getChangeCount() {
            if (changeBuilder_ == null) {
              return change_.size();
            } else {
              return changeBuilder_.getCount();
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate getChange(int index) {
            if (changeBuilder_ == null) {
              return change_.get(index);
            } else {
              return changeBuilder_.getMessage(index);
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public Builder setChange(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate value) {
            if (changeBuilder_ == null) {
              if (value == null) {
                throw new NullPointerException();
              }
              ensureChangeIsMutable();
              change_.set(index, value);
              onChanged();
            } else {
              changeBuilder_.setMessage(index, value);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public Builder setChange(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder builderForValue) {
            if (changeBuilder_ == null) {
              ensureChangeIsMutable();
              change_.set(index, builderForValue.build());
              onChanged();
            } else {
              changeBuilder_.setMessage(index, builderForValue.build());
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public Builder addChange(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate value) {
            if (changeBuilder_ == null) {
              if (value == null) {
                throw new NullPointerException();
              }
              ensureChangeIsMutable();
              change_.add(value);
              onChanged();
            } else {
              changeBuilder_.addMessage(value);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public Builder addChange(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate value) {
            if (changeBuilder_ == null) {
              if (value == null) {
                throw new NullPointerException();
              }
              ensureChangeIsMutable();
              change_.add(index, value);
              onChanged();
            } else {
              changeBuilder_.addMessage(index, value);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public Builder addChange(
              org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder builderForValue) {
            if (changeBuilder_ == null) {
              ensureChangeIsMutable();
              change_.add(builderForValue.build());
              onChanged();
            } else {
              changeBuilder_.addMessage(builderForValue.build());
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public Builder addChange(
              int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder builderForValue) {
            if (changeBuilder_ == null) {
              ensureChangeIsMutable();
              change_.add(index, builderForValue.build());
              onChanged();
            } else {
              changeBuilder_.addMessage(index, builderForValue.build());
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public Builder addAllChange(
              java.lang.Iterable<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate> values) {
            if (changeBuilder_ == null) {
              ensureChangeIsMutable();
              super.addAll(values, change_);
              onChanged();
            } else {
              changeBuilder_.addAllMessages(values);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public Builder clearChange() {
            if (changeBuilder_ == null) {
              change_ = java.util.Collections.emptyList();
              bitField0_ = (bitField0_ & ~0x00000004);
              onChanged();
            } else {
              changeBuilder_.clear();
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public Builder removeChange(int index) {
            if (changeBuilder_ == null) {
              ensureChangeIsMutable();
              change_.remove(index);
              onChanged();
            } else {
              changeBuilder_.remove(index);
            }
            return this;
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder getChangeBuilder(
              int index) {
            return getChangeFieldBuilder().getBuilder(index);
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder getChangeOrBuilder(
              int index) {
            if (changeBuilder_ == null) {
              return change_.get(index);  } else {
              return changeBuilder_.getMessageOrBuilder(index);
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder> 
               getChangeOrBuilderList() {
            if (changeBuilder_ != null) {
              return changeBuilder_.getMessageOrBuilderList();
            } else {
              return java.util.Collections.unmodifiableList(change_);
            }
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder addChangeBuilder() {
            return getChangeFieldBuilder().addBuilder(
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.getDefaultInstance());
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder addChangeBuilder(
              int index) {
            return getChangeFieldBuilder().addBuilder(
                index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.getDefaultInstance());
          }
          /**
           * <code>repeated .federation.ProtocolDocumentOperation.Component.KeyValueUpdate change = 3;</code>
           *
           * <pre>
           * MUST NOT have two updates with the same key.  MUST NOT
           * contain any of the strings listed in the 'end' field.
           * </pre>
           */
          public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder> 
               getChangeBuilderList() {
            return getChangeFieldBuilder().getBuilderList();
          }
          private com.google.protobuf.RepeatedFieldBuilder<
              org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder> 
              getChangeFieldBuilder() {
            if (changeBuilder_ == null) {
              changeBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
                  org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdate.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.KeyValueUpdateOrBuilder>(
                      change_,
                      ((bitField0_ & 0x00000004) == 0x00000004),
                      getParentForChildren(),
                      isClean());
              change_ = null;
            }
            return changeBuilder_;
          }

          // @@protoc_insertion_point(builder_scope:federation.ProtocolDocumentOperation.Component.AnnotationBoundary)
        }

        static {
          defaultInstance = new AnnotationBoundary(true);
          defaultInstance.initFields();
        }

        // @@protoc_insertion_point(class_scope:federation.ProtocolDocumentOperation.Component.AnnotationBoundary)
      }

      private int bitField0_;
      // optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;
      public static final int ANNOTATION_BOUNDARY_FIELD_NUMBER = 1;
      private org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary annotationBoundary_;
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;</code>
       */
      public boolean hasAnnotationBoundary() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary getAnnotationBoundary() {
        return annotationBoundary_;
      }
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundaryOrBuilder getAnnotationBoundaryOrBuilder() {
        return annotationBoundary_;
      }

      // optional string characters = 2;
      public static final int CHARACTERS_FIELD_NUMBER = 2;
      private java.lang.Object characters_;
      /**
       * <code>optional string characters = 2;</code>
       */
      public boolean hasCharacters() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      /**
       * <code>optional string characters = 2;</code>
       */
      public java.lang.String getCharacters() {
        java.lang.Object ref = characters_;
        if (ref instanceof java.lang.String) {
          return (java.lang.String) ref;
        } else {
          com.google.protobuf.ByteString bs = 
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          if (bs.isValidUtf8()) {
            characters_ = s;
          }
          return s;
        }
      }
      /**
       * <code>optional string characters = 2;</code>
       */
      public com.google.protobuf.ByteString
          getCharactersBytes() {
        java.lang.Object ref = characters_;
        if (ref instanceof java.lang.String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          characters_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }

      // optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;
      public static final int ELEMENT_START_FIELD_NUMBER = 3;
      private org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart elementStart_;
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;</code>
       */
      public boolean hasElementStart() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart getElementStart() {
        return elementStart_;
      }
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStartOrBuilder getElementStartOrBuilder() {
        return elementStart_;
      }

      // optional bool element_end = 4;
      public static final int ELEMENT_END_FIELD_NUMBER = 4;
      private boolean elementEnd_;
      /**
       * <code>optional bool element_end = 4;</code>
       */
      public boolean hasElementEnd() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      /**
       * <code>optional bool element_end = 4;</code>
       */
      public boolean getElementEnd() {
        return elementEnd_;
      }

      // optional int32 retain_item_count = 5;
      public static final int RETAIN_ITEM_COUNT_FIELD_NUMBER = 5;
      private int retainItemCount_;
      /**
       * <code>optional int32 retain_item_count = 5;</code>
       */
      public boolean hasRetainItemCount() {
        return ((bitField0_ & 0x00000010) == 0x00000010);
      }
      /**
       * <code>optional int32 retain_item_count = 5;</code>
       */
      public int getRetainItemCount() {
        return retainItemCount_;
      }

      // optional string delete_characters = 6;
      public static final int DELETE_CHARACTERS_FIELD_NUMBER = 6;
      private java.lang.Object deleteCharacters_;
      /**
       * <code>optional string delete_characters = 6;</code>
       */
      public boolean hasDeleteCharacters() {
        return ((bitField0_ & 0x00000020) == 0x00000020);
      }
      /**
       * <code>optional string delete_characters = 6;</code>
       */
      public java.lang.String getDeleteCharacters() {
        java.lang.Object ref = deleteCharacters_;
        if (ref instanceof java.lang.String) {
          return (java.lang.String) ref;
        } else {
          com.google.protobuf.ByteString bs = 
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          if (bs.isValidUtf8()) {
            deleteCharacters_ = s;
          }
          return s;
        }
      }
      /**
       * <code>optional string delete_characters = 6;</code>
       */
      public com.google.protobuf.ByteString
          getDeleteCharactersBytes() {
        java.lang.Object ref = deleteCharacters_;
        if (ref instanceof java.lang.String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          deleteCharacters_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }

      // optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;
      public static final int DELETE_ELEMENT_START_FIELD_NUMBER = 7;
      private org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart deleteElementStart_;
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;</code>
       */
      public boolean hasDeleteElementStart() {
        return ((bitField0_ & 0x00000040) == 0x00000040);
      }
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart getDeleteElementStart() {
        return deleteElementStart_;
      }
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStartOrBuilder getDeleteElementStartOrBuilder() {
        return deleteElementStart_;
      }

      // optional bool delete_element_end = 8;
      public static final int DELETE_ELEMENT_END_FIELD_NUMBER = 8;
      private boolean deleteElementEnd_;
      /**
       * <code>optional bool delete_element_end = 8;</code>
       */
      public boolean hasDeleteElementEnd() {
        return ((bitField0_ & 0x00000080) == 0x00000080);
      }
      /**
       * <code>optional bool delete_element_end = 8;</code>
       */
      public boolean getDeleteElementEnd() {
        return deleteElementEnd_;
      }

      // optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;
      public static final int REPLACE_ATTRIBUTES_FIELD_NUMBER = 9;
      private org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes replaceAttributes_;
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;</code>
       */
      public boolean hasReplaceAttributes() {
        return ((bitField0_ & 0x00000100) == 0x00000100);
      }
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes getReplaceAttributes() {
        return replaceAttributes_;
      }
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributesOrBuilder getReplaceAttributesOrBuilder() {
        return replaceAttributes_;
      }

      // optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;
      public static final int UPDATE_ATTRIBUTES_FIELD_NUMBER = 10;
      private org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes updateAttributes_;
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;</code>
       */
      public boolean hasUpdateAttributes() {
        return ((bitField0_ & 0x00000200) == 0x00000200);
      }
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes getUpdateAttributes() {
        return updateAttributes_;
      }
      /**
       * <code>optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributesOrBuilder getUpdateAttributesOrBuilder() {
        return updateAttributes_;
      }

      private void initFields() {
        annotationBoundary_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.getDefaultInstance();
        characters_ = "";
        elementStart_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.getDefaultInstance();
        elementEnd_ = false;
        retainItemCount_ = 0;
        deleteCharacters_ = "";
        deleteElementStart_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.getDefaultInstance();
        deleteElementEnd_ = false;
        replaceAttributes_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.getDefaultInstance();
        updateAttributes_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.getDefaultInstance();
      }
      private byte memoizedIsInitialized = -1;
      public final boolean isInitialized() {
        byte isInitialized = memoizedIsInitialized;
        if (isInitialized != -1) return isInitialized == 1;

        if (hasAnnotationBoundary()) {
          if (!getAnnotationBoundary().isInitialized()) {
            memoizedIsInitialized = 0;
            return false;
          }
        }
        if (hasElementStart()) {
          if (!getElementStart().isInitialized()) {
            memoizedIsInitialized = 0;
            return false;
          }
        }
        if (hasDeleteElementStart()) {
          if (!getDeleteElementStart().isInitialized()) {
            memoizedIsInitialized = 0;
            return false;
          }
        }
        if (hasReplaceAttributes()) {
          if (!getReplaceAttributes().isInitialized()) {
            memoizedIsInitialized = 0;
            return false;
          }
        }
        if (hasUpdateAttributes()) {
          if (!getUpdateAttributes().isInitialized()) {
            memoizedIsInitialized = 0;
            return false;
          }
        }
        memoizedIsInitialized = 1;
        return true;
      }

      public void writeTo(com.google.protobuf.CodedOutputStream output)
                          throws java.io.IOException {
        getSerializedSize();
        if (((bitField0_ & 0x00000001) == 0x00000001)) {
          output.writeMessage(1, annotationBoundary_);
        }
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          output.writeBytes(2, getCharactersBytes());
        }
        if (((bitField0_ & 0x00000004) == 0x00000004)) {
          output.writeMessage(3, elementStart_);
        }
        if (((bitField0_ & 0x00000008) == 0x00000008)) {
          output.writeBool(4, elementEnd_);
        }
        if (((bitField0_ & 0x00000010) == 0x00000010)) {
          output.writeInt32(5, retainItemCount_);
        }
        if (((bitField0_ & 0x00000020) == 0x00000020)) {
          output.writeBytes(6, getDeleteCharactersBytes());
        }
        if (((bitField0_ & 0x00000040) == 0x00000040)) {
          output.writeMessage(7, deleteElementStart_);
        }
        if (((bitField0_ & 0x00000080) == 0x00000080)) {
          output.writeBool(8, deleteElementEnd_);
        }
        if (((bitField0_ & 0x00000100) == 0x00000100)) {
          output.writeMessage(9, replaceAttributes_);
        }
        if (((bitField0_ & 0x00000200) == 0x00000200)) {
          output.writeMessage(10, updateAttributes_);
        }
        getUnknownFields().writeTo(output);
      }

      private int memoizedSerializedSize = -1;
      public int getSerializedSize() {
        int size = memoizedSerializedSize;
        if (size != -1) return size;

        size = 0;
        if (((bitField0_ & 0x00000001) == 0x00000001)) {
          size += com.google.protobuf.CodedOutputStream
            .computeMessageSize(1, annotationBoundary_);
        }
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          size += com.google.protobuf.CodedOutputStream
            .computeBytesSize(2, getCharactersBytes());
        }
        if (((bitField0_ & 0x00000004) == 0x00000004)) {
          size += com.google.protobuf.CodedOutputStream
            .computeMessageSize(3, elementStart_);
        }
        if (((bitField0_ & 0x00000008) == 0x00000008)) {
          size += com.google.protobuf.CodedOutputStream
            .computeBoolSize(4, elementEnd_);
        }
        if (((bitField0_ & 0x00000010) == 0x00000010)) {
          size += com.google.protobuf.CodedOutputStream
            .computeInt32Size(5, retainItemCount_);
        }
        if (((bitField0_ & 0x00000020) == 0x00000020)) {
          size += com.google.protobuf.CodedOutputStream
            .computeBytesSize(6, getDeleteCharactersBytes());
        }
        if (((bitField0_ & 0x00000040) == 0x00000040)) {
          size += com.google.protobuf.CodedOutputStream
            .computeMessageSize(7, deleteElementStart_);
        }
        if (((bitField0_ & 0x00000080) == 0x00000080)) {
          size += com.google.protobuf.CodedOutputStream
            .computeBoolSize(8, deleteElementEnd_);
        }
        if (((bitField0_ & 0x00000100) == 0x00000100)) {
          size += com.google.protobuf.CodedOutputStream
            .computeMessageSize(9, replaceAttributes_);
        }
        if (((bitField0_ & 0x00000200) == 0x00000200)) {
          size += com.google.protobuf.CodedOutputStream
            .computeMessageSize(10, updateAttributes_);
        }
        size += getUnknownFields().getSerializedSize();
        memoizedSerializedSize = size;
        return size;
      }

      private static final long serialVersionUID = 0L;
      @java.lang.Override
      protected java.lang.Object writeReplace()
          throws java.io.ObjectStreamException {
        return super.writeReplace();
      }

      public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component parseFrom(
          com.google.protobuf.ByteString data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component parseFrom(
          com.google.protobuf.ByteString data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component parseFrom(byte[] data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component parseFrom(
          byte[] data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component parseFrom(java.io.InputStream input)
          throws java.io.IOException {
        return PARSER.parseFrom(input);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component parseFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return PARSER.parseFrom(input, extensionRegistry);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component parseDelimitedFrom(java.io.InputStream input)
          throws java.io.IOException {
        return PARSER.parseDelimitedFrom(input);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component parseDelimitedFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return PARSER.parseDelimitedFrom(input, extensionRegistry);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component parseFrom(
          com.google.protobuf.CodedInputStream input)
          throws java.io.IOException {
        return PARSER.parseFrom(input);
      }
      public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component parseFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return PARSER.parseFrom(input, extensionRegistry);
      }

      public static Builder newBuilder() { return Builder.create(); }
      public Builder newBuilderForType() { return newBuilder(); }
      public static Builder newBuilder(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component prototype) {
        return newBuilder().mergeFrom(prototype);
      }
      public Builder toBuilder() { return newBuilder(this); }

      @java.lang.Override
      protected Builder newBuilderForType(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        Builder builder = new Builder(parent);
        return builder;
      }
      /**
       * Protobuf type {@code federation.ProtocolDocumentOperation.Component}
       *
       * <pre>
       **
       * A component of a document operation.  One (and only one) of the component
       * types must be set.
       * </pre>
       */
      public static final class Builder extends
          com.google.protobuf.GeneratedMessage.Builder<Builder>
         implements org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.ComponentOrBuilder {
        public static final com.google.protobuf.Descriptors.Descriptor
            getDescriptor() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_descriptor;
        }

        protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
            internalGetFieldAccessorTable() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_fieldAccessorTable
              .ensureFieldAccessorsInitialized(
                  org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.class, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.Builder.class);
        }

        // Construct using org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.newBuilder()
        private Builder() {
          maybeForceBuilderInitialization();
        }

        private Builder(
            com.google.protobuf.GeneratedMessage.BuilderParent parent) {
          super(parent);
          maybeForceBuilderInitialization();
        }
        private void maybeForceBuilderInitialization() {
          if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
            getAnnotationBoundaryFieldBuilder();
            getElementStartFieldBuilder();
            getDeleteElementStartFieldBuilder();
            getReplaceAttributesFieldBuilder();
            getUpdateAttributesFieldBuilder();
          }
        }
        private static Builder create() {
          return new Builder();
        }

        public Builder clear() {
          super.clear();
          if (annotationBoundaryBuilder_ == null) {
            annotationBoundary_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.getDefaultInstance();
          } else {
            annotationBoundaryBuilder_.clear();
          }
          bitField0_ = (bitField0_ & ~0x00000001);
          characters_ = "";
          bitField0_ = (bitField0_ & ~0x00000002);
          if (elementStartBuilder_ == null) {
            elementStart_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.getDefaultInstance();
          } else {
            elementStartBuilder_.clear();
          }
          bitField0_ = (bitField0_ & ~0x00000004);
          elementEnd_ = false;
          bitField0_ = (bitField0_ & ~0x00000008);
          retainItemCount_ = 0;
          bitField0_ = (bitField0_ & ~0x00000010);
          deleteCharacters_ = "";
          bitField0_ = (bitField0_ & ~0x00000020);
          if (deleteElementStartBuilder_ == null) {
            deleteElementStart_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.getDefaultInstance();
          } else {
            deleteElementStartBuilder_.clear();
          }
          bitField0_ = (bitField0_ & ~0x00000040);
          deleteElementEnd_ = false;
          bitField0_ = (bitField0_ & ~0x00000080);
          if (replaceAttributesBuilder_ == null) {
            replaceAttributes_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.getDefaultInstance();
          } else {
            replaceAttributesBuilder_.clear();
          }
          bitField0_ = (bitField0_ & ~0x00000100);
          if (updateAttributesBuilder_ == null) {
            updateAttributes_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.getDefaultInstance();
          } else {
            updateAttributesBuilder_.clear();
          }
          bitField0_ = (bitField0_ & ~0x00000200);
          return this;
        }

        public Builder clone() {
          return create().mergeFrom(buildPartial());
        }

        public com.google.protobuf.Descriptors.Descriptor
            getDescriptorForType() {
          return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_Component_descriptor;
        }

        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component getDefaultInstanceForType() {
          return org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.getDefaultInstance();
        }

        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component build() {
          org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component result = buildPartial();
          if (!result.isInitialized()) {
            throw newUninitializedMessageException(result);
          }
          return result;
        }

        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component buildPartial() {
          org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component result = new org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component(this);
          int from_bitField0_ = bitField0_;
          int to_bitField0_ = 0;
          if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
            to_bitField0_ |= 0x00000001;
          }
          if (annotationBoundaryBuilder_ == null) {
            result.annotationBoundary_ = annotationBoundary_;
          } else {
            result.annotationBoundary_ = annotationBoundaryBuilder_.build();
          }
          if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
            to_bitField0_ |= 0x00000002;
          }
          result.characters_ = characters_;
          if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
            to_bitField0_ |= 0x00000004;
          }
          if (elementStartBuilder_ == null) {
            result.elementStart_ = elementStart_;
          } else {
            result.elementStart_ = elementStartBuilder_.build();
          }
          if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
            to_bitField0_ |= 0x00000008;
          }
          result.elementEnd_ = elementEnd_;
          if (((from_bitField0_ & 0x00000010) == 0x00000010)) {
            to_bitField0_ |= 0x00000010;
          }
          result.retainItemCount_ = retainItemCount_;
          if (((from_bitField0_ & 0x00000020) == 0x00000020)) {
            to_bitField0_ |= 0x00000020;
          }
          result.deleteCharacters_ = deleteCharacters_;
          if (((from_bitField0_ & 0x00000040) == 0x00000040)) {
            to_bitField0_ |= 0x00000040;
          }
          if (deleteElementStartBuilder_ == null) {
            result.deleteElementStart_ = deleteElementStart_;
          } else {
            result.deleteElementStart_ = deleteElementStartBuilder_.build();
          }
          if (((from_bitField0_ & 0x00000080) == 0x00000080)) {
            to_bitField0_ |= 0x00000080;
          }
          result.deleteElementEnd_ = deleteElementEnd_;
          if (((from_bitField0_ & 0x00000100) == 0x00000100)) {
            to_bitField0_ |= 0x00000100;
          }
          if (replaceAttributesBuilder_ == null) {
            result.replaceAttributes_ = replaceAttributes_;
          } else {
            result.replaceAttributes_ = replaceAttributesBuilder_.build();
          }
          if (((from_bitField0_ & 0x00000200) == 0x00000200)) {
            to_bitField0_ |= 0x00000200;
          }
          if (updateAttributesBuilder_ == null) {
            result.updateAttributes_ = updateAttributes_;
          } else {
            result.updateAttributes_ = updateAttributesBuilder_.build();
          }
          result.bitField0_ = to_bitField0_;
          onBuilt();
          return result;
        }

        public Builder mergeFrom(com.google.protobuf.Message other) {
          if (other instanceof org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component) {
            return mergeFrom((org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component)other);
          } else {
            super.mergeFrom(other);
            return this;
          }
        }

        public Builder mergeFrom(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component other) {
          if (other == org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.getDefaultInstance()) return this;
          if (other.hasAnnotationBoundary()) {
            mergeAnnotationBoundary(other.getAnnotationBoundary());
          }
          if (other.hasCharacters()) {
            bitField0_ |= 0x00000002;
            characters_ = other.characters_;
            onChanged();
          }
          if (other.hasElementStart()) {
            mergeElementStart(other.getElementStart());
          }
          if (other.hasElementEnd()) {
            setElementEnd(other.getElementEnd());
          }
          if (other.hasRetainItemCount()) {
            setRetainItemCount(other.getRetainItemCount());
          }
          if (other.hasDeleteCharacters()) {
            bitField0_ |= 0x00000020;
            deleteCharacters_ = other.deleteCharacters_;
            onChanged();
          }
          if (other.hasDeleteElementStart()) {
            mergeDeleteElementStart(other.getDeleteElementStart());
          }
          if (other.hasDeleteElementEnd()) {
            setDeleteElementEnd(other.getDeleteElementEnd());
          }
          if (other.hasReplaceAttributes()) {
            mergeReplaceAttributes(other.getReplaceAttributes());
          }
          if (other.hasUpdateAttributes()) {
            mergeUpdateAttributes(other.getUpdateAttributes());
          }
          this.mergeUnknownFields(other.getUnknownFields());
          return this;
        }

        public final boolean isInitialized() {
          if (hasAnnotationBoundary()) {
            if (!getAnnotationBoundary().isInitialized()) {
              
              return false;
            }
          }
          if (hasElementStart()) {
            if (!getElementStart().isInitialized()) {
              
              return false;
            }
          }
          if (hasDeleteElementStart()) {
            if (!getDeleteElementStart().isInitialized()) {
              
              return false;
            }
          }
          if (hasReplaceAttributes()) {
            if (!getReplaceAttributes().isInitialized()) {
              
              return false;
            }
          }
          if (hasUpdateAttributes()) {
            if (!getUpdateAttributes().isInitialized()) {
              
              return false;
            }
          }
          return true;
        }

        public Builder mergeFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component parsedMessage = null;
          try {
            parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
          } catch (com.google.protobuf.InvalidProtocolBufferException e) {
            parsedMessage = (org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component) e.getUnfinishedMessage();
            throw e;
          } finally {
            if (parsedMessage != null) {
              mergeFrom(parsedMessage);
            }
          }
          return this;
        }
        private int bitField0_;

        // optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;
        private org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary annotationBoundary_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.getDefaultInstance();
        private com.google.protobuf.SingleFieldBuilder<
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundaryOrBuilder> annotationBoundaryBuilder_;
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;</code>
         */
        public boolean hasAnnotationBoundary() {
          return ((bitField0_ & 0x00000001) == 0x00000001);
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary getAnnotationBoundary() {
          if (annotationBoundaryBuilder_ == null) {
            return annotationBoundary_;
          } else {
            return annotationBoundaryBuilder_.getMessage();
          }
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;</code>
         */
        public Builder setAnnotationBoundary(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary value) {
          if (annotationBoundaryBuilder_ == null) {
            if (value == null) {
              throw new NullPointerException();
            }
            annotationBoundary_ = value;
            onChanged();
          } else {
            annotationBoundaryBuilder_.setMessage(value);
          }
          bitField0_ |= 0x00000001;
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;</code>
         */
        public Builder setAnnotationBoundary(
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.Builder builderForValue) {
          if (annotationBoundaryBuilder_ == null) {
            annotationBoundary_ = builderForValue.build();
            onChanged();
          } else {
            annotationBoundaryBuilder_.setMessage(builderForValue.build());
          }
          bitField0_ |= 0x00000001;
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;</code>
         */
        public Builder mergeAnnotationBoundary(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary value) {
          if (annotationBoundaryBuilder_ == null) {
            if (((bitField0_ & 0x00000001) == 0x00000001) &&
                annotationBoundary_ != org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.getDefaultInstance()) {
              annotationBoundary_ =
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.newBuilder(annotationBoundary_).mergeFrom(value).buildPartial();
            } else {
              annotationBoundary_ = value;
            }
            onChanged();
          } else {
            annotationBoundaryBuilder_.mergeFrom(value);
          }
          bitField0_ |= 0x00000001;
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;</code>
         */
        public Builder clearAnnotationBoundary() {
          if (annotationBoundaryBuilder_ == null) {
            annotationBoundary_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.getDefaultInstance();
            onChanged();
          } else {
            annotationBoundaryBuilder_.clear();
          }
          bitField0_ = (bitField0_ & ~0x00000001);
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.Builder getAnnotationBoundaryBuilder() {
          bitField0_ |= 0x00000001;
          onChanged();
          return getAnnotationBoundaryFieldBuilder().getBuilder();
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundaryOrBuilder getAnnotationBoundaryOrBuilder() {
          if (annotationBoundaryBuilder_ != null) {
            return annotationBoundaryBuilder_.getMessageOrBuilder();
          } else {
            return annotationBoundary_;
          }
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.AnnotationBoundary annotation_boundary = 1;</code>
         */
        private com.google.protobuf.SingleFieldBuilder<
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundaryOrBuilder> 
            getAnnotationBoundaryFieldBuilder() {
          if (annotationBoundaryBuilder_ == null) {
            annotationBoundaryBuilder_ = new com.google.protobuf.SingleFieldBuilder<
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundary.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.AnnotationBoundaryOrBuilder>(
                    annotationBoundary_,
                    getParentForChildren(),
                    isClean());
            annotationBoundary_ = null;
          }
          return annotationBoundaryBuilder_;
        }

        // optional string characters = 2;
        private java.lang.Object characters_ = "";
        /**
         * <code>optional string characters = 2;</code>
         */
        public boolean hasCharacters() {
          return ((bitField0_ & 0x00000002) == 0x00000002);
        }
        /**
         * <code>optional string characters = 2;</code>
         */
        public java.lang.String getCharacters() {
          java.lang.Object ref = characters_;
          if (!(ref instanceof java.lang.String)) {
            java.lang.String s = ((com.google.protobuf.ByteString) ref)
                .toStringUtf8();
            characters_ = s;
            return s;
          } else {
            return (java.lang.String) ref;
          }
        }
        /**
         * <code>optional string characters = 2;</code>
         */
        public com.google.protobuf.ByteString
            getCharactersBytes() {
          java.lang.Object ref = characters_;
          if (ref instanceof String) {
            com.google.protobuf.ByteString b = 
                com.google.protobuf.ByteString.copyFromUtf8(
                    (java.lang.String) ref);
            characters_ = b;
            return b;
          } else {
            return (com.google.protobuf.ByteString) ref;
          }
        }
        /**
         * <code>optional string characters = 2;</code>
         */
        public Builder setCharacters(
            java.lang.String value) {
          if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
          characters_ = value;
          onChanged();
          return this;
        }
        /**
         * <code>optional string characters = 2;</code>
         */
        public Builder clearCharacters() {
          bitField0_ = (bitField0_ & ~0x00000002);
          characters_ = getDefaultInstance().getCharacters();
          onChanged();
          return this;
        }
        /**
         * <code>optional string characters = 2;</code>
         */
        public Builder setCharactersBytes(
            com.google.protobuf.ByteString value) {
          if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
          characters_ = value;
          onChanged();
          return this;
        }

        // optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;
        private org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart elementStart_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.getDefaultInstance();
        private com.google.protobuf.SingleFieldBuilder<
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStartOrBuilder> elementStartBuilder_;
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;</code>
         */
        public boolean hasElementStart() {
          return ((bitField0_ & 0x00000004) == 0x00000004);
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart getElementStart() {
          if (elementStartBuilder_ == null) {
            return elementStart_;
          } else {
            return elementStartBuilder_.getMessage();
          }
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;</code>
         */
        public Builder setElementStart(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart value) {
          if (elementStartBuilder_ == null) {
            if (value == null) {
              throw new NullPointerException();
            }
            elementStart_ = value;
            onChanged();
          } else {
            elementStartBuilder_.setMessage(value);
          }
          bitField0_ |= 0x00000004;
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;</code>
         */
        public Builder setElementStart(
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.Builder builderForValue) {
          if (elementStartBuilder_ == null) {
            elementStart_ = builderForValue.build();
            onChanged();
          } else {
            elementStartBuilder_.setMessage(builderForValue.build());
          }
          bitField0_ |= 0x00000004;
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;</code>
         */
        public Builder mergeElementStart(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart value) {
          if (elementStartBuilder_ == null) {
            if (((bitField0_ & 0x00000004) == 0x00000004) &&
                elementStart_ != org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.getDefaultInstance()) {
              elementStart_ =
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.newBuilder(elementStart_).mergeFrom(value).buildPartial();
            } else {
              elementStart_ = value;
            }
            onChanged();
          } else {
            elementStartBuilder_.mergeFrom(value);
          }
          bitField0_ |= 0x00000004;
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;</code>
         */
        public Builder clearElementStart() {
          if (elementStartBuilder_ == null) {
            elementStart_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.getDefaultInstance();
            onChanged();
          } else {
            elementStartBuilder_.clear();
          }
          bitField0_ = (bitField0_ & ~0x00000004);
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.Builder getElementStartBuilder() {
          bitField0_ |= 0x00000004;
          onChanged();
          return getElementStartFieldBuilder().getBuilder();
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStartOrBuilder getElementStartOrBuilder() {
          if (elementStartBuilder_ != null) {
            return elementStartBuilder_.getMessageOrBuilder();
          } else {
            return elementStart_;
          }
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart element_start = 3;</code>
         */
        private com.google.protobuf.SingleFieldBuilder<
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStartOrBuilder> 
            getElementStartFieldBuilder() {
          if (elementStartBuilder_ == null) {
            elementStartBuilder_ = new com.google.protobuf.SingleFieldBuilder<
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStartOrBuilder>(
                    elementStart_,
                    getParentForChildren(),
                    isClean());
            elementStart_ = null;
          }
          return elementStartBuilder_;
        }

        // optional bool element_end = 4;
        private boolean elementEnd_ ;
        /**
         * <code>optional bool element_end = 4;</code>
         */
        public boolean hasElementEnd() {
          return ((bitField0_ & 0x00000008) == 0x00000008);
        }
        /**
         * <code>optional bool element_end = 4;</code>
         */
        public boolean getElementEnd() {
          return elementEnd_;
        }
        /**
         * <code>optional bool element_end = 4;</code>
         */
        public Builder setElementEnd(boolean value) {
          bitField0_ |= 0x00000008;
          elementEnd_ = value;
          onChanged();
          return this;
        }
        /**
         * <code>optional bool element_end = 4;</code>
         */
        public Builder clearElementEnd() {
          bitField0_ = (bitField0_ & ~0x00000008);
          elementEnd_ = false;
          onChanged();
          return this;
        }

        // optional int32 retain_item_count = 5;
        private int retainItemCount_ ;
        /**
         * <code>optional int32 retain_item_count = 5;</code>
         */
        public boolean hasRetainItemCount() {
          return ((bitField0_ & 0x00000010) == 0x00000010);
        }
        /**
         * <code>optional int32 retain_item_count = 5;</code>
         */
        public int getRetainItemCount() {
          return retainItemCount_;
        }
        /**
         * <code>optional int32 retain_item_count = 5;</code>
         */
        public Builder setRetainItemCount(int value) {
          bitField0_ |= 0x00000010;
          retainItemCount_ = value;
          onChanged();
          return this;
        }
        /**
         * <code>optional int32 retain_item_count = 5;</code>
         */
        public Builder clearRetainItemCount() {
          bitField0_ = (bitField0_ & ~0x00000010);
          retainItemCount_ = 0;
          onChanged();
          return this;
        }

        // optional string delete_characters = 6;
        private java.lang.Object deleteCharacters_ = "";
        /**
         * <code>optional string delete_characters = 6;</code>
         */
        public boolean hasDeleteCharacters() {
          return ((bitField0_ & 0x00000020) == 0x00000020);
        }
        /**
         * <code>optional string delete_characters = 6;</code>
         */
        public java.lang.String getDeleteCharacters() {
          java.lang.Object ref = deleteCharacters_;
          if (!(ref instanceof java.lang.String)) {
            java.lang.String s = ((com.google.protobuf.ByteString) ref)
                .toStringUtf8();
            deleteCharacters_ = s;
            return s;
          } else {
            return (java.lang.String) ref;
          }
        }
        /**
         * <code>optional string delete_characters = 6;</code>
         */
        public com.google.protobuf.ByteString
            getDeleteCharactersBytes() {
          java.lang.Object ref = deleteCharacters_;
          if (ref instanceof String) {
            com.google.protobuf.ByteString b = 
                com.google.protobuf.ByteString.copyFromUtf8(
                    (java.lang.String) ref);
            deleteCharacters_ = b;
            return b;
          } else {
            return (com.google.protobuf.ByteString) ref;
          }
        }
        /**
         * <code>optional string delete_characters = 6;</code>
         */
        public Builder setDeleteCharacters(
            java.lang.String value) {
          if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000020;
          deleteCharacters_ = value;
          onChanged();
          return this;
        }
        /**
         * <code>optional string delete_characters = 6;</code>
         */
        public Builder clearDeleteCharacters() {
          bitField0_ = (bitField0_ & ~0x00000020);
          deleteCharacters_ = getDefaultInstance().getDeleteCharacters();
          onChanged();
          return this;
        }
        /**
         * <code>optional string delete_characters = 6;</code>
         */
        public Builder setDeleteCharactersBytes(
            com.google.protobuf.ByteString value) {
          if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000020;
          deleteCharacters_ = value;
          onChanged();
          return this;
        }

        // optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;
        private org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart deleteElementStart_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.getDefaultInstance();
        private com.google.protobuf.SingleFieldBuilder<
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStartOrBuilder> deleteElementStartBuilder_;
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;</code>
         */
        public boolean hasDeleteElementStart() {
          return ((bitField0_ & 0x00000040) == 0x00000040);
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart getDeleteElementStart() {
          if (deleteElementStartBuilder_ == null) {
            return deleteElementStart_;
          } else {
            return deleteElementStartBuilder_.getMessage();
          }
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;</code>
         */
        public Builder setDeleteElementStart(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart value) {
          if (deleteElementStartBuilder_ == null) {
            if (value == null) {
              throw new NullPointerException();
            }
            deleteElementStart_ = value;
            onChanged();
          } else {
            deleteElementStartBuilder_.setMessage(value);
          }
          bitField0_ |= 0x00000040;
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;</code>
         */
        public Builder setDeleteElementStart(
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.Builder builderForValue) {
          if (deleteElementStartBuilder_ == null) {
            deleteElementStart_ = builderForValue.build();
            onChanged();
          } else {
            deleteElementStartBuilder_.setMessage(builderForValue.build());
          }
          bitField0_ |= 0x00000040;
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;</code>
         */
        public Builder mergeDeleteElementStart(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart value) {
          if (deleteElementStartBuilder_ == null) {
            if (((bitField0_ & 0x00000040) == 0x00000040) &&
                deleteElementStart_ != org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.getDefaultInstance()) {
              deleteElementStart_ =
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.newBuilder(deleteElementStart_).mergeFrom(value).buildPartial();
            } else {
              deleteElementStart_ = value;
            }
            onChanged();
          } else {
            deleteElementStartBuilder_.mergeFrom(value);
          }
          bitField0_ |= 0x00000040;
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;</code>
         */
        public Builder clearDeleteElementStart() {
          if (deleteElementStartBuilder_ == null) {
            deleteElementStart_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.getDefaultInstance();
            onChanged();
          } else {
            deleteElementStartBuilder_.clear();
          }
          bitField0_ = (bitField0_ & ~0x00000040);
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.Builder getDeleteElementStartBuilder() {
          bitField0_ |= 0x00000040;
          onChanged();
          return getDeleteElementStartFieldBuilder().getBuilder();
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStartOrBuilder getDeleteElementStartOrBuilder() {
          if (deleteElementStartBuilder_ != null) {
            return deleteElementStartBuilder_.getMessageOrBuilder();
          } else {
            return deleteElementStart_;
          }
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ElementStart delete_element_start = 7;</code>
         */
        private com.google.protobuf.SingleFieldBuilder<
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStartOrBuilder> 
            getDeleteElementStartFieldBuilder() {
          if (deleteElementStartBuilder_ == null) {
            deleteElementStartBuilder_ = new com.google.protobuf.SingleFieldBuilder<
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStart.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ElementStartOrBuilder>(
                    deleteElementStart_,
                    getParentForChildren(),
                    isClean());
            deleteElementStart_ = null;
          }
          return deleteElementStartBuilder_;
        }

        // optional bool delete_element_end = 8;
        private boolean deleteElementEnd_ ;
        /**
         * <code>optional bool delete_element_end = 8;</code>
         */
        public boolean hasDeleteElementEnd() {
          return ((bitField0_ & 0x00000080) == 0x00000080);
        }
        /**
         * <code>optional bool delete_element_end = 8;</code>
         */
        public boolean getDeleteElementEnd() {
          return deleteElementEnd_;
        }
        /**
         * <code>optional bool delete_element_end = 8;</code>
         */
        public Builder setDeleteElementEnd(boolean value) {
          bitField0_ |= 0x00000080;
          deleteElementEnd_ = value;
          onChanged();
          return this;
        }
        /**
         * <code>optional bool delete_element_end = 8;</code>
         */
        public Builder clearDeleteElementEnd() {
          bitField0_ = (bitField0_ & ~0x00000080);
          deleteElementEnd_ = false;
          onChanged();
          return this;
        }

        // optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;
        private org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes replaceAttributes_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.getDefaultInstance();
        private com.google.protobuf.SingleFieldBuilder<
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributesOrBuilder> replaceAttributesBuilder_;
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;</code>
         */
        public boolean hasReplaceAttributes() {
          return ((bitField0_ & 0x00000100) == 0x00000100);
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes getReplaceAttributes() {
          if (replaceAttributesBuilder_ == null) {
            return replaceAttributes_;
          } else {
            return replaceAttributesBuilder_.getMessage();
          }
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;</code>
         */
        public Builder setReplaceAttributes(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes value) {
          if (replaceAttributesBuilder_ == null) {
            if (value == null) {
              throw new NullPointerException();
            }
            replaceAttributes_ = value;
            onChanged();
          } else {
            replaceAttributesBuilder_.setMessage(value);
          }
          bitField0_ |= 0x00000100;
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;</code>
         */
        public Builder setReplaceAttributes(
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.Builder builderForValue) {
          if (replaceAttributesBuilder_ == null) {
            replaceAttributes_ = builderForValue.build();
            onChanged();
          } else {
            replaceAttributesBuilder_.setMessage(builderForValue.build());
          }
          bitField0_ |= 0x00000100;
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;</code>
         */
        public Builder mergeReplaceAttributes(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes value) {
          if (replaceAttributesBuilder_ == null) {
            if (((bitField0_ & 0x00000100) == 0x00000100) &&
                replaceAttributes_ != org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.getDefaultInstance()) {
              replaceAttributes_ =
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.newBuilder(replaceAttributes_).mergeFrom(value).buildPartial();
            } else {
              replaceAttributes_ = value;
            }
            onChanged();
          } else {
            replaceAttributesBuilder_.mergeFrom(value);
          }
          bitField0_ |= 0x00000100;
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;</code>
         */
        public Builder clearReplaceAttributes() {
          if (replaceAttributesBuilder_ == null) {
            replaceAttributes_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.getDefaultInstance();
            onChanged();
          } else {
            replaceAttributesBuilder_.clear();
          }
          bitField0_ = (bitField0_ & ~0x00000100);
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.Builder getReplaceAttributesBuilder() {
          bitField0_ |= 0x00000100;
          onChanged();
          return getReplaceAttributesFieldBuilder().getBuilder();
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributesOrBuilder getReplaceAttributesOrBuilder() {
          if (replaceAttributesBuilder_ != null) {
            return replaceAttributesBuilder_.getMessageOrBuilder();
          } else {
            return replaceAttributes_;
          }
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.ReplaceAttributes replace_attributes = 9;</code>
         */
        private com.google.protobuf.SingleFieldBuilder<
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributesOrBuilder> 
            getReplaceAttributesFieldBuilder() {
          if (replaceAttributesBuilder_ == null) {
            replaceAttributesBuilder_ = new com.google.protobuf.SingleFieldBuilder<
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributes.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.ReplaceAttributesOrBuilder>(
                    replaceAttributes_,
                    getParentForChildren(),
                    isClean());
            replaceAttributes_ = null;
          }
          return replaceAttributesBuilder_;
        }

        // optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;
        private org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes updateAttributes_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.getDefaultInstance();
        private com.google.protobuf.SingleFieldBuilder<
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributesOrBuilder> updateAttributesBuilder_;
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;</code>
         */
        public boolean hasUpdateAttributes() {
          return ((bitField0_ & 0x00000200) == 0x00000200);
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes getUpdateAttributes() {
          if (updateAttributesBuilder_ == null) {
            return updateAttributes_;
          } else {
            return updateAttributesBuilder_.getMessage();
          }
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;</code>
         */
        public Builder setUpdateAttributes(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes value) {
          if (updateAttributesBuilder_ == null) {
            if (value == null) {
              throw new NullPointerException();
            }
            updateAttributes_ = value;
            onChanged();
          } else {
            updateAttributesBuilder_.setMessage(value);
          }
          bitField0_ |= 0x00000200;
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;</code>
         */
        public Builder setUpdateAttributes(
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.Builder builderForValue) {
          if (updateAttributesBuilder_ == null) {
            updateAttributes_ = builderForValue.build();
            onChanged();
          } else {
            updateAttributesBuilder_.setMessage(builderForValue.build());
          }
          bitField0_ |= 0x00000200;
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;</code>
         */
        public Builder mergeUpdateAttributes(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes value) {
          if (updateAttributesBuilder_ == null) {
            if (((bitField0_ & 0x00000200) == 0x00000200) &&
                updateAttributes_ != org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.getDefaultInstance()) {
              updateAttributes_ =
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.newBuilder(updateAttributes_).mergeFrom(value).buildPartial();
            } else {
              updateAttributes_ = value;
            }
            onChanged();
          } else {
            updateAttributesBuilder_.mergeFrom(value);
          }
          bitField0_ |= 0x00000200;
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;</code>
         */
        public Builder clearUpdateAttributes() {
          if (updateAttributesBuilder_ == null) {
            updateAttributes_ = org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.getDefaultInstance();
            onChanged();
          } else {
            updateAttributesBuilder_.clear();
          }
          bitField0_ = (bitField0_ & ~0x00000200);
          return this;
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.Builder getUpdateAttributesBuilder() {
          bitField0_ |= 0x00000200;
          onChanged();
          return getUpdateAttributesFieldBuilder().getBuilder();
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;</code>
         */
        public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributesOrBuilder getUpdateAttributesOrBuilder() {
          if (updateAttributesBuilder_ != null) {
            return updateAttributesBuilder_.getMessageOrBuilder();
          } else {
            return updateAttributes_;
          }
        }
        /**
         * <code>optional .federation.ProtocolDocumentOperation.Component.UpdateAttributes update_attributes = 10;</code>
         */
        private com.google.protobuf.SingleFieldBuilder<
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributesOrBuilder> 
            getUpdateAttributesFieldBuilder() {
          if (updateAttributesBuilder_ == null) {
            updateAttributesBuilder_ = new com.google.protobuf.SingleFieldBuilder<
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributes.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.UpdateAttributesOrBuilder>(
                    updateAttributes_,
                    getParentForChildren(),
                    isClean());
            updateAttributes_ = null;
          }
          return updateAttributesBuilder_;
        }

        // @@protoc_insertion_point(builder_scope:federation.ProtocolDocumentOperation.Component)
      }

      static {
        defaultInstance = new Component(true);
        defaultInstance.initFields();
      }

      // @@protoc_insertion_point(class_scope:federation.ProtocolDocumentOperation.Component)
    }

    // repeated .federation.ProtocolDocumentOperation.Component component = 1;
    public static final int COMPONENT_FIELD_NUMBER = 1;
    private java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component> component_;
    /**
     * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
     */
    public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component> getComponentList() {
      return component_;
    }
    /**
     * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
     */
    public java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.ComponentOrBuilder> 
        getComponentOrBuilderList() {
      return component_;
    }
    /**
     * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
     */
    public int getComponentCount() {
      return component_.size();
    }
    /**
     * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
     */
    public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component getComponent(int index) {
      return component_.get(index);
    }
    /**
     * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
     */
    public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.ComponentOrBuilder getComponentOrBuilder(
        int index) {
      return component_.get(index);
    }

    private void initFields() {
      component_ = java.util.Collections.emptyList();
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      for (int i = 0; i < getComponentCount(); i++) {
        if (!getComponent(i).isInitialized()) {
          memoizedIsInitialized = 0;
          return false;
        }
      }
      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      for (int i = 0; i < component_.size(); i++) {
        output.writeMessage(1, component_.get(i));
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      for (int i = 0; i < component_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(1, component_.get(i));
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code federation.ProtocolDocumentOperation}
     *
     * <pre>
     **
     * A list of mutation components.
     * </pre>
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperationOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.class, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Builder.class);
      }

      // Construct using org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
          getComponentFieldBuilder();
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        if (componentBuilder_ == null) {
          component_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000001);
        } else {
          componentBuilder_.clear();
        }
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolDocumentOperation_descriptor;
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation getDefaultInstanceForType() {
        return org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.getDefaultInstance();
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation build() {
        org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation buildPartial() {
        org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation result = new org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation(this);
        int from_bitField0_ = bitField0_;
        if (componentBuilder_ == null) {
          if (((bitField0_ & 0x00000001) == 0x00000001)) {
            component_ = java.util.Collections.unmodifiableList(component_);
            bitField0_ = (bitField0_ & ~0x00000001);
          }
          result.component_ = component_;
        } else {
          result.component_ = componentBuilder_.build();
        }
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation) {
          return mergeFrom((org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation other) {
        if (other == org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.getDefaultInstance()) return this;
        if (componentBuilder_ == null) {
          if (!other.component_.isEmpty()) {
            if (component_.isEmpty()) {
              component_ = other.component_;
              bitField0_ = (bitField0_ & ~0x00000001);
            } else {
              ensureComponentIsMutable();
              component_.addAll(other.component_);
            }
            onChanged();
          }
        } else {
          if (!other.component_.isEmpty()) {
            if (componentBuilder_.isEmpty()) {
              componentBuilder_.dispose();
              componentBuilder_ = null;
              component_ = other.component_;
              bitField0_ = (bitField0_ & ~0x00000001);
              componentBuilder_ = 
                com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                   getComponentFieldBuilder() : null;
            } else {
              componentBuilder_.addAllMessages(other.component_);
            }
          }
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        for (int i = 0; i < getComponentCount(); i++) {
          if (!getComponent(i).isInitialized()) {
            
            return false;
          }
        }
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // repeated .federation.ProtocolDocumentOperation.Component component = 1;
      private java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component> component_ =
        java.util.Collections.emptyList();
      private void ensureComponentIsMutable() {
        if (!((bitField0_ & 0x00000001) == 0x00000001)) {
          component_ = new java.util.ArrayList<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component>(component_);
          bitField0_ |= 0x00000001;
         }
      }

      private com.google.protobuf.RepeatedFieldBuilder<
          org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.ComponentOrBuilder> componentBuilder_;

      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component> getComponentList() {
        if (componentBuilder_ == null) {
          return java.util.Collections.unmodifiableList(component_);
        } else {
          return componentBuilder_.getMessageList();
        }
      }
      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public int getComponentCount() {
        if (componentBuilder_ == null) {
          return component_.size();
        } else {
          return componentBuilder_.getCount();
        }
      }
      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component getComponent(int index) {
        if (componentBuilder_ == null) {
          return component_.get(index);
        } else {
          return componentBuilder_.getMessage(index);
        }
      }
      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public Builder setComponent(
          int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component value) {
        if (componentBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureComponentIsMutable();
          component_.set(index, value);
          onChanged();
        } else {
          componentBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public Builder setComponent(
          int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.Builder builderForValue) {
        if (componentBuilder_ == null) {
          ensureComponentIsMutable();
          component_.set(index, builderForValue.build());
          onChanged();
        } else {
          componentBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public Builder addComponent(org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component value) {
        if (componentBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureComponentIsMutable();
          component_.add(value);
          onChanged();
        } else {
          componentBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public Builder addComponent(
          int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component value) {
        if (componentBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureComponentIsMutable();
          component_.add(index, value);
          onChanged();
        } else {
          componentBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public Builder addComponent(
          org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.Builder builderForValue) {
        if (componentBuilder_ == null) {
          ensureComponentIsMutable();
          component_.add(builderForValue.build());
          onChanged();
        } else {
          componentBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public Builder addComponent(
          int index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.Builder builderForValue) {
        if (componentBuilder_ == null) {
          ensureComponentIsMutable();
          component_.add(index, builderForValue.build());
          onChanged();
        } else {
          componentBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public Builder addAllComponent(
          java.lang.Iterable<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component> values) {
        if (componentBuilder_ == null) {
          ensureComponentIsMutable();
          super.addAll(values, component_);
          onChanged();
        } else {
          componentBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public Builder clearComponent() {
        if (componentBuilder_ == null) {
          component_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000001);
          onChanged();
        } else {
          componentBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public Builder removeComponent(int index) {
        if (componentBuilder_ == null) {
          ensureComponentIsMutable();
          component_.remove(index);
          onChanged();
        } else {
          componentBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.Builder getComponentBuilder(
          int index) {
        return getComponentFieldBuilder().getBuilder(index);
      }
      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.ComponentOrBuilder getComponentOrBuilder(
          int index) {
        if (componentBuilder_ == null) {
          return component_.get(index);  } else {
          return componentBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.ComponentOrBuilder> 
           getComponentOrBuilderList() {
        if (componentBuilder_ != null) {
          return componentBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(component_);
        }
      }
      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.Builder addComponentBuilder() {
        return getComponentFieldBuilder().addBuilder(
            org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.getDefaultInstance());
      }
      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.Builder addComponentBuilder(
          int index) {
        return getComponentFieldBuilder().addBuilder(
            index, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.getDefaultInstance());
      }
      /**
       * <code>repeated .federation.ProtocolDocumentOperation.Component component = 1;</code>
       */
      public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.Builder> 
           getComponentBuilderList() {
        return getComponentFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilder<
          org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.ComponentOrBuilder> 
          getComponentFieldBuilder() {
        if (componentBuilder_ == null) {
          componentBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
              org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.Component.Builder, org.waveprotocol.wave.federation.Proto.ProtocolDocumentOperation.ComponentOrBuilder>(
                  component_,
                  ((bitField0_ & 0x00000001) == 0x00000001),
                  getParentForChildren(),
                  isClean());
          component_ = null;
        }
        return componentBuilder_;
      }

      // @@protoc_insertion_point(builder_scope:federation.ProtocolDocumentOperation)
    }

    static {
      defaultInstance = new ProtocolDocumentOperation(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:federation.ProtocolDocumentOperation)
  }

  public interface ProtocolAppliedWaveletDeltaOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // required .federation.ProtocolSignedDelta signed_original_delta = 1;
    /**
     * <code>required .federation.ProtocolSignedDelta signed_original_delta = 1;</code>
     */
    boolean hasSignedOriginalDelta();
    /**
     * <code>required .federation.ProtocolSignedDelta signed_original_delta = 1;</code>
     */
    org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta getSignedOriginalDelta();
    /**
     * <code>required .federation.ProtocolSignedDelta signed_original_delta = 1;</code>
     */
    org.waveprotocol.wave.federation.Proto.ProtocolSignedDeltaOrBuilder getSignedOriginalDeltaOrBuilder();

    // optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;
    /**
     * <code>optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;</code>
     */
    boolean hasHashedVersionAppliedAt();
    /**
     * <code>optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;</code>
     */
    org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion getHashedVersionAppliedAt();
    /**
     * <code>optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;</code>
     */
    org.waveprotocol.wave.federation.Proto.ProtocolHashedVersionOrBuilder getHashedVersionAppliedAtOrBuilder();

    // required int32 operations_applied = 3;
    /**
     * <code>required int32 operations_applied = 3;</code>
     */
    boolean hasOperationsApplied();
    /**
     * <code>required int32 operations_applied = 3;</code>
     */
    int getOperationsApplied();

    // required int64 application_timestamp = 4;
    /**
     * <code>required int64 application_timestamp = 4;</code>
     */
    boolean hasApplicationTimestamp();
    /**
     * <code>required int64 application_timestamp = 4;</code>
     */
    long getApplicationTimestamp();
  }
  /**
   * Protobuf type {@code federation.ProtocolAppliedWaveletDelta}
   *
   * <pre>
   **
   * Information generated about this delta post-applicaton. Used in
   * ProtocolUpdate and ProtocolHistoryResponse.
   * </pre>
   */
  public static final class ProtocolAppliedWaveletDelta extends
      com.google.protobuf.GeneratedMessage
      implements ProtocolAppliedWaveletDeltaOrBuilder {
    // Use ProtocolAppliedWaveletDelta.newBuilder() to construct.
    private ProtocolAppliedWaveletDelta(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private ProtocolAppliedWaveletDelta(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final ProtocolAppliedWaveletDelta defaultInstance;
    public static ProtocolAppliedWaveletDelta getDefaultInstance() {
      return defaultInstance;
    }

    public ProtocolAppliedWaveletDelta getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private ProtocolAppliedWaveletDelta(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.Builder subBuilder = null;
              if (((bitField0_ & 0x00000001) == 0x00000001)) {
                subBuilder = signedOriginalDelta_.toBuilder();
              }
              signedOriginalDelta_ = input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(signedOriginalDelta_);
                signedOriginalDelta_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000001;
              break;
            }
            case 18: {
              org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.Builder subBuilder = null;
              if (((bitField0_ & 0x00000002) == 0x00000002)) {
                subBuilder = hashedVersionAppliedAt_.toBuilder();
              }
              hashedVersionAppliedAt_ = input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(hashedVersionAppliedAt_);
                hashedVersionAppliedAt_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000002;
              break;
            }
            case 24: {
              bitField0_ |= 0x00000004;
              operationsApplied_ = input.readInt32();
              break;
            }
            case 32: {
              bitField0_ |= 0x00000008;
              applicationTimestamp_ = input.readInt64();
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolAppliedWaveletDelta_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolAppliedWaveletDelta_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta.class, org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta.Builder.class);
    }

    public static com.google.protobuf.Parser<ProtocolAppliedWaveletDelta> PARSER =
        new com.google.protobuf.AbstractParser<ProtocolAppliedWaveletDelta>() {
      public ProtocolAppliedWaveletDelta parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new ProtocolAppliedWaveletDelta(input, extensionRegistry);
      }
    };

    @java.lang.Override
    public com.google.protobuf.Parser<ProtocolAppliedWaveletDelta> getParserForType() {
      return PARSER;
    }

    private int bitField0_;
    // required .federation.ProtocolSignedDelta signed_original_delta = 1;
    public static final int SIGNED_ORIGINAL_DELTA_FIELD_NUMBER = 1;
    private org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta signedOriginalDelta_;
    /**
     * <code>required .federation.ProtocolSignedDelta signed_original_delta = 1;</code>
     */
    public boolean hasSignedOriginalDelta() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>required .federation.ProtocolSignedDelta signed_original_delta = 1;</code>
     */
    public org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta getSignedOriginalDelta() {
      return signedOriginalDelta_;
    }
    /**
     * <code>required .federation.ProtocolSignedDelta signed_original_delta = 1;</code>
     */
    public org.waveprotocol.wave.federation.Proto.ProtocolSignedDeltaOrBuilder getSignedOriginalDeltaOrBuilder() {
      return signedOriginalDelta_;
    }

    // optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;
    public static final int HASHED_VERSION_APPLIED_AT_FIELD_NUMBER = 2;
    private org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion hashedVersionAppliedAt_;
    /**
     * <code>optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;</code>
     */
    public boolean hasHashedVersionAppliedAt() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    /**
     * <code>optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;</code>
     */
    public org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion getHashedVersionAppliedAt() {
      return hashedVersionAppliedAt_;
    }
    /**
     * <code>optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;</code>
     */
    public org.waveprotocol.wave.federation.Proto.ProtocolHashedVersionOrBuilder getHashedVersionAppliedAtOrBuilder() {
      return hashedVersionAppliedAt_;
    }

    // required int32 operations_applied = 3;
    public static final int OPERATIONS_APPLIED_FIELD_NUMBER = 3;
    private int operationsApplied_;
    /**
     * <code>required int32 operations_applied = 3;</code>
     */
    public boolean hasOperationsApplied() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    /**
     * <code>required int32 operations_applied = 3;</code>
     */
    public int getOperationsApplied() {
      return operationsApplied_;
    }

    // required int64 application_timestamp = 4;
    public static final int APPLICATION_TIMESTAMP_FIELD_NUMBER = 4;
    private long applicationTimestamp_;
    /**
     * <code>required int64 application_timestamp = 4;</code>
     */
    public boolean hasApplicationTimestamp() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    /**
     * <code>required int64 application_timestamp = 4;</code>
     */
    public long getApplicationTimestamp() {
      return applicationTimestamp_;
    }

    private void initFields() {
      signedOriginalDelta_ = org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.getDefaultInstance();
      hashedVersionAppliedAt_ = org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.getDefaultInstance();
      operationsApplied_ = 0;
      applicationTimestamp_ = 0L;
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      if (!hasSignedOriginalDelta()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasOperationsApplied()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasApplicationTimestamp()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!getSignedOriginalDelta().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (hasHashedVersionAppliedAt()) {
        if (!getHashedVersionAppliedAt().isInitialized()) {
          memoizedIsInitialized = 0;
          return false;
        }
      }
      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeMessage(1, signedOriginalDelta_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeMessage(2, hashedVersionAppliedAt_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeInt32(3, operationsApplied_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeInt64(4, applicationTimestamp_);
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(1, signedOriginalDelta_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(2, hashedVersionAppliedAt_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, operationsApplied_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(4, applicationTimestamp_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    public static org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code federation.ProtocolAppliedWaveletDelta}
     *
     * <pre>
     **
     * Information generated about this delta post-applicaton. Used in
     * ProtocolUpdate and ProtocolHistoryResponse.
     * </pre>
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDeltaOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolAppliedWaveletDelta_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolAppliedWaveletDelta_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta.class, org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta.Builder.class);
      }

      // Construct using org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
          getSignedOriginalDeltaFieldBuilder();
          getHashedVersionAppliedAtFieldBuilder();
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        if (signedOriginalDeltaBuilder_ == null) {
          signedOriginalDelta_ = org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.getDefaultInstance();
        } else {
          signedOriginalDeltaBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        if (hashedVersionAppliedAtBuilder_ == null) {
          hashedVersionAppliedAt_ = org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.getDefaultInstance();
        } else {
          hashedVersionAppliedAtBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000002);
        operationsApplied_ = 0;
        bitField0_ = (bitField0_ & ~0x00000004);
        applicationTimestamp_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000008);
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolAppliedWaveletDelta_descriptor;
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta getDefaultInstanceForType() {
        return org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta.getDefaultInstance();
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta build() {
        org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta buildPartial() {
        org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta result = new org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        if (signedOriginalDeltaBuilder_ == null) {
          result.signedOriginalDelta_ = signedOriginalDelta_;
        } else {
          result.signedOriginalDelta_ = signedOriginalDeltaBuilder_.build();
        }
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        if (hashedVersionAppliedAtBuilder_ == null) {
          result.hashedVersionAppliedAt_ = hashedVersionAppliedAt_;
        } else {
          result.hashedVersionAppliedAt_ = hashedVersionAppliedAtBuilder_.build();
        }
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.operationsApplied_ = operationsApplied_;
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.applicationTimestamp_ = applicationTimestamp_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta) {
          return mergeFrom((org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta other) {
        if (other == org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta.getDefaultInstance()) return this;
        if (other.hasSignedOriginalDelta()) {
          mergeSignedOriginalDelta(other.getSignedOriginalDelta());
        }
        if (other.hasHashedVersionAppliedAt()) {
          mergeHashedVersionAppliedAt(other.getHashedVersionAppliedAt());
        }
        if (other.hasOperationsApplied()) {
          setOperationsApplied(other.getOperationsApplied());
        }
        if (other.hasApplicationTimestamp()) {
          setApplicationTimestamp(other.getApplicationTimestamp());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        if (!hasSignedOriginalDelta()) {
          
          return false;
        }
        if (!hasOperationsApplied()) {
          
          return false;
        }
        if (!hasApplicationTimestamp()) {
          
          return false;
        }
        if (!getSignedOriginalDelta().isInitialized()) {
          
          return false;
        }
        if (hasHashedVersionAppliedAt()) {
          if (!getHashedVersionAppliedAt().isInitialized()) {
            
            return false;
          }
        }
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.waveprotocol.wave.federation.Proto.ProtocolAppliedWaveletDelta) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // required .federation.ProtocolSignedDelta signed_original_delta = 1;
      private org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta signedOriginalDelta_ = org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.getDefaultInstance();
      private com.google.protobuf.SingleFieldBuilder<
          org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta, org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.Builder, org.waveprotocol.wave.federation.Proto.ProtocolSignedDeltaOrBuilder> signedOriginalDeltaBuilder_;
      /**
       * <code>required .federation.ProtocolSignedDelta signed_original_delta = 1;</code>
       */
      public boolean hasSignedOriginalDelta() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>required .federation.ProtocolSignedDelta signed_original_delta = 1;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta getSignedOriginalDelta() {
        if (signedOriginalDeltaBuilder_ == null) {
          return signedOriginalDelta_;
        } else {
          return signedOriginalDeltaBuilder_.getMessage();
        }
      }
      /**
       * <code>required .federation.ProtocolSignedDelta signed_original_delta = 1;</code>
       */
      public Builder setSignedOriginalDelta(org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta value) {
        if (signedOriginalDeltaBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          signedOriginalDelta_ = value;
          onChanged();
        } else {
          signedOriginalDeltaBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .federation.ProtocolSignedDelta signed_original_delta = 1;</code>
       */
      public Builder setSignedOriginalDelta(
          org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.Builder builderForValue) {
        if (signedOriginalDeltaBuilder_ == null) {
          signedOriginalDelta_ = builderForValue.build();
          onChanged();
        } else {
          signedOriginalDeltaBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .federation.ProtocolSignedDelta signed_original_delta = 1;</code>
       */
      public Builder mergeSignedOriginalDelta(org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta value) {
        if (signedOriginalDeltaBuilder_ == null) {
          if (((bitField0_ & 0x00000001) == 0x00000001) &&
              signedOriginalDelta_ != org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.getDefaultInstance()) {
            signedOriginalDelta_ =
              org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.newBuilder(signedOriginalDelta_).mergeFrom(value).buildPartial();
          } else {
            signedOriginalDelta_ = value;
          }
          onChanged();
        } else {
          signedOriginalDeltaBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .federation.ProtocolSignedDelta signed_original_delta = 1;</code>
       */
      public Builder clearSignedOriginalDelta() {
        if (signedOriginalDeltaBuilder_ == null) {
          signedOriginalDelta_ = org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.getDefaultInstance();
          onChanged();
        } else {
          signedOriginalDeltaBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        return this;
      }
      /**
       * <code>required .federation.ProtocolSignedDelta signed_original_delta = 1;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.Builder getSignedOriginalDeltaBuilder() {
        bitField0_ |= 0x00000001;
        onChanged();
        return getSignedOriginalDeltaFieldBuilder().getBuilder();
      }
      /**
       * <code>required .federation.ProtocolSignedDelta signed_original_delta = 1;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolSignedDeltaOrBuilder getSignedOriginalDeltaOrBuilder() {
        if (signedOriginalDeltaBuilder_ != null) {
          return signedOriginalDeltaBuilder_.getMessageOrBuilder();
        } else {
          return signedOriginalDelta_;
        }
      }
      /**
       * <code>required .federation.ProtocolSignedDelta signed_original_delta = 1;</code>
       */
      private com.google.protobuf.SingleFieldBuilder<
          org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta, org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.Builder, org.waveprotocol.wave.federation.Proto.ProtocolSignedDeltaOrBuilder> 
          getSignedOriginalDeltaFieldBuilder() {
        if (signedOriginalDeltaBuilder_ == null) {
          signedOriginalDeltaBuilder_ = new com.google.protobuf.SingleFieldBuilder<
              org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta, org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.Builder, org.waveprotocol.wave.federation.Proto.ProtocolSignedDeltaOrBuilder>(
                  signedOriginalDelta_,
                  getParentForChildren(),
                  isClean());
          signedOriginalDelta_ = null;
        }
        return signedOriginalDeltaBuilder_;
      }

      // optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;
      private org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion hashedVersionAppliedAt_ = org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.getDefaultInstance();
      private com.google.protobuf.SingleFieldBuilder<
          org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion, org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.Builder, org.waveprotocol.wave.federation.Proto.ProtocolHashedVersionOrBuilder> hashedVersionAppliedAtBuilder_;
      /**
       * <code>optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;</code>
       */
      public boolean hasHashedVersionAppliedAt() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      /**
       * <code>optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion getHashedVersionAppliedAt() {
        if (hashedVersionAppliedAtBuilder_ == null) {
          return hashedVersionAppliedAt_;
        } else {
          return hashedVersionAppliedAtBuilder_.getMessage();
        }
      }
      /**
       * <code>optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;</code>
       */
      public Builder setHashedVersionAppliedAt(org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion value) {
        if (hashedVersionAppliedAtBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          hashedVersionAppliedAt_ = value;
          onChanged();
        } else {
          hashedVersionAppliedAtBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000002;
        return this;
      }
      /**
       * <code>optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;</code>
       */
      public Builder setHashedVersionAppliedAt(
          org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.Builder builderForValue) {
        if (hashedVersionAppliedAtBuilder_ == null) {
          hashedVersionAppliedAt_ = builderForValue.build();
          onChanged();
        } else {
          hashedVersionAppliedAtBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000002;
        return this;
      }
      /**
       * <code>optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;</code>
       */
      public Builder mergeHashedVersionAppliedAt(org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion value) {
        if (hashedVersionAppliedAtBuilder_ == null) {
          if (((bitField0_ & 0x00000002) == 0x00000002) &&
              hashedVersionAppliedAt_ != org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.getDefaultInstance()) {
            hashedVersionAppliedAt_ =
              org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.newBuilder(hashedVersionAppliedAt_).mergeFrom(value).buildPartial();
          } else {
            hashedVersionAppliedAt_ = value;
          }
          onChanged();
        } else {
          hashedVersionAppliedAtBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000002;
        return this;
      }
      /**
       * <code>optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;</code>
       */
      public Builder clearHashedVersionAppliedAt() {
        if (hashedVersionAppliedAtBuilder_ == null) {
          hashedVersionAppliedAt_ = org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.getDefaultInstance();
          onChanged();
        } else {
          hashedVersionAppliedAtBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000002);
        return this;
      }
      /**
       * <code>optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.Builder getHashedVersionAppliedAtBuilder() {
        bitField0_ |= 0x00000002;
        onChanged();
        return getHashedVersionAppliedAtFieldBuilder().getBuilder();
      }
      /**
       * <code>optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolHashedVersionOrBuilder getHashedVersionAppliedAtOrBuilder() {
        if (hashedVersionAppliedAtBuilder_ != null) {
          return hashedVersionAppliedAtBuilder_.getMessageOrBuilder();
        } else {
          return hashedVersionAppliedAt_;
        }
      }
      /**
       * <code>optional .federation.ProtocolHashedVersion hashed_version_applied_at = 2;</code>
       */
      private com.google.protobuf.SingleFieldBuilder<
          org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion, org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.Builder, org.waveprotocol.wave.federation.Proto.ProtocolHashedVersionOrBuilder> 
          getHashedVersionAppliedAtFieldBuilder() {
        if (hashedVersionAppliedAtBuilder_ == null) {
          hashedVersionAppliedAtBuilder_ = new com.google.protobuf.SingleFieldBuilder<
              org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion, org.waveprotocol.wave.federation.Proto.ProtocolHashedVersion.Builder, org.waveprotocol.wave.federation.Proto.ProtocolHashedVersionOrBuilder>(
                  hashedVersionAppliedAt_,
                  getParentForChildren(),
                  isClean());
          hashedVersionAppliedAt_ = null;
        }
        return hashedVersionAppliedAtBuilder_;
      }

      // required int32 operations_applied = 3;
      private int operationsApplied_ ;
      /**
       * <code>required int32 operations_applied = 3;</code>
       */
      public boolean hasOperationsApplied() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      /**
       * <code>required int32 operations_applied = 3;</code>
       */
      public int getOperationsApplied() {
        return operationsApplied_;
      }
      /**
       * <code>required int32 operations_applied = 3;</code>
       */
      public Builder setOperationsApplied(int value) {
        bitField0_ |= 0x00000004;
        operationsApplied_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required int32 operations_applied = 3;</code>
       */
      public Builder clearOperationsApplied() {
        bitField0_ = (bitField0_ & ~0x00000004);
        operationsApplied_ = 0;
        onChanged();
        return this;
      }

      // required int64 application_timestamp = 4;
      private long applicationTimestamp_ ;
      /**
       * <code>required int64 application_timestamp = 4;</code>
       */
      public boolean hasApplicationTimestamp() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      /**
       * <code>required int64 application_timestamp = 4;</code>
       */
      public long getApplicationTimestamp() {
        return applicationTimestamp_;
      }
      /**
       * <code>required int64 application_timestamp = 4;</code>
       */
      public Builder setApplicationTimestamp(long value) {
        bitField0_ |= 0x00000008;
        applicationTimestamp_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required int64 application_timestamp = 4;</code>
       */
      public Builder clearApplicationTimestamp() {
        bitField0_ = (bitField0_ & ~0x00000008);
        applicationTimestamp_ = 0L;
        onChanged();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:federation.ProtocolAppliedWaveletDelta)
    }

    static {
      defaultInstance = new ProtocolAppliedWaveletDelta(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:federation.ProtocolAppliedWaveletDelta)
  }

  public interface ProtocolSignedDeltaOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // required bytes delta = 1;
    /**
     * <code>required bytes delta = 1;</code>
     */
    boolean hasDelta();
    /**
     * <code>required bytes delta = 1;</code>
     */
    com.google.protobuf.ByteString getDelta();

    // repeated .federation.ProtocolSignature signature = 2;
    /**
     * <code>repeated .federation.ProtocolSignature signature = 2;</code>
     */
    java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolSignature> 
        getSignatureList();
    /**
     * <code>repeated .federation.ProtocolSignature signature = 2;</code>
     */
    org.waveprotocol.wave.federation.Proto.ProtocolSignature getSignature(int index);
    /**
     * <code>repeated .federation.ProtocolSignature signature = 2;</code>
     */
    int getSignatureCount();
    /**
     * <code>repeated .federation.ProtocolSignature signature = 2;</code>
     */
    java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolSignatureOrBuilder> 
        getSignatureOrBuilderList();
    /**
     * <code>repeated .federation.ProtocolSignature signature = 2;</code>
     */
    org.waveprotocol.wave.federation.Proto.ProtocolSignatureOrBuilder getSignatureOrBuilder(
        int index);
  }
  /**
   * Protobuf type {@code federation.ProtocolSignedDelta}
   *
   * <pre>
   **
   * A canonicalised delta signed with a number of domain signatures.
   * </pre>
   */
  public static final class ProtocolSignedDelta extends
      com.google.protobuf.GeneratedMessage
      implements ProtocolSignedDeltaOrBuilder {
    // Use ProtocolSignedDelta.newBuilder() to construct.
    private ProtocolSignedDelta(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private ProtocolSignedDelta(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final ProtocolSignedDelta defaultInstance;
    public static ProtocolSignedDelta getDefaultInstance() {
      return defaultInstance;
    }

    public ProtocolSignedDelta getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private ProtocolSignedDelta(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              bitField0_ |= 0x00000001;
              delta_ = input.readBytes();
              break;
            }
            case 18: {
              if (!((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
                signature_ = new java.util.ArrayList<org.waveprotocol.wave.federation.Proto.ProtocolSignature>();
                mutable_bitField0_ |= 0x00000002;
              }
              signature_.add(input.readMessage(org.waveprotocol.wave.federation.Proto.ProtocolSignature.PARSER, extensionRegistry));
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
          signature_ = java.util.Collections.unmodifiableList(signature_);
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolSignedDelta_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolSignedDelta_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.class, org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.Builder.class);
    }

    public static com.google.protobuf.Parser<ProtocolSignedDelta> PARSER =
        new com.google.protobuf.AbstractParser<ProtocolSignedDelta>() {
      public ProtocolSignedDelta parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new ProtocolSignedDelta(input, extensionRegistry);
      }
    };

    @java.lang.Override
    public com.google.protobuf.Parser<ProtocolSignedDelta> getParserForType() {
      return PARSER;
    }

    private int bitField0_;
    // required bytes delta = 1;
    public static final int DELTA_FIELD_NUMBER = 1;
    private com.google.protobuf.ByteString delta_;
    /**
     * <code>required bytes delta = 1;</code>
     */
    public boolean hasDelta() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>required bytes delta = 1;</code>
     */
    public com.google.protobuf.ByteString getDelta() {
      return delta_;
    }

    // repeated .federation.ProtocolSignature signature = 2;
    public static final int SIGNATURE_FIELD_NUMBER = 2;
    private java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolSignature> signature_;
    /**
     * <code>repeated .federation.ProtocolSignature signature = 2;</code>
     */
    public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolSignature> getSignatureList() {
      return signature_;
    }
    /**
     * <code>repeated .federation.ProtocolSignature signature = 2;</code>
     */
    public java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolSignatureOrBuilder> 
        getSignatureOrBuilderList() {
      return signature_;
    }
    /**
     * <code>repeated .federation.ProtocolSignature signature = 2;</code>
     */
    public int getSignatureCount() {
      return signature_.size();
    }
    /**
     * <code>repeated .federation.ProtocolSignature signature = 2;</code>
     */
    public org.waveprotocol.wave.federation.Proto.ProtocolSignature getSignature(int index) {
      return signature_.get(index);
    }
    /**
     * <code>repeated .federation.ProtocolSignature signature = 2;</code>
     */
    public org.waveprotocol.wave.federation.Proto.ProtocolSignatureOrBuilder getSignatureOrBuilder(
        int index) {
      return signature_.get(index);
    }

    private void initFields() {
      delta_ = com.google.protobuf.ByteString.EMPTY;
      signature_ = java.util.Collections.emptyList();
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      if (!hasDelta()) {
        memoizedIsInitialized = 0;
        return false;
      }
      for (int i = 0; i < getSignatureCount(); i++) {
        if (!getSignature(i).isInitialized()) {
          memoizedIsInitialized = 0;
          return false;
        }
      }
      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeBytes(1, delta_);
      }
      for (int i = 0; i < signature_.size(); i++) {
        output.writeMessage(2, signature_.get(i));
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(1, delta_);
      }
      for (int i = 0; i < signature_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(2, signature_.get(i));
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    public static org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code federation.ProtocolSignedDelta}
     *
     * <pre>
     **
     * A canonicalised delta signed with a number of domain signatures.
     * </pre>
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements org.waveprotocol.wave.federation.Proto.ProtocolSignedDeltaOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolSignedDelta_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolSignedDelta_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.class, org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.Builder.class);
      }

      // Construct using org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
          getSignatureFieldBuilder();
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        delta_ = com.google.protobuf.ByteString.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000001);
        if (signatureBuilder_ == null) {
          signature_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000002);
        } else {
          signatureBuilder_.clear();
        }
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolSignedDelta_descriptor;
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta getDefaultInstanceForType() {
        return org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.getDefaultInstance();
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta build() {
        org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta buildPartial() {
        org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta result = new org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.delta_ = delta_;
        if (signatureBuilder_ == null) {
          if (((bitField0_ & 0x00000002) == 0x00000002)) {
            signature_ = java.util.Collections.unmodifiableList(signature_);
            bitField0_ = (bitField0_ & ~0x00000002);
          }
          result.signature_ = signature_;
        } else {
          result.signature_ = signatureBuilder_.build();
        }
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta) {
          return mergeFrom((org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta other) {
        if (other == org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta.getDefaultInstance()) return this;
        if (other.hasDelta()) {
          setDelta(other.getDelta());
        }
        if (signatureBuilder_ == null) {
          if (!other.signature_.isEmpty()) {
            if (signature_.isEmpty()) {
              signature_ = other.signature_;
              bitField0_ = (bitField0_ & ~0x00000002);
            } else {
              ensureSignatureIsMutable();
              signature_.addAll(other.signature_);
            }
            onChanged();
          }
        } else {
          if (!other.signature_.isEmpty()) {
            if (signatureBuilder_.isEmpty()) {
              signatureBuilder_.dispose();
              signatureBuilder_ = null;
              signature_ = other.signature_;
              bitField0_ = (bitField0_ & ~0x00000002);
              signatureBuilder_ = 
                com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                   getSignatureFieldBuilder() : null;
            } else {
              signatureBuilder_.addAllMessages(other.signature_);
            }
          }
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        if (!hasDelta()) {
          
          return false;
        }
        for (int i = 0; i < getSignatureCount(); i++) {
          if (!getSignature(i).isInitialized()) {
            
            return false;
          }
        }
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.waveprotocol.wave.federation.Proto.ProtocolSignedDelta) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // required bytes delta = 1;
      private com.google.protobuf.ByteString delta_ = com.google.protobuf.ByteString.EMPTY;
      /**
       * <code>required bytes delta = 1;</code>
       */
      public boolean hasDelta() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>required bytes delta = 1;</code>
       */
      public com.google.protobuf.ByteString getDelta() {
        return delta_;
      }
      /**
       * <code>required bytes delta = 1;</code>
       */
      public Builder setDelta(com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        delta_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required bytes delta = 1;</code>
       */
      public Builder clearDelta() {
        bitField0_ = (bitField0_ & ~0x00000001);
        delta_ = getDefaultInstance().getDelta();
        onChanged();
        return this;
      }

      // repeated .federation.ProtocolSignature signature = 2;
      private java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolSignature> signature_ =
        java.util.Collections.emptyList();
      private void ensureSignatureIsMutable() {
        if (!((bitField0_ & 0x00000002) == 0x00000002)) {
          signature_ = new java.util.ArrayList<org.waveprotocol.wave.federation.Proto.ProtocolSignature>(signature_);
          bitField0_ |= 0x00000002;
         }
      }

      private com.google.protobuf.RepeatedFieldBuilder<
          org.waveprotocol.wave.federation.Proto.ProtocolSignature, org.waveprotocol.wave.federation.Proto.ProtocolSignature.Builder, org.waveprotocol.wave.federation.Proto.ProtocolSignatureOrBuilder> signatureBuilder_;

      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolSignature> getSignatureList() {
        if (signatureBuilder_ == null) {
          return java.util.Collections.unmodifiableList(signature_);
        } else {
          return signatureBuilder_.getMessageList();
        }
      }
      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public int getSignatureCount() {
        if (signatureBuilder_ == null) {
          return signature_.size();
        } else {
          return signatureBuilder_.getCount();
        }
      }
      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolSignature getSignature(int index) {
        if (signatureBuilder_ == null) {
          return signature_.get(index);
        } else {
          return signatureBuilder_.getMessage(index);
        }
      }
      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public Builder setSignature(
          int index, org.waveprotocol.wave.federation.Proto.ProtocolSignature value) {
        if (signatureBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureSignatureIsMutable();
          signature_.set(index, value);
          onChanged();
        } else {
          signatureBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public Builder setSignature(
          int index, org.waveprotocol.wave.federation.Proto.ProtocolSignature.Builder builderForValue) {
        if (signatureBuilder_ == null) {
          ensureSignatureIsMutable();
          signature_.set(index, builderForValue.build());
          onChanged();
        } else {
          signatureBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public Builder addSignature(org.waveprotocol.wave.federation.Proto.ProtocolSignature value) {
        if (signatureBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureSignatureIsMutable();
          signature_.add(value);
          onChanged();
        } else {
          signatureBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public Builder addSignature(
          int index, org.waveprotocol.wave.federation.Proto.ProtocolSignature value) {
        if (signatureBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureSignatureIsMutable();
          signature_.add(index, value);
          onChanged();
        } else {
          signatureBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public Builder addSignature(
          org.waveprotocol.wave.federation.Proto.ProtocolSignature.Builder builderForValue) {
        if (signatureBuilder_ == null) {
          ensureSignatureIsMutable();
          signature_.add(builderForValue.build());
          onChanged();
        } else {
          signatureBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public Builder addSignature(
          int index, org.waveprotocol.wave.federation.Proto.ProtocolSignature.Builder builderForValue) {
        if (signatureBuilder_ == null) {
          ensureSignatureIsMutable();
          signature_.add(index, builderForValue.build());
          onChanged();
        } else {
          signatureBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public Builder addAllSignature(
          java.lang.Iterable<? extends org.waveprotocol.wave.federation.Proto.ProtocolSignature> values) {
        if (signatureBuilder_ == null) {
          ensureSignatureIsMutable();
          super.addAll(values, signature_);
          onChanged();
        } else {
          signatureBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public Builder clearSignature() {
        if (signatureBuilder_ == null) {
          signature_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000002);
          onChanged();
        } else {
          signatureBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public Builder removeSignature(int index) {
        if (signatureBuilder_ == null) {
          ensureSignatureIsMutable();
          signature_.remove(index);
          onChanged();
        } else {
          signatureBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolSignature.Builder getSignatureBuilder(
          int index) {
        return getSignatureFieldBuilder().getBuilder(index);
      }
      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolSignatureOrBuilder getSignatureOrBuilder(
          int index) {
        if (signatureBuilder_ == null) {
          return signature_.get(index);  } else {
          return signatureBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public java.util.List<? extends org.waveprotocol.wave.federation.Proto.ProtocolSignatureOrBuilder> 
           getSignatureOrBuilderList() {
        if (signatureBuilder_ != null) {
          return signatureBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(signature_);
        }
      }
      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolSignature.Builder addSignatureBuilder() {
        return getSignatureFieldBuilder().addBuilder(
            org.waveprotocol.wave.federation.Proto.ProtocolSignature.getDefaultInstance());
      }
      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolSignature.Builder addSignatureBuilder(
          int index) {
        return getSignatureFieldBuilder().addBuilder(
            index, org.waveprotocol.wave.federation.Proto.ProtocolSignature.getDefaultInstance());
      }
      /**
       * <code>repeated .federation.ProtocolSignature signature = 2;</code>
       */
      public java.util.List<org.waveprotocol.wave.federation.Proto.ProtocolSignature.Builder> 
           getSignatureBuilderList() {
        return getSignatureFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilder<
          org.waveprotocol.wave.federation.Proto.ProtocolSignature, org.waveprotocol.wave.federation.Proto.ProtocolSignature.Builder, org.waveprotocol.wave.federation.Proto.ProtocolSignatureOrBuilder> 
          getSignatureFieldBuilder() {
        if (signatureBuilder_ == null) {
          signatureBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
              org.waveprotocol.wave.federation.Proto.ProtocolSignature, org.waveprotocol.wave.federation.Proto.ProtocolSignature.Builder, org.waveprotocol.wave.federation.Proto.ProtocolSignatureOrBuilder>(
                  signature_,
                  ((bitField0_ & 0x00000002) == 0x00000002),
                  getParentForChildren(),
                  isClean());
          signature_ = null;
        }
        return signatureBuilder_;
      }

      // @@protoc_insertion_point(builder_scope:federation.ProtocolSignedDelta)
    }

    static {
      defaultInstance = new ProtocolSignedDelta(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:federation.ProtocolSignedDelta)
  }

  public interface ProtocolSignatureOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // required bytes signature_bytes = 1;
    /**
     * <code>required bytes signature_bytes = 1;</code>
     */
    boolean hasSignatureBytes();
    /**
     * <code>required bytes signature_bytes = 1;</code>
     */
    com.google.protobuf.ByteString getSignatureBytes();

    // required bytes signer_id = 2;
    /**
     * <code>required bytes signer_id = 2;</code>
     */
    boolean hasSignerId();
    /**
     * <code>required bytes signer_id = 2;</code>
     */
    com.google.protobuf.ByteString getSignerId();

    // required .federation.ProtocolSignature.SignatureAlgorithm signature_algorithm = 3;
    /**
     * <code>required .federation.ProtocolSignature.SignatureAlgorithm signature_algorithm = 3;</code>
     */
    boolean hasSignatureAlgorithm();
    /**
     * <code>required .federation.ProtocolSignature.SignatureAlgorithm signature_algorithm = 3;</code>
     */
    org.waveprotocol.wave.federation.Proto.ProtocolSignature.SignatureAlgorithm getSignatureAlgorithm();
  }
  /**
   * Protobuf type {@code federation.ProtocolSignature}
   *
   * <pre>
   **
   * A signature for a delta. It contains the actual bytes of the signature,
   * an identifier of the signer (usually the hash of a certificate chain),
   * and an enum identifying the signature algorithm used.
   * </pre>
   */
  public static final class ProtocolSignature extends
      com.google.protobuf.GeneratedMessage
      implements ProtocolSignatureOrBuilder {
    // Use ProtocolSignature.newBuilder() to construct.
    private ProtocolSignature(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private ProtocolSignature(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final ProtocolSignature defaultInstance;
    public static ProtocolSignature getDefaultInstance() {
      return defaultInstance;
    }

    public ProtocolSignature getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private ProtocolSignature(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              bitField0_ |= 0x00000001;
              signatureBytes_ = input.readBytes();
              break;
            }
            case 18: {
              bitField0_ |= 0x00000002;
              signerId_ = input.readBytes();
              break;
            }
            case 24: {
              int rawValue = input.readEnum();
              org.waveprotocol.wave.federation.Proto.ProtocolSignature.SignatureAlgorithm value = org.waveprotocol.wave.federation.Proto.ProtocolSignature.SignatureAlgorithm.valueOf(rawValue);
              if (value == null) {
                unknownFields.mergeVarintField(3, rawValue);
              } else {
                bitField0_ |= 0x00000004;
                signatureAlgorithm_ = value;
              }
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolSignature_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolSignature_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.waveprotocol.wave.federation.Proto.ProtocolSignature.class, org.waveprotocol.wave.federation.Proto.ProtocolSignature.Builder.class);
    }

    public static com.google.protobuf.Parser<ProtocolSignature> PARSER =
        new com.google.protobuf.AbstractParser<ProtocolSignature>() {
      public ProtocolSignature parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new ProtocolSignature(input, extensionRegistry);
      }
    };

    @java.lang.Override
    public com.google.protobuf.Parser<ProtocolSignature> getParserForType() {
      return PARSER;
    }

    /**
     * Protobuf enum {@code federation.ProtocolSignature.SignatureAlgorithm}
     */
    public enum SignatureAlgorithm
        implements com.google.protobuf.ProtocolMessageEnum {
      /**
       * <code>SHA1_RSA = 1;</code>
       */
      SHA1_RSA(0, 1),
      ;

      /**
       * <code>SHA1_RSA = 1;</code>
       */
      public static final int SHA1_RSA_VALUE = 1;


      public final int getNumber() { return value; }

      public static SignatureAlgorithm valueOf(int value) {
        switch (value) {
          case 1: return SHA1_RSA;
          default: return null;
        }
      }

      public static com.google.protobuf.Internal.EnumLiteMap<SignatureAlgorithm>
          internalGetValueMap() {
        return internalValueMap;
      }
      private static com.google.protobuf.Internal.EnumLiteMap<SignatureAlgorithm>
          internalValueMap =
            new com.google.protobuf.Internal.EnumLiteMap<SignatureAlgorithm>() {
              public SignatureAlgorithm findValueByNumber(int number) {
                return SignatureAlgorithm.valueOf(number);
              }
            };

      public final com.google.protobuf.Descriptors.EnumValueDescriptor
          getValueDescriptor() {
        return getDescriptor().getValues().get(index);
      }
      public final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptorForType() {
        return getDescriptor();
      }
      public static final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptor() {
        return org.waveprotocol.wave.federation.Proto.ProtocolSignature.getDescriptor().getEnumTypes().get(0);
      }

      private static final SignatureAlgorithm[] VALUES = values();

      public static SignatureAlgorithm valueOf(
          com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
        if (desc.getType() != getDescriptor()) {
          throw new java.lang.IllegalArgumentException(
            "EnumValueDescriptor is not for this type.");
        }
        return VALUES[desc.getIndex()];
      }

      private final int index;
      private final int value;

      private SignatureAlgorithm(int index, int value) {
        this.index = index;
        this.value = value;
      }

      // @@protoc_insertion_point(enum_scope:federation.ProtocolSignature.SignatureAlgorithm)
    }

    private int bitField0_;
    // required bytes signature_bytes = 1;
    public static final int SIGNATURE_BYTES_FIELD_NUMBER = 1;
    private com.google.protobuf.ByteString signatureBytes_;
    /**
     * <code>required bytes signature_bytes = 1;</code>
     */
    public boolean hasSignatureBytes() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>required bytes signature_bytes = 1;</code>
     */
    public com.google.protobuf.ByteString getSignatureBytes() {
      return signatureBytes_;
    }

    // required bytes signer_id = 2;
    public static final int SIGNER_ID_FIELD_NUMBER = 2;
    private com.google.protobuf.ByteString signerId_;
    /**
     * <code>required bytes signer_id = 2;</code>
     */
    public boolean hasSignerId() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    /**
     * <code>required bytes signer_id = 2;</code>
     */
    public com.google.protobuf.ByteString getSignerId() {
      return signerId_;
    }

    // required .federation.ProtocolSignature.SignatureAlgorithm signature_algorithm = 3;
    public static final int SIGNATURE_ALGORITHM_FIELD_NUMBER = 3;
    private org.waveprotocol.wave.federation.Proto.ProtocolSignature.SignatureAlgorithm signatureAlgorithm_;
    /**
     * <code>required .federation.ProtocolSignature.SignatureAlgorithm signature_algorithm = 3;</code>
     */
    public boolean hasSignatureAlgorithm() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    /**
     * <code>required .federation.ProtocolSignature.SignatureAlgorithm signature_algorithm = 3;</code>
     */
    public org.waveprotocol.wave.federation.Proto.ProtocolSignature.SignatureAlgorithm getSignatureAlgorithm() {
      return signatureAlgorithm_;
    }

    private void initFields() {
      signatureBytes_ = com.google.protobuf.ByteString.EMPTY;
      signerId_ = com.google.protobuf.ByteString.EMPTY;
      signatureAlgorithm_ = org.waveprotocol.wave.federation.Proto.ProtocolSignature.SignatureAlgorithm.SHA1_RSA;
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      if (!hasSignatureBytes()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasSignerId()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasSignatureAlgorithm()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeBytes(1, signatureBytes_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeBytes(2, signerId_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeEnum(3, signatureAlgorithm_.getNumber());
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(1, signatureBytes_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(2, signerId_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeEnumSize(3, signatureAlgorithm_.getNumber());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    public static org.waveprotocol.wave.federation.Proto.ProtocolSignature parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignature parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignature parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignature parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignature parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignature parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignature parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignature parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignature parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignature parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(org.waveprotocol.wave.federation.Proto.ProtocolSignature prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code federation.ProtocolSignature}
     *
     * <pre>
     **
     * A signature for a delta. It contains the actual bytes of the signature,
     * an identifier of the signer (usually the hash of a certificate chain),
     * and an enum identifying the signature algorithm used.
     * </pre>
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements org.waveprotocol.wave.federation.Proto.ProtocolSignatureOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolSignature_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolSignature_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.waveprotocol.wave.federation.Proto.ProtocolSignature.class, org.waveprotocol.wave.federation.Proto.ProtocolSignature.Builder.class);
      }

      // Construct using org.waveprotocol.wave.federation.Proto.ProtocolSignature.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        signatureBytes_ = com.google.protobuf.ByteString.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000001);
        signerId_ = com.google.protobuf.ByteString.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000002);
        signatureAlgorithm_ = org.waveprotocol.wave.federation.Proto.ProtocolSignature.SignatureAlgorithm.SHA1_RSA;
        bitField0_ = (bitField0_ & ~0x00000004);
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolSignature_descriptor;
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolSignature getDefaultInstanceForType() {
        return org.waveprotocol.wave.federation.Proto.ProtocolSignature.getDefaultInstance();
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolSignature build() {
        org.waveprotocol.wave.federation.Proto.ProtocolSignature result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolSignature buildPartial() {
        org.waveprotocol.wave.federation.Proto.ProtocolSignature result = new org.waveprotocol.wave.federation.Proto.ProtocolSignature(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.signatureBytes_ = signatureBytes_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.signerId_ = signerId_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.signatureAlgorithm_ = signatureAlgorithm_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.waveprotocol.wave.federation.Proto.ProtocolSignature) {
          return mergeFrom((org.waveprotocol.wave.federation.Proto.ProtocolSignature)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.waveprotocol.wave.federation.Proto.ProtocolSignature other) {
        if (other == org.waveprotocol.wave.federation.Proto.ProtocolSignature.getDefaultInstance()) return this;
        if (other.hasSignatureBytes()) {
          setSignatureBytes(other.getSignatureBytes());
        }
        if (other.hasSignerId()) {
          setSignerId(other.getSignerId());
        }
        if (other.hasSignatureAlgorithm()) {
          setSignatureAlgorithm(other.getSignatureAlgorithm());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        if (!hasSignatureBytes()) {
          
          return false;
        }
        if (!hasSignerId()) {
          
          return false;
        }
        if (!hasSignatureAlgorithm()) {
          
          return false;
        }
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.waveprotocol.wave.federation.Proto.ProtocolSignature parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.waveprotocol.wave.federation.Proto.ProtocolSignature) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // required bytes signature_bytes = 1;
      private com.google.protobuf.ByteString signatureBytes_ = com.google.protobuf.ByteString.EMPTY;
      /**
       * <code>required bytes signature_bytes = 1;</code>
       */
      public boolean hasSignatureBytes() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>required bytes signature_bytes = 1;</code>
       */
      public com.google.protobuf.ByteString getSignatureBytes() {
        return signatureBytes_;
      }
      /**
       * <code>required bytes signature_bytes = 1;</code>
       */
      public Builder setSignatureBytes(com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        signatureBytes_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required bytes signature_bytes = 1;</code>
       */
      public Builder clearSignatureBytes() {
        bitField0_ = (bitField0_ & ~0x00000001);
        signatureBytes_ = getDefaultInstance().getSignatureBytes();
        onChanged();
        return this;
      }

      // required bytes signer_id = 2;
      private com.google.protobuf.ByteString signerId_ = com.google.protobuf.ByteString.EMPTY;
      /**
       * <code>required bytes signer_id = 2;</code>
       */
      public boolean hasSignerId() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      /**
       * <code>required bytes signer_id = 2;</code>
       */
      public com.google.protobuf.ByteString getSignerId() {
        return signerId_;
      }
      /**
       * <code>required bytes signer_id = 2;</code>
       */
      public Builder setSignerId(com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        signerId_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required bytes signer_id = 2;</code>
       */
      public Builder clearSignerId() {
        bitField0_ = (bitField0_ & ~0x00000002);
        signerId_ = getDefaultInstance().getSignerId();
        onChanged();
        return this;
      }

      // required .federation.ProtocolSignature.SignatureAlgorithm signature_algorithm = 3;
      private org.waveprotocol.wave.federation.Proto.ProtocolSignature.SignatureAlgorithm signatureAlgorithm_ = org.waveprotocol.wave.federation.Proto.ProtocolSignature.SignatureAlgorithm.SHA1_RSA;
      /**
       * <code>required .federation.ProtocolSignature.SignatureAlgorithm signature_algorithm = 3;</code>
       */
      public boolean hasSignatureAlgorithm() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      /**
       * <code>required .federation.ProtocolSignature.SignatureAlgorithm signature_algorithm = 3;</code>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolSignature.SignatureAlgorithm getSignatureAlgorithm() {
        return signatureAlgorithm_;
      }
      /**
       * <code>required .federation.ProtocolSignature.SignatureAlgorithm signature_algorithm = 3;</code>
       */
      public Builder setSignatureAlgorithm(org.waveprotocol.wave.federation.Proto.ProtocolSignature.SignatureAlgorithm value) {
        if (value == null) {
          throw new NullPointerException();
        }
        bitField0_ |= 0x00000004;
        signatureAlgorithm_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required .federation.ProtocolSignature.SignatureAlgorithm signature_algorithm = 3;</code>
       */
      public Builder clearSignatureAlgorithm() {
        bitField0_ = (bitField0_ & ~0x00000004);
        signatureAlgorithm_ = org.waveprotocol.wave.federation.Proto.ProtocolSignature.SignatureAlgorithm.SHA1_RSA;
        onChanged();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:federation.ProtocolSignature)
    }

    static {
      defaultInstance = new ProtocolSignature(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:federation.ProtocolSignature)
  }

  public interface ProtocolSignerInfoOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // required .federation.ProtocolSignerInfo.HashAlgorithm hash_algorithm = 1;
    /**
     * <code>required .federation.ProtocolSignerInfo.HashAlgorithm hash_algorithm = 1;</code>
     *
     * <pre>
     * The hash algorithm senders will use to generate an id that will refer to
     * this certificate chain in the future
     * </pre>
     */
    boolean hasHashAlgorithm();
    /**
     * <code>required .federation.ProtocolSignerInfo.HashAlgorithm hash_algorithm = 1;</code>
     *
     * <pre>
     * The hash algorithm senders will use to generate an id that will refer to
     * this certificate chain in the future
     * </pre>
     */
    org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.HashAlgorithm getHashAlgorithm();

    // required string domain = 2;
    /**
     * <code>required string domain = 2;</code>
     *
     * <pre>
     * The domain that this certificate chain was issued to. Receivers of this
     * ProtocolSignerInfo SHOULD reject the ProtocolSignerInfo if the target
     * certificate (the first one in the list) is not issued to this domain.
     * </pre>
     */
    boolean hasDomain();
    /**
     * <code>required string domain = 2;</code>
     *
     * <pre>
     * The domain that this certificate chain was issued to. Receivers of this
     * ProtocolSignerInfo SHOULD reject the ProtocolSignerInfo if the target
     * certificate (the first one in the list) is not issued to this domain.
     * </pre>
     */
    java.lang.String getDomain();
    /**
     * <code>required string domain = 2;</code>
     *
     * <pre>
     * The domain that this certificate chain was issued to. Receivers of this
     * ProtocolSignerInfo SHOULD reject the ProtocolSignerInfo if the target
     * certificate (the first one in the list) is not issued to this domain.
     * </pre>
     */
    com.google.protobuf.ByteString
        getDomainBytes();

    // repeated bytes certificate = 3;
    /**
     * <code>repeated bytes certificate = 3;</code>
     *
     * <pre>
     * The certificate chain. The target certificate (i.e., the certificate issued
     * to the signer) is first, and the CA certificate (or one issued directly
     * by the CA) is last.
     * </pre>
     */
    java.util.List<com.google.protobuf.ByteString> getCertificateList();
    /**
     * <code>repeated bytes certificate = 3;</code>
     *
     * <pre>
     * The certificate chain. The target certificate (i.e., the certificate issued
     * to the signer) is first, and the CA certificate (or one issued directly
     * by the CA) is last.
     * </pre>
     */
    int getCertificateCount();
    /**
     * <code>repeated bytes certificate = 3;</code>
     *
     * <pre>
     * The certificate chain. The target certificate (i.e., the certificate issued
     * to the signer) is first, and the CA certificate (or one issued directly
     * by the CA) is last.
     * </pre>
     */
    com.google.protobuf.ByteString getCertificate(int index);
  }
  /**
   * Protobuf type {@code federation.ProtocolSignerInfo}
   *
   * <pre>
   **
   * A certificate chain that a sender will refer to in subsequent signatures.
   *
   * The signer_id field in a ProtocolSignature refers to a ProtocolSignerInfo
   * as follows: The certificates present in a ProtocolSignerInfo are encoded
   * in PkiPath format, and then hashed using the hash algorithm indicated in the
   * ProtocolSignerInfo.
   * </pre>
   */
  public static final class ProtocolSignerInfo extends
      com.google.protobuf.GeneratedMessage
      implements ProtocolSignerInfoOrBuilder {
    // Use ProtocolSignerInfo.newBuilder() to construct.
    private ProtocolSignerInfo(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private ProtocolSignerInfo(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final ProtocolSignerInfo defaultInstance;
    public static ProtocolSignerInfo getDefaultInstance() {
      return defaultInstance;
    }

    public ProtocolSignerInfo getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private ProtocolSignerInfo(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 8: {
              int rawValue = input.readEnum();
              org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.HashAlgorithm value = org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.HashAlgorithm.valueOf(rawValue);
              if (value == null) {
                unknownFields.mergeVarintField(1, rawValue);
              } else {
                bitField0_ |= 0x00000001;
                hashAlgorithm_ = value;
              }
              break;
            }
            case 18: {
              bitField0_ |= 0x00000002;
              domain_ = input.readBytes();
              break;
            }
            case 26: {
              if (!((mutable_bitField0_ & 0x00000004) == 0x00000004)) {
                certificate_ = new java.util.ArrayList<com.google.protobuf.ByteString>();
                mutable_bitField0_ |= 0x00000004;
              }
              certificate_.add(input.readBytes());
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000004) == 0x00000004)) {
          certificate_ = java.util.Collections.unmodifiableList(certificate_);
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolSignerInfo_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolSignerInfo_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.class, org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.Builder.class);
    }

    public static com.google.protobuf.Parser<ProtocolSignerInfo> PARSER =
        new com.google.protobuf.AbstractParser<ProtocolSignerInfo>() {
      public ProtocolSignerInfo parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new ProtocolSignerInfo(input, extensionRegistry);
      }
    };

    @java.lang.Override
    public com.google.protobuf.Parser<ProtocolSignerInfo> getParserForType() {
      return PARSER;
    }

    /**
     * Protobuf enum {@code federation.ProtocolSignerInfo.HashAlgorithm}
     */
    public enum HashAlgorithm
        implements com.google.protobuf.ProtocolMessageEnum {
      /**
       * <code>SHA256 = 1;</code>
       */
      SHA256(0, 1),
      /**
       * <code>SHA512 = 2;</code>
       */
      SHA512(1, 2),
      ;

      /**
       * <code>SHA256 = 1;</code>
       */
      public static final int SHA256_VALUE = 1;
      /**
       * <code>SHA512 = 2;</code>
       */
      public static final int SHA512_VALUE = 2;


      public final int getNumber() { return value; }

      public static HashAlgorithm valueOf(int value) {
        switch (value) {
          case 1: return SHA256;
          case 2: return SHA512;
          default: return null;
        }
      }

      public static com.google.protobuf.Internal.EnumLiteMap<HashAlgorithm>
          internalGetValueMap() {
        return internalValueMap;
      }
      private static com.google.protobuf.Internal.EnumLiteMap<HashAlgorithm>
          internalValueMap =
            new com.google.protobuf.Internal.EnumLiteMap<HashAlgorithm>() {
              public HashAlgorithm findValueByNumber(int number) {
                return HashAlgorithm.valueOf(number);
              }
            };

      public final com.google.protobuf.Descriptors.EnumValueDescriptor
          getValueDescriptor() {
        return getDescriptor().getValues().get(index);
      }
      public final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptorForType() {
        return getDescriptor();
      }
      public static final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptor() {
        return org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.getDescriptor().getEnumTypes().get(0);
      }

      private static final HashAlgorithm[] VALUES = values();

      public static HashAlgorithm valueOf(
          com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
        if (desc.getType() != getDescriptor()) {
          throw new java.lang.IllegalArgumentException(
            "EnumValueDescriptor is not for this type.");
        }
        return VALUES[desc.getIndex()];
      }

      private final int index;
      private final int value;

      private HashAlgorithm(int index, int value) {
        this.index = index;
        this.value = value;
      }

      // @@protoc_insertion_point(enum_scope:federation.ProtocolSignerInfo.HashAlgorithm)
    }

    private int bitField0_;
    // required .federation.ProtocolSignerInfo.HashAlgorithm hash_algorithm = 1;
    public static final int HASH_ALGORITHM_FIELD_NUMBER = 1;
    private org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.HashAlgorithm hashAlgorithm_;
    /**
     * <code>required .federation.ProtocolSignerInfo.HashAlgorithm hash_algorithm = 1;</code>
     *
     * <pre>
     * The hash algorithm senders will use to generate an id that will refer to
     * this certificate chain in the future
     * </pre>
     */
    public boolean hasHashAlgorithm() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>required .federation.ProtocolSignerInfo.HashAlgorithm hash_algorithm = 1;</code>
     *
     * <pre>
     * The hash algorithm senders will use to generate an id that will refer to
     * this certificate chain in the future
     * </pre>
     */
    public org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.HashAlgorithm getHashAlgorithm() {
      return hashAlgorithm_;
    }

    // required string domain = 2;
    public static final int DOMAIN_FIELD_NUMBER = 2;
    private java.lang.Object domain_;
    /**
     * <code>required string domain = 2;</code>
     *
     * <pre>
     * The domain that this certificate chain was issued to. Receivers of this
     * ProtocolSignerInfo SHOULD reject the ProtocolSignerInfo if the target
     * certificate (the first one in the list) is not issued to this domain.
     * </pre>
     */
    public boolean hasDomain() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    /**
     * <code>required string domain = 2;</code>
     *
     * <pre>
     * The domain that this certificate chain was issued to. Receivers of this
     * ProtocolSignerInfo SHOULD reject the ProtocolSignerInfo if the target
     * certificate (the first one in the list) is not issued to this domain.
     * </pre>
     */
    public java.lang.String getDomain() {
      java.lang.Object ref = domain_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          domain_ = s;
        }
        return s;
      }
    }
    /**
     * <code>required string domain = 2;</code>
     *
     * <pre>
     * The domain that this certificate chain was issued to. Receivers of this
     * ProtocolSignerInfo SHOULD reject the ProtocolSignerInfo if the target
     * certificate (the first one in the list) is not issued to this domain.
     * </pre>
     */
    public com.google.protobuf.ByteString
        getDomainBytes() {
      java.lang.Object ref = domain_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        domain_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // repeated bytes certificate = 3;
    public static final int CERTIFICATE_FIELD_NUMBER = 3;
    private java.util.List<com.google.protobuf.ByteString> certificate_;
    /**
     * <code>repeated bytes certificate = 3;</code>
     *
     * <pre>
     * The certificate chain. The target certificate (i.e., the certificate issued
     * to the signer) is first, and the CA certificate (or one issued directly
     * by the CA) is last.
     * </pre>
     */
    public java.util.List<com.google.protobuf.ByteString>
        getCertificateList() {
      return certificate_;
    }
    /**
     * <code>repeated bytes certificate = 3;</code>
     *
     * <pre>
     * The certificate chain. The target certificate (i.e., the certificate issued
     * to the signer) is first, and the CA certificate (or one issued directly
     * by the CA) is last.
     * </pre>
     */
    public int getCertificateCount() {
      return certificate_.size();
    }
    /**
     * <code>repeated bytes certificate = 3;</code>
     *
     * <pre>
     * The certificate chain. The target certificate (i.e., the certificate issued
     * to the signer) is first, and the CA certificate (or one issued directly
     * by the CA) is last.
     * </pre>
     */
    public com.google.protobuf.ByteString getCertificate(int index) {
      return certificate_.get(index);
    }

    private void initFields() {
      hashAlgorithm_ = org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.HashAlgorithm.SHA256;
      domain_ = "";
      certificate_ = java.util.Collections.emptyList();
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      if (!hasHashAlgorithm()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasDomain()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeEnum(1, hashAlgorithm_.getNumber());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeBytes(2, getDomainBytes());
      }
      for (int i = 0; i < certificate_.size(); i++) {
        output.writeBytes(3, certificate_.get(i));
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeEnumSize(1, hashAlgorithm_.getNumber());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(2, getDomainBytes());
      }
      {
        int dataSize = 0;
        for (int i = 0; i < certificate_.size(); i++) {
          dataSize += com.google.protobuf.CodedOutputStream
            .computeBytesSizeNoTag(certificate_.get(i));
        }
        size += dataSize;
        size += 1 * getCertificateList().size();
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    public static org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code federation.ProtocolSignerInfo}
     *
     * <pre>
     **
     * A certificate chain that a sender will refer to in subsequent signatures.
     *
     * The signer_id field in a ProtocolSignature refers to a ProtocolSignerInfo
     * as follows: The certificates present in a ProtocolSignerInfo are encoded
     * in PkiPath format, and then hashed using the hash algorithm indicated in the
     * ProtocolSignerInfo.
     * </pre>
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements org.waveprotocol.wave.federation.Proto.ProtocolSignerInfoOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolSignerInfo_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolSignerInfo_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.class, org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.Builder.class);
      }

      // Construct using org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        hashAlgorithm_ = org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.HashAlgorithm.SHA256;
        bitField0_ = (bitField0_ & ~0x00000001);
        domain_ = "";
        bitField0_ = (bitField0_ & ~0x00000002);
        certificate_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000004);
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.waveprotocol.wave.federation.Proto.internal_static_federation_ProtocolSignerInfo_descriptor;
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo getDefaultInstanceForType() {
        return org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.getDefaultInstance();
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo build() {
        org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo buildPartial() {
        org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo result = new org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.hashAlgorithm_ = hashAlgorithm_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.domain_ = domain_;
        if (((bitField0_ & 0x00000004) == 0x00000004)) {
          certificate_ = java.util.Collections.unmodifiableList(certificate_);
          bitField0_ = (bitField0_ & ~0x00000004);
        }
        result.certificate_ = certificate_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo) {
          return mergeFrom((org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo other) {
        if (other == org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.getDefaultInstance()) return this;
        if (other.hasHashAlgorithm()) {
          setHashAlgorithm(other.getHashAlgorithm());
        }
        if (other.hasDomain()) {
          bitField0_ |= 0x00000002;
          domain_ = other.domain_;
          onChanged();
        }
        if (!other.certificate_.isEmpty()) {
          if (certificate_.isEmpty()) {
            certificate_ = other.certificate_;
            bitField0_ = (bitField0_ & ~0x00000004);
          } else {
            ensureCertificateIsMutable();
            certificate_.addAll(other.certificate_);
          }
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        if (!hasHashAlgorithm()) {
          
          return false;
        }
        if (!hasDomain()) {
          
          return false;
        }
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // required .federation.ProtocolSignerInfo.HashAlgorithm hash_algorithm = 1;
      private org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.HashAlgorithm hashAlgorithm_ = org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.HashAlgorithm.SHA256;
      /**
       * <code>required .federation.ProtocolSignerInfo.HashAlgorithm hash_algorithm = 1;</code>
       *
       * <pre>
       * The hash algorithm senders will use to generate an id that will refer to
       * this certificate chain in the future
       * </pre>
       */
      public boolean hasHashAlgorithm() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>required .federation.ProtocolSignerInfo.HashAlgorithm hash_algorithm = 1;</code>
       *
       * <pre>
       * The hash algorithm senders will use to generate an id that will refer to
       * this certificate chain in the future
       * </pre>
       */
      public org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.HashAlgorithm getHashAlgorithm() {
        return hashAlgorithm_;
      }
      /**
       * <code>required .federation.ProtocolSignerInfo.HashAlgorithm hash_algorithm = 1;</code>
       *
       * <pre>
       * The hash algorithm senders will use to generate an id that will refer to
       * this certificate chain in the future
       * </pre>
       */
      public Builder setHashAlgorithm(org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.HashAlgorithm value) {
        if (value == null) {
          throw new NullPointerException();
        }
        bitField0_ |= 0x00000001;
        hashAlgorithm_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required .federation.ProtocolSignerInfo.HashAlgorithm hash_algorithm = 1;</code>
       *
       * <pre>
       * The hash algorithm senders will use to generate an id that will refer to
       * this certificate chain in the future
       * </pre>
       */
      public Builder clearHashAlgorithm() {
        bitField0_ = (bitField0_ & ~0x00000001);
        hashAlgorithm_ = org.waveprotocol.wave.federation.Proto.ProtocolSignerInfo.HashAlgorithm.SHA256;
        onChanged();
        return this;
      }

      // required string domain = 2;
      private java.lang.Object domain_ = "";
      /**
       * <code>required string domain = 2;</code>
       *
       * <pre>
       * The domain that this certificate chain was issued to. Receivers of this
       * ProtocolSignerInfo SHOULD reject the ProtocolSignerInfo if the target
       * certificate (the first one in the list) is not issued to this domain.
       * </pre>
       */
      public boolean hasDomain() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      /**
       * <code>required string domain = 2;</code>
       *
       * <pre>
       * The domain that this certificate chain was issued to. Receivers of this
       * ProtocolSignerInfo SHOULD reject the ProtocolSignerInfo if the target
       * certificate (the first one in the list) is not issued to this domain.
       * </pre>
       */
      public java.lang.String getDomain() {
        java.lang.Object ref = domain_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          domain_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>required string domain = 2;</code>
       *
       * <pre>
       * The domain that this certificate chain was issued to. Receivers of this
       * ProtocolSignerInfo SHOULD reject the ProtocolSignerInfo if the target
       * certificate (the first one in the list) is not issued to this domain.
       * </pre>
       */
      public com.google.protobuf.ByteString
          getDomainBytes() {
        java.lang.Object ref = domain_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          domain_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>required string domain = 2;</code>
       *
       * <pre>
       * The domain that this certificate chain was issued to. Receivers of this
       * ProtocolSignerInfo SHOULD reject the ProtocolSignerInfo if the target
       * certificate (the first one in the list) is not issued to this domain.
       * </pre>
       */
      public Builder setDomain(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        domain_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required string domain = 2;</code>
       *
       * <pre>
       * The domain that this certificate chain was issued to. Receivers of this
       * ProtocolSignerInfo SHOULD reject the ProtocolSignerInfo if the target
       * certificate (the first one in the list) is not issued to this domain.
       * </pre>
       */
      public Builder clearDomain() {
        bitField0_ = (bitField0_ & ~0x00000002);
        domain_ = getDefaultInstance().getDomain();
        onChanged();
        return this;
      }
      /**
       * <code>required string domain = 2;</code>
       *
       * <pre>
       * The domain that this certificate chain was issued to. Receivers of this
       * ProtocolSignerInfo SHOULD reject the ProtocolSignerInfo if the target
       * certificate (the first one in the list) is not issued to this domain.
       * </pre>
       */
      public Builder setDomainBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        domain_ = value;
        onChanged();
        return this;
      }

      // repeated bytes certificate = 3;
      private java.util.List<com.google.protobuf.ByteString> certificate_ = java.util.Collections.emptyList();
      private void ensureCertificateIsMutable() {
        if (!((bitField0_ & 0x00000004) == 0x00000004)) {
          certificate_ = new java.util.ArrayList<com.google.protobuf.ByteString>(certificate_);
          bitField0_ |= 0x00000004;
         }
      }
      /**
       * <code>repeated bytes certificate = 3;</code>
       *
       * <pre>
       * The certificate chain. The target certificate (i.e., the certificate issued
       * to the signer) is first, and the CA certificate (or one issued directly
       * by the CA) is last.
       * </pre>
       */
      public java.util.List<com.google.protobuf.ByteString>
          getCertificateList() {
        return java.util.Collections.unmodifiableList(certificate_);
      }
      /**
       * <code>repeated bytes certificate = 3;</code>
       *
       * <pre>
       * The certificate chain. The target certificate (i.e., the certificate issued
       * to the signer) is first, and the CA certificate (or one issued directly
       * by the CA) is last.
       * </pre>
       */
      public int getCertificateCount() {
        return certificate_.size();
      }
      /**
       * <code>repeated bytes certificate = 3;</code>
       *
       * <pre>
       * The certificate chain. The target certificate (i.e., the certificate issued
       * to the signer) is first, and the CA certificate (or one issued directly
       * by the CA) is last.
       * </pre>
       */
      public com.google.protobuf.ByteString getCertificate(int index) {
        return certificate_.get(index);
      }
      /**
       * <code>repeated bytes certificate = 3;</code>
       *
       * <pre>
       * The certificate chain. The target certificate (i.e., the certificate issued
       * to the signer) is first, and the CA certificate (or one issued directly
       * by the CA) is last.
       * </pre>
       */
      public Builder setCertificate(
          int index, com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureCertificateIsMutable();
        certificate_.set(index, value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated bytes certificate = 3;</code>
       *
       * <pre>
       * The certificate chain. The target certificate (i.e., the certificate issued
       * to the signer) is first, and the CA certificate (or one issued directly
       * by the CA) is last.
       * </pre>
       */
      public Builder addCertificate(com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureCertificateIsMutable();
        certificate_.add(value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated bytes certificate = 3;</code>
       *
       * <pre>
       * The certificate chain. The target certificate (i.e., the certificate issued
       * to the signer) is first, and the CA certificate (or one issued directly
       * by the CA) is last.
       * </pre>
       */
      public Builder addAllCertificate(
          java.lang.Iterable<? extends com.google.protobuf.ByteString> values) {
        ensureCertificateIsMutable();
        super.addAll(values, certificate_);
        onChanged();
        return this;
      }
      /**
       * <code>repeated bytes certificate = 3;</code>
       *
       * <pre>
       * The certificate chain. The target certificate (i.e., the certificate issued
       * to the signer) is first, and the CA certificate (or one issued directly
       * by the CA) is last.
       * </pre>
       */
      public Builder clearCertificate() {
        certificate_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000004);
        onChanged();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:federation.ProtocolSignerInfo)
    }

    static {
      defaultInstance = new ProtocolSignerInfo(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:federation.ProtocolSignerInfo)
  }

  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_federation_ProtocolWaveletDelta_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_federation_ProtocolWaveletDelta_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_federation_ProtocolHashedVersion_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_federation_ProtocolHashedVersion_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_federation_ProtocolWaveletOperation_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_federation_ProtocolWaveletOperation_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_federation_ProtocolWaveletOperation_MutateDocument_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_federation_ProtocolWaveletOperation_MutateDocument_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_federation_ProtocolDocumentOperation_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_federation_ProtocolDocumentOperation_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_federation_ProtocolDocumentOperation_Component_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_federation_ProtocolDocumentOperation_Component_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_federation_ProtocolDocumentOperation_Component_KeyValuePair_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_federation_ProtocolDocumentOperation_Component_KeyValuePair_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_federation_ProtocolDocumentOperation_Component_KeyValueUpdate_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_federation_ProtocolDocumentOperation_Component_KeyValueUpdate_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_federation_ProtocolDocumentOperation_Component_ElementStart_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_federation_ProtocolDocumentOperation_Component_ElementStart_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_federation_ProtocolDocumentOperation_Component_ReplaceAttributes_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_federation_ProtocolDocumentOperation_Component_ReplaceAttributes_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_federation_ProtocolDocumentOperation_Component_UpdateAttributes_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_federation_ProtocolDocumentOperation_Component_UpdateAttributes_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_federation_ProtocolDocumentOperation_Component_AnnotationBoundary_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_federation_ProtocolDocumentOperation_Component_AnnotationBoundary_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_federation_ProtocolAppliedWaveletDelta_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_federation_ProtocolAppliedWaveletDelta_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_federation_ProtocolSignedDelta_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_federation_ProtocolSignedDelta_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_federation_ProtocolSignature_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_federation_ProtocolSignature_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_federation_ProtocolSignerInfo_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_federation_ProtocolSignerInfo_fieldAccessorTable;

  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n6org/waveprotocol/wave/federation/feder" +
      "ation.protodevel\022\nfederation\032*org/wavepr" +
      "otocol/protobuf/extensions.proto\"\260\001\n\024Pro" +
      "tocolWaveletDelta\0229\n\016hashed_version\030\001 \002(" +
      "\0132!.federation.ProtocolHashedVersion\022\016\n\006" +
      "author\030\002 \002(\t\0227\n\toperation\030\003 \003(\0132$.federa" +
      "tion.ProtocolWaveletOperation\022\024\n\014address" +
      "_path\030\004 \003(\t\"D\n\025ProtocolHashedVersion\022\025\n\007" +
      "version\030\001 \002(\003B\004\200\265\030\001\022\024\n\014history_hash\030\002 \002(" +
      "\014\"\226\002\n\030ProtocolWaveletOperation\022\027\n\017add_pa",
      "rticipant\030\001 \001(\t\022\032\n\022remove_participant\030\002 " +
      "\001(\t\022L\n\017mutate_document\030\003 \001(\01323.federatio" +
      "n.ProtocolWaveletOperation.MutateDocumen" +
      "t\022\r\n\005no_op\030\004 \001(\010\032h\n\016MutateDocument\022\023\n\013do" +
      "cument_id\030\001 \002(\t\022A\n\022document_operation\030\002 " +
      "\002(\0132%.federation.ProtocolDocumentOperati" +
      "on\"\345\n\n\031ProtocolDocumentOperation\022B\n\tcomp" +
      "onent\030\001 \003(\0132/.federation.ProtocolDocumen" +
      "tOperation.Component\032\203\n\n\tComponent\022_\n\023an" +
      "notation_boundary\030\001 \001(\0132B.federation.Pro",
      "tocolDocumentOperation.Component.Annotat" +
      "ionBoundary\022\022\n\ncharacters\030\002 \001(\t\022S\n\releme" +
      "nt_start\030\003 \001(\0132<.federation.ProtocolDocu" +
      "mentOperation.Component.ElementStart\022\023\n\013" +
      "element_end\030\004 \001(\010\022\031\n\021retain_item_count\030\005" +
      " \001(\005\022\031\n\021delete_characters\030\006 \001(\t\022Z\n\024delet" +
      "e_element_start\030\007 \001(\0132<.federation.Proto" +
      "colDocumentOperation.Component.ElementSt" +
      "art\022\032\n\022delete_element_end\030\010 \001(\010\022]\n\022repla" +
      "ce_attributes\030\t \001(\0132A.federation.Protoco",
      "lDocumentOperation.Component.ReplaceAttr" +
      "ibutes\022[\n\021update_attributes\030\n \001(\0132@.fede" +
      "ration.ProtocolDocumentOperation.Compone" +
      "nt.UpdateAttributes\032*\n\014KeyValuePair\022\013\n\003k" +
      "ey\030\001 \002(\t\022\r\n\005value\030\002 \002(\t\032C\n\016KeyValueUpdat" +
      "e\022\013\n\003key\030\001 \002(\t\022\021\n\told_value\030\002 \001(\t\022\021\n\tnew" +
      "_value\030\003 \001(\t\032m\n\014ElementStart\022\014\n\004type\030\001 \002" +
      "(\t\022O\n\tattribute\030\002 \003(\0132<.federation.Proto" +
      "colDocumentOperation.Component.KeyValueP" +
      "air\032\314\001\n\021ReplaceAttributes\022\r\n\005empty\030\001 \001(\010",
      "\022S\n\rold_attribute\030\002 \003(\0132<.federation.Pro" +
      "tocolDocumentOperation.Component.KeyValu" +
      "ePair\022S\n\rnew_attribute\030\003 \003(\0132<.federatio" +
      "n.ProtocolDocumentOperation.Component.Ke" +
      "yValuePair\032{\n\020UpdateAttributes\022\r\n\005empty\030" +
      "\001 \001(\010\022X\n\020attribute_update\030\002 \003(\0132>.federa" +
      "tion.ProtocolDocumentOperation.Component" +
      ".KeyValueUpdate\032\200\001\n\022AnnotationBoundary\022\r" +
      "\n\005empty\030\001 \001(\010\022\013\n\003end\030\002 \003(\t\022N\n\006change\030\003 \003" +
      "(\0132>.federation.ProtocolDocumentOperatio",
      "n.Component.KeyValueUpdate\"\344\001\n\033ProtocolA" +
      "ppliedWaveletDelta\022>\n\025signed_original_de" +
      "lta\030\001 \002(\0132\037.federation.ProtocolSignedDel" +
      "ta\022D\n\031hashed_version_applied_at\030\002 \001(\0132!." +
      "federation.ProtocolHashedVersion\022\032\n\022oper" +
      "ations_applied\030\003 \002(\005\022#\n\025application_time" +
      "stamp\030\004 \002(\003B\004\200\265\030\001\"V\n\023ProtocolSignedDelta" +
      "\022\r\n\005delta\030\001 \002(\014\0220\n\tsignature\030\002 \003(\0132\035.fed" +
      "eration.ProtocolSignature\"\262\001\n\021ProtocolSi" +
      "gnature\022\027\n\017signature_bytes\030\001 \002(\014\022\021\n\tsign",
      "er_id\030\002 \002(\014\022M\n\023signature_algorithm\030\003 \002(\016" +
      "20.federation.ProtocolSignature.Signatur" +
      "eAlgorithm\"\"\n\022SignatureAlgorithm\022\014\n\010SHA1" +
      "_RSA\020\001\"\250\001\n\022ProtocolSignerInfo\022D\n\016hash_al" +
      "gorithm\030\001 \002(\0162,.federation.ProtocolSigne" +
      "rInfo.HashAlgorithm\022\016\n\006domain\030\002 \002(\t\022\023\n\013c" +
      "ertificate\030\003 \003(\014\"\'\n\rHashAlgorithm\022\n\n\006SHA" +
      "256\020\001\022\n\n\006SHA512\020\002B)\n org.waveprotocol.wa" +
      "ve.federationB\005Proto"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_federation_ProtocolWaveletDelta_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_federation_ProtocolWaveletDelta_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_federation_ProtocolWaveletDelta_descriptor,
              new java.lang.String[] { "HashedVersion", "Author", "Operation", "AddressPath", });
          internal_static_federation_ProtocolHashedVersion_descriptor =
            getDescriptor().getMessageTypes().get(1);
          internal_static_federation_ProtocolHashedVersion_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_federation_ProtocolHashedVersion_descriptor,
              new java.lang.String[] { "Version", "HistoryHash", });
          internal_static_federation_ProtocolWaveletOperation_descriptor =
            getDescriptor().getMessageTypes().get(2);
          internal_static_federation_ProtocolWaveletOperation_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_federation_ProtocolWaveletOperation_descriptor,
              new java.lang.String[] { "AddParticipant", "RemoveParticipant", "MutateDocument", "NoOp", });
          internal_static_federation_ProtocolWaveletOperation_MutateDocument_descriptor =
            internal_static_federation_ProtocolWaveletOperation_descriptor.getNestedTypes().get(0);
          internal_static_federation_ProtocolWaveletOperation_MutateDocument_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_federation_ProtocolWaveletOperation_MutateDocument_descriptor,
              new java.lang.String[] { "DocumentId", "DocumentOperation", });
          internal_static_federation_ProtocolDocumentOperation_descriptor =
            getDescriptor().getMessageTypes().get(3);
          internal_static_federation_ProtocolDocumentOperation_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_federation_ProtocolDocumentOperation_descriptor,
              new java.lang.String[] { "Component", });
          internal_static_federation_ProtocolDocumentOperation_Component_descriptor =
            internal_static_federation_ProtocolDocumentOperation_descriptor.getNestedTypes().get(0);
          internal_static_federation_ProtocolDocumentOperation_Component_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_federation_ProtocolDocumentOperation_Component_descriptor,
              new java.lang.String[] { "AnnotationBoundary", "Characters", "ElementStart", "ElementEnd", "RetainItemCount", "DeleteCharacters", "DeleteElementStart", "DeleteElementEnd", "ReplaceAttributes", "UpdateAttributes", });
          internal_static_federation_ProtocolDocumentOperation_Component_KeyValuePair_descriptor =
            internal_static_federation_ProtocolDocumentOperation_Component_descriptor.getNestedTypes().get(0);
          internal_static_federation_ProtocolDocumentOperation_Component_KeyValuePair_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_federation_ProtocolDocumentOperation_Component_KeyValuePair_descriptor,
              new java.lang.String[] { "Key", "Value", });
          internal_static_federation_ProtocolDocumentOperation_Component_KeyValueUpdate_descriptor =
            internal_static_federation_ProtocolDocumentOperation_Component_descriptor.getNestedTypes().get(1);
          internal_static_federation_ProtocolDocumentOperation_Component_KeyValueUpdate_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_federation_ProtocolDocumentOperation_Component_KeyValueUpdate_descriptor,
              new java.lang.String[] { "Key", "OldValue", "NewValue", });
          internal_static_federation_ProtocolDocumentOperation_Component_ElementStart_descriptor =
            internal_static_federation_ProtocolDocumentOperation_Component_descriptor.getNestedTypes().get(2);
          internal_static_federation_ProtocolDocumentOperation_Component_ElementStart_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_federation_ProtocolDocumentOperation_Component_ElementStart_descriptor,
              new java.lang.String[] { "Type", "Attribute", });
          internal_static_federation_ProtocolDocumentOperation_Component_ReplaceAttributes_descriptor =
            internal_static_federation_ProtocolDocumentOperation_Component_descriptor.getNestedTypes().get(3);
          internal_static_federation_ProtocolDocumentOperation_Component_ReplaceAttributes_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_federation_ProtocolDocumentOperation_Component_ReplaceAttributes_descriptor,
              new java.lang.String[] { "Empty", "OldAttribute", "NewAttribute", });
          internal_static_federation_ProtocolDocumentOperation_Component_UpdateAttributes_descriptor =
            internal_static_federation_ProtocolDocumentOperation_Component_descriptor.getNestedTypes().get(4);
          internal_static_federation_ProtocolDocumentOperation_Component_UpdateAttributes_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_federation_ProtocolDocumentOperation_Component_UpdateAttributes_descriptor,
              new java.lang.String[] { "Empty", "AttributeUpdate", });
          internal_static_federation_ProtocolDocumentOperation_Component_AnnotationBoundary_descriptor =
            internal_static_federation_ProtocolDocumentOperation_Component_descriptor.getNestedTypes().get(5);
          internal_static_federation_ProtocolDocumentOperation_Component_AnnotationBoundary_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_federation_ProtocolDocumentOperation_Component_AnnotationBoundary_descriptor,
              new java.lang.String[] { "Empty", "End", "Change", });
          internal_static_federation_ProtocolAppliedWaveletDelta_descriptor =
            getDescriptor().getMessageTypes().get(4);
          internal_static_federation_ProtocolAppliedWaveletDelta_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_federation_ProtocolAppliedWaveletDelta_descriptor,
              new java.lang.String[] { "SignedOriginalDelta", "HashedVersionAppliedAt", "OperationsApplied", "ApplicationTimestamp", });
          internal_static_federation_ProtocolSignedDelta_descriptor =
            getDescriptor().getMessageTypes().get(5);
          internal_static_federation_ProtocolSignedDelta_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_federation_ProtocolSignedDelta_descriptor,
              new java.lang.String[] { "Delta", "Signature", });
          internal_static_federation_ProtocolSignature_descriptor =
            getDescriptor().getMessageTypes().get(6);
          internal_static_federation_ProtocolSignature_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_federation_ProtocolSignature_descriptor,
              new java.lang.String[] { "SignatureBytes", "SignerId", "SignatureAlgorithm", });
          internal_static_federation_ProtocolSignerInfo_descriptor =
            getDescriptor().getMessageTypes().get(7);
          internal_static_federation_ProtocolSignerInfo_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_federation_ProtocolSignerInfo_descriptor,
              new java.lang.String[] { "HashAlgorithm", "Domain", "Certificate", });
          com.google.protobuf.ExtensionRegistry registry =
            com.google.protobuf.ExtensionRegistry.newInstance();
          registry.add(org.waveprotocol.protobuf.Extensions.int52);
          registry.add(org.waveprotocol.protobuf.Extensions.int52);
          return registry;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
          org.waveprotocol.protobuf.Extensions.getDescriptor(),
        }, assigner);
  }

  // @@protoc_insertion_point(outer_class_scope)
}
